			Java Electric change log ( MAIN branch )

NOTE: Please place changes under the version that will be released next.

************************* Version 9.07-a: ******************************

************************* END OF Version 9.06, GNU RELEASE *************
************************* Version 9.06-z: ******************************

BUG: (6/4/15, GVG) NPE while arraying busses (Bug #7043)
FIX: Detecting if valid objects are selected.

BUG: (6/4/15, SMR) SOG doesn't use 2X contacts properly (Bug #7039).
FIX: Better tests to detect 2X.

BUG: (6/3/15, GVG) SoG: only generated pcell names should be used if 
SOGCONTACTSUSEEXISTINGSUBCELLS is on (Bug #7026)
FIX: Added SOGCONTACTSFORCESUBCELLS condition in the right place now

BUG: (6/3/15, DN) Scala code doesn't compile with Java1.8 (Bug #6992)
FIX: Val in for syntax fixed - using Scala 2.11 as of now

BUG: (6/2/15, GVG) SoG: only generated pcell names should be used if 
SOGCONTACTSUSEEXISTINGSUBCELLS is on (Bug #7026)
FIX: Added SOGCONTACTSFORCESUBCELLS

BUG: (6/2/15, SMR) SOG min area code still bad (Bug #7025).
FIX: Min area gridded, better examined, rejected if out of bounds.

BUG: (6/2/15, GVG) DRC Import errors feature failed with latest format (Bug #7035)
FIX: Skipping CL lines now

BUG: (6/1/15, GVG) SoG: IndexOutOfBoundsException after min area changes (Bug #7034)
FIX: Another consideration when the list to analyze has only 2 points in same metal

BUG: (6/1/15, GVG) SoG: Still min area issues (Bug #7025)
FIX: Detecting if new extra geometry for MinArea goes beyonds boundary.
Attempt to fix min area condition for tapers.

IMP: (5/26/15, GVG) SoG: use new name convention to write GDS with
pcell information (Bug #7013)
FIX: Adding via spacing values.

BUG: (5/26/15, GVG) GDS Export: references to cell names should be controlled by 
IOTool.getGDSCellNameLenMax() (Bug #7022)
FIX: Controlled by localPrefs.cellNameLenMax

BUG: (5/26/15, GVG) SoG: NPE in standalone if top cell is null (Bug #7021)
FIX: Just detecting the null case

IMP: (5/22/15, GVG) SoG: connection by name request (Bug #7001)
Available in standalone tool as well.

IMP: (5/22/15, GVG) SoG: use new name convention to write GDS with 
pcell information (Bug #7013)
FIX: New cell name format for pcells

IMP: (5/21/15, SMR) DEF import now has preference to connect by name from GDS (Bug #7001).

IMP: (5/20/15, GVG) Getting access to latest DRC tool from special menu.

************************* Version 9.06-y: ******************************

BUG: (5/20/15, GVG) SoG: IllegalArgumentException: exportUsages while using new 
code for pin replacement (Bug #6977)
FIX: Last fix in PinCheckerEnumerator done by Dima. Turning USE_BATCH_PIN_REPLACEMENT on.

BUG: (5/19/15, SMR) SOG needs to connect to all exports with a given name (Bug #7001).
FIX: GDS import preserves export names.

BUG: (5/19/15, GVG) SoG: IllegalArgumentException: exportUsages while using new 
code for pin replacement (Bug #6977)
FIX: Adding debugging code for Dima - no fix yet

BUG: (5/19/15, SMR) SOG min area calculation leaves notches (Bug #7011).
FIX: Better min area width calculation.

BUG: (5/18/15, GVG) Java8 and mismatches in regression results (Bug #5827)
FIX: Fix in DRC to better consider DRC rules associated to wide layers
FIX: Fixing Spice/DXF data

************************* Version 9.06-x: ******************************

BUG: (5/14/15, SMR) SOG tapers should not happen when width is normal (Bug #7003).
FIX: Now allow any length taper if width is unchanged.

BUG: (5/13/15, SMR) SOG grid line debugging uses wrong color (Bug #6999).
FIX: Compute color properly.

BUG: (5/13/15, SMR) SOG has confusing error message (Bug #6995).
FIX: Better explanation given.

IMP: (5/12/15, GVG) Get rid of UnsatisfiedLinkError in Java3D is not available (Bug #6997)

IMP (5/12/15, SMR) SOG router now has multiple options for contact placement (Bug #6965).

BUG: (5/12/15, SMR) Scala code in SOG is failing to compile (Bug #6992).
FIX: Use pure Java.

IMP: (5/11/15, GVG) Reduce spacing rule associated with via7 in 40nm tech (Bug #6993) 

BUG: (5/11/15, SMR) SOG doesn't fill in minimum area (Bug #6960).
FIX: Better minimum area computation.

IMP: (5/11/15, GVG) SoG: Adding more logging information in standalone version (Bug #6991)

BUG: (5/11/15, SMR) SOG uses wrong track (Bug #6987).
FIX: Fixed boundary condition on track assignment.

************************* Version 9.06-w: ******************************

IMP: (5/7/15, GVG) SoG: change in length of one x via metal (Bug #6985)
M3 length in x-M3M4 was changed

BUG: (5/7/15, GVG) Undoing "SoG: via pcells are not available in results from 
standalone version (Bug #6965)" due to Bug #6969

BUG: (5/7/15, SMR) SOG reports two errors when fails and retrys (Bug #6897).
FIX: Remove earlier message when rerouting.

IMP: (5/6/15, GVG) Electric min source/target is Java 1.7 (Bug #6981)

BUG: (5/6/15, SMR) SOG results different in Java 8 (Bug #6968).
FIX: Store SearchVertices in TreeMap instead of HashMap.

BUG: (5/6/15, SMR) SOG debugging crashes (Bug #6980).
FIX: Ignore null search vertices.

BUG: (5/5/15. GVG) SOG: NPE in BatchChanges$NodeReplacement (Bug #6976)
FIX: Passing the NodoProto function

BUG: (5/5/15, SMR) SOG runs wires in disallowed directions (Bug #6963).
FIX: Destination rectangle properly updated when contact to disallowed layers inserted.

BUG: (5/4/15, GVG) Java8 and mismatches in IO regression results (Bug #5827)
FIX: First change in DXF IO output.

BUG: (4/30/15, GVG) SoG: via pcells are not available in results from standalone version (Bug #6965)
FIX: Flag enabled by default now

BUG: (4/30/15, DN) SoG: AssertionError in router if useSubcellsForContacts is on (Bug #6966).
FIX: Implement combination of useSubcellsForContacts and resultCellName!=null.

************************* Version 9.06-v: ******************************

IMP: (4/29/15, GVG) New layer in 40nm tech (Bug #6962)

BUG: (4/29/15, SMR) SOG tapers not being honored (Bug #6961).
FIX: Compute arc width properly when placing finished route.

BUG: (4/29/15, SMR) Interactive router connects layers wrong (Bug #6956).
FIX: Improved fix to Bug #6940.

BUG: (4/29/15, SMR) SOG crashes when route ends are off-grid (Bug #6957).
FIX: Colors need to be adjusted.

BUG: (4/28/15, SMR) Interactive router fails to connect layers (Bug #6940).
FIX: In VerticalRoute.specifyRoute(), choose options with valid ports first.

IMP: (4/28/15, GVG) SoG: hide unknown host exception when machine does use DHCP (Bug #6955)

BUG: (4/27/15, GVG) Error in Clipboard: 'Font transform has NaN position (Bug #6941)
FIX: Adding the exception to the list associated to MacOSX case. This is an known issue.

BUG: (4/26/15, SMR) SOG fails when disallowed layer moves contact close to goal (Bug #6948).
FIX: Must recompute jump bounds when moving to allowed layers.

BUG: (4/24/15, GVG) SOG: standalone tool - statistics file has zero size (Bug #6939)
FIX: Setup printerStream variable.

IMP: (4/24/15, GVG) New pattern values for new layer (Bug #6937) 

BUG: (4/24/15, GVG) Confusing rotation warning (Bug #6947)
FIX: Added angle condition != 0

************************* Version 9.06-u: ******************************

BUG:(4/23/15, SMR) SOG router finds circuitous paths (Bug #6888).
FIX: Use careful floating-point comparisons when determining legal DRC distances.

IMP: (4/22/15, GVG) Add new layer to latest smallest tech used internally (Bug #6937) 

BUG: (4/21/15, DN) EDIF import: clarify issues with current regression (Bug #6863)
FIX: Netlist.portConnected compares port names instead of port protos.

BUG: (4/21/15, DN) UTFDataFormatException in Routing regression test2 (Bug #6913)
FIX: Implementations of UserInterface.PrintMessage split long messages into smaller pieces.

IMP: (4/21/15, GVG) EDIF: Export regression missing (Bug #6862)
Releasing EDIF regression now that Bug #6934 is fixed.

BUG: (4/21/15, GVG) EDIF output - non-deterministic results (Bug #6934)
FIX: Comparators added. Regression file doesn't contain time stamp.

IMP: (4/21/15, GVG) EDIF: Export regression missing (Bug #6862)
First attempt until Bug#6934 is fixed

BUG: (4/21/15, GVG) EDIF import: clarify issues with current regression (Bug #6863)
FIX: Added extra warning text for Test5. <borderWidth> in Test1 is not supported.

BUG: (4/20/15, GVG) EDIF export: missing rename for single wire (Bug #6866)
FIX: Fix 4-port transistor reference. Problem not over though.

BUG: (4/20/15, GVG) Export EDIF: can't read SPICE property written by Electric (Bug #6861)
FIX: New condition for KeyProperty.checkValidArrayDescription()

BUG: (4/20/15, GVG) EDIF input and Cadence compatibility (Bug #6932)
FIX: Use stripPercentEscapes() in KeyString now

BUG: (4/20/15, GVG) EvalSpice$ParseException: Invalid token: doesn't 
longer recognize 47u as 47 microns (Bug #6921)
FIX: TextUtils.equalsTo() changed to allow comparison when strings have same length.

BUG: (4/17/15, GVG) Invalid EDIF output of SUE_info variable (Bug #6922)
FIX: Special treatment for vars that are arrays.

************************* Version 9.06-t: ******************************

BUG: (4/16/15, GVG) UTFDataFormatException in Routing regression test2 (Bug #6913)
FIX: Patching BucketInstance.toString() since combination of writeBytes()/writeInt() doesn't work

BUG: (4/16/15, GVG) SOG metrics crash (Bug #6915)
FIX: Extra code to detect nets with less than 2 vertices

BUG: (4/16/15, SMR) SOG places contacts to disallowed layers badly (Bug #6905).
FIX: Make sure contact is connected to endpoint.

IMP: (4/15/15, GVG) SoG: new vias statistics (Bug #6907)

IMP: (4/15/15, SMR) SOG now handles minimum area rules (Bug #6878).

************************* Version 9.06-s: ******************************

BUG: (4/14/15, SMR) SOG uses taper widths on non-taper wires (Bug #6902).
FIX: Ensure metal layer is correct.

BUG: (4/14/15, GVG) SoG: different results - GUI v/s standalone (Bug #6899)
Putting the default GUI value.

IMP: (4/13/15, GVG) SOG: new HPWL calculation (Bug #6898)

IMP: (4/13/15, GVG) SoG: rerun failed routes should be on in standalone version (Bug #6896)
On now.

BUG: (4/9/15, SMR) SOG contacts are too big when connected to tapers (Bug #6881).
FIX: Shrink contacts when connected to tapers.

IMP: (4/9/15, GVG) SOG: min area consideration (Bug #6878)
Amended min area values in technology file

IMP: (4/9/15, GVG) Allow {} brackets when defining LayerRule in XML tech (Bug #6891)

************************* Version 9.06-r: ******************************

BUG: (4/8/15, GVG) SOG: increase of # of vias in test5 (Bug #6865)
FIX: Calculate avg vias per segment, not per net.

IMP: (4/8/15, GVG) SoG: add new wire length statistic requested by user (Bug #6886)
Better output format + adding the net names in debug mode.

IMP: (4/7/15, GVG) SoG: add new wire length statistic requested by user (Bug #6886)

BUG: (4/7/15, GVG) SoG: Circuitous routing still observed in 9.06-q (Bug #6885)
Standalone SoG 9.06q not properly installed.

BUG: (4/7/15, SMR) SoG: ContactInclusion2X upload in dialog not working (Bug #6880)
FIX: Allow SOG cell properties to import properly

BUG: (4/7/15, SMR) Spice suffix "M" is ambiguous (Bug #6505).
FIX: Allow "M" or "MEG" to be Mega, "m" to be milli.

BUG: (4/6/15, GVG) MacOSX case: closing the last window should quit the app (Bug #6877) 
FIX: Don't treat MacOSX differently than Linux

BUG: (4/3/15, GVG) EDIF: does this format support MYMX as orientation? (Bug #6872)
FIX: Added option

BUG: (4/2/15, GVG) EDIF import: assertion while reading file with multiple libraries (Bug #6864)
FIX: Reference cell must be stored in proper library hash bucket.

************************* Version 9.06-q: ******************************

BUG: (4/2/15, SMR) SOG does circuitous routes (Bug #6851).
FIX: Diagonal spacing distance computation improved.

BUG: (4/1/15, GVG) Missing commentGraphics/annotate in export EDIF (Bug #6858)
FIX: Added those two nested blocks

IMP: (4/1/15, GVG) Compare cell tool should store missing parts when level == 3 (Bug #6857)
No writing cells in the compareResult library if no polygon is found.

BUG: (4/1/15, SMR) SOG doesn't handle different X and Y spacing rules (Bug #6850).
FIX: Use both rules if they exist.

BUG: (3/31/15, GVG) SoG: end2end spacing violation in same net (Bug #6850)
FIX: Fix in getMaxSurround() function

BUG: (3/31/15, SMR) SOG uses taper after inserting contact to forbidden layer (Bug #6849).
FIX: Ignore tapers after inserting contact.

BUG: (3/30/15, GVG) SOG: mismatch in WL data for two test examples (Bug #6812)
FIX: Remove old calculation since the new one is based on SoGWireQualityMetric

BUG: (3/30/15, GVG) SoG: M4 pin lamdabox wrong (Bug #6852)
FIX: lamdabox definition amended in tech file.

IMP: (3/30/15, GVG) SoG: enable debugging printing in standalone version (Bug #6844) 
Added extra local variable to control it - no intention to pass it as command option for now.

BUG: (3/30/15, SMR) SOG Cell properties dialog is too big (Bug #6848).
FIX: Made it smaller.

BUG: (3/27/15, GVG) SoG: GUI version giving different results as standalone (Bug #6843)
FIX: Override values stored in cell not properly retrieved. Bug introduced with (Bug #6826).

IMP: (3/26/15, SMR) SOG now uses 2X contacts more often (Bug #6727)

IMP: (3/25/15, GVG) SoG: Complete traverse of geometry if pins are not on track in 
pin swamp function (Bug #6840)

************************* Version 9.06-p: ******************************

BUG: (3/25/15, SMR) SOG doesn't use proper widths (taper and override) (Bug #6817).
FIX: Use proper override and taper pin size.

IMP: (3/24/15, SMR) Added experimental Steiner tree code to SOG (Bug #6838).

BUG: (3/24/15, SMR) Missing contact color error message is confusing (Bug #6836).
FIX: Have better error message.

IMP: (3/19/15, GVG) Add end2end spacing values (Bug #6826)
All changes in now. Layer spacing only for primary direction.

BUG: (3/19/15, GVG) SOG: assertion catching possible wrong wl/hpwl value (Bug #6829)
FIX: Changed to a warning message.

BUG: (3/18/15, SMR) SOG doesn't consider diagonal design-rule distances (Bug #6818)
FIX: Handle them when computing maximum distance for a run.

IMP: (3/17/15, GVG) SoG: statistics to calculate current wire length compared 
with HPWL (Bug #6822)

BUG: (3/17/15, GVG)  SoG: check end-to-end rules for some metals (Bug #6819)
FIX: some spacing rules were changed and therefore 2 benchmarks were affected.
This change doesn't solve the end2end issue yet.

BUG: (3/16/15, SMR) Via layers are excluded from "Pure" component menu popup (Bug #6816).
FIX: Now allow them.

IMP: (3/13/15, GVG) SoG: results using given pcells (Bug #6802)
Making this option available for standalone version

************************* Version 9.06-o: ******************************

BUG: (3/13/15, GVG) SoG: some metal values wrong after rotation (Bug #6811)
FIX: Metal 4 values modified on 3/6/2015. No bug in the code btw.

IMP: (3/13/15, GVG/SMR) SoG: Enable rectangular vias (Bug #6720)
Modifications done in SoG declared as done.

IMP: (3/13/15, SMR) SOG handles 2X wires (Bug #6727).
Declaring it as implemented.

IMP: (3/11/15, GVG) SoG: enable extra pin color search by default (Bug #6807)

BUG: (3/10/15, SMR) SOG router not handling taper layer directive right (Bug #6803).
FIX: Handle it right.

************************* Version 9.06-n: ******************************

IMP: (3/5/15, GVG) SOG can choose to ignore already-routed nets (Bug #6785).
Enabling in the standalone version as well via a flag.

IMP: (3/5/15, SMR) SOG can choose to ignore already-routed nets (Bug #6785).

BUG: (3/5/15, SMR) SOG doesn't handle via spacing right (Bug #6788).
FIX: Saving rectangular vias, computing distance right.

BUG: (3/4/15, GVG) SoG: NPE while reading configuration file for older tech (Bug #6791)
FIX: Detect the null messages structure

BUG: (3/3/15, SMR) Antenna check loops infinitely (Bug #6787).
FIX: Handle connections to transistor bias ports.

IMP: (3/2/15, GVG) SoG: spine routing should be on by default in standalone version (Bug #6784)
Adding entry in Bugzilla to remember when value was switched.

IMP: (3/2/15, GVG) SoG: enabling average routing quality value (Bug #6783)

IMP: (3/2/15, SMR) SOG now handles new routefile parameters (Bug #6773)
Now handles AllowViaUp and AllowViaDown

IMP: (2/26/15, SMR) SOG now handles new routefile parameters (Bug #6773).

BUG: (2/25/15, GVG) SoG: results can't be read back without errors (Bug #6771)
FIX: Tech file amended - some x-contacts had masked colors swapped

IMP: (2/25/15, SMR) SOG detects routes that already exist in the circuit (Bug #6740).

IMP: (2/23/15, GVG) Difficulties to reset wrong max memory allocated (Bug #6757) 

BUG: (2/16/15, SMR) Antenna Rules preferences crashes when technology changes (Bug #6752).
FIX: Update technology properly.

BUG: (2/12/15, GVG) No registering users in case of using -logusage (Bug #6741)
FIX: Must close FileHandler after format is called.

IMP: (2/10/15, SMR) SOG handles 2X wires (Bug #6727).

************************* Version 9.06-m: ******************************

IMP: (2/9/15, GVG) SoG: report time spent on checking pin (Bug #6725)

IMP: (2/6/15, GVG) SoG: Enable rectangular vias (Bug #6720)
First set of changes

IMP: (2/5/15, GVG) SoG: standalone - leave exhaustive pin search as optional only (Bug #6716)
Only the standard along has access to the exhaustive mode.

IMP: (2/5/15, GVG) SoG: standalone version should check pins after DEF import (Bug #6713)
Default is after as of now. Use pinCheckingFirst to switch to previous order.

BUG: (2/5/15, SMR) Launcher uses wrong memory parameters (Bug #6692).
FIX: Use proper memory/permgen values, explain relaunching in manual.

IMP: (2/5/15, SMR) Spice prefs now have max chars per line (Bug #6693).

BUG: (2/4/15, SMR) SOG fails on simple route (Bug #6710).
FIX: Better floating point comparison.

BUG: (2/4/15, GVG) SoG: NPE in standalone if no access to logging path (Bug #6709)
FIX: Detect the NPE due to no access

BUG: (2/3/15, GVG) Telesis: simple ports missing if they belong to net whose name 
includes multiple subnets (Bug #6704)
FIX: Keep track of ports already visited.

BUG: (2/3/15, SMR) SOG needs to place contacts more intelligently (Bug #6699).
FIX: When shifting to unblocked layer, move contact close to destination.

BUG: (2/2/15, SMR) SoG gives spurious warnings about track usage (Bug #6698).
FIX: Make sure warnings are valid.

BUG: (2/2/15, GVG) SoG: pin checker in standalone not working properly for M3 (Bug #6700)
FIX: Correct detection of metal orientation

BUG: (1/29/15, GVG) Telesis: mismatching due to lower/upper cases (Bug #6691)
FIX: Making extractRealPortName not case sensitive

************************* Version 9.06-l: ******************************

BUG: (1/29/15, SMR) SOG router doesn't use proper size contacts (Bug #6687)
FIX: Contacts now right for overridden arc sizes.

IMP: (1/28/15, GVG) Allow logging for regular application (Bug #6688)

IMP: (1/28/15, GVG) SoG: make routing bound layer available from conf file (Bug #6686)

IMP: (1/27/15, SMR) Now have SOG cell property to set routing limit layer (Bug #6667).

BUG: (1/26/15, GVG) Telesis: can't parse correctly double nested definitions (Bug #6683)
FIX: Extended code to deal with 1 nested case.

BUG: (1/23/15, GVG) Telesis: not parsing correctly single signal with nested array (Bug #6670)
FIX: Make sure that it is an array when descending/ascending the local count.

IMP: (1/23/15, GVG) SoG: logging system for standalone version (Bug #6661)
Handles now multiple sessions accessing the same log file.

************************* Version 9.06-k: ******************************

IMP: (1/22/15, GVG) SoG: logging system for standalone version (Bug #6661)
Another location for internal + version added.

BUG: (1/22/15, GVG) SoG: standalone version not honoring metal orientation (Bug #6666) 
FIX: Honor value read from SoG Config file

BUG: (1/22/15, GVG) SoG: Track information might be cached wrong for rotated examples (Bug #6664) 
FIX: Correct coordinate caching.

IMP: (1/21/15, GVG) SoG: logging system for standalone version (Bug #6661)

BUG: (1/16/15, GVG) IndexOutOfBoundsException in Telesis (Bug #6653) 
FIX: Better detection of single signal like A[0] in enterCell()

************************* Version 9.06-j: ******************************

IMP: (1/14/15, GVG) SoG: parameters parse should handle multiple white spaces (Bug #6650).

IMP: (1/14/15, SMR) SOG cell properties now handles blockages (Bug #6641).

IMP: (1/14/15, GVG) SoG: ability to expand space search end bounds from GUI (Bug #6649).

IMP: (1/13/15, GVG) LEF: similar to GDS, LEF reader should allow to handle unknown layers (Bug #6586).
Two more preferences added.

BUG: (1/13/15, SMR) User's manual incorrectly describes location of LIBDIRS file (Bug #6637).
FIX: Updated manual.

BUG: (1/13/15, SMR) User's manual describes text descriptor anchors wrong (Bug #6636).
FIX: Updated manual.

BUG: (1/13/15, SMR) JELIB output doesn't handle strings with square brackets (Bug #6622).
FIX: JELIB output now quotes strings with square brackets. Manual updated.

BUG: (1/12/15, GVG) SoG: remove new "accessed from null" after GDS output option was added (Bug #6645).
FIX: Use factory values in case of SoG

IMP: (1/8/15, GVG) SoG: standalone tool - ability to control output files (Bug #6635).

BUG: (1/7/15, GVG) SoG: still generates arc with wrong mark (Bug #6632).
FIX: Offending metal color not properly stored

BUG: (1/7/15, GVG) SoG: router generating multiple arcs with same name (Bug #6629).
FIX: Setting netname to null while creating arcs in createRoute().

BUG: (1/6/15, GVG) EXCEPTION: can save but not reload annotation starts with square bracket '[' (Bug #6622).
FIX: Detecting if there is a closing bracket to consider it as array

************************* Version 9.06-i: ******************************

BUG: (1/5/15, GVG) ArrayIndexOutOfBoundsException while reading track info (Bug #6626)
FIX: Detects if there are missing Tvalues.

IMP: (1/2/15, SMR) SOG router now examines both wavefronts for common points (Bug #6621).

IMP: (12/23/14, SMR) SOG router now checks track colors (Bug #6609).

BUG: (12/22/14, SMR) SOG makes nonmanhattan arcs (Bug #6607).
FIX: Handle endpoints when adding contacts to get to allowed metal layers.

BUG: (12/19/14, GVG) Wrong center warning when the center is in the same place? (Bug #6602)
FIX: Use DBMath.areEquals() for comparisons

BUG: (12/19/14, GVG) SoG: investigate export size mismatch (Bug #6600) 
FIX: Fixed pin sizes in technology file.

IMP/MAN: (12/12/14, GVG) XML technology: allow definition of multiple layers 
with same width and spacing rules (Bug #6434) 

IMP: (12/12/14, GVG) SoG: Store track info for metals that don't offer 
colored versions (Bug #6576) 

************************* Version 9.06-h: ******************************

BUG: (12/11/14, SMR) SOG Router issues (Bug #6571)
FIX: Made various improvements.

BUG: (12/9/14, SMR) SOG router doesn't get right color when adding contacts (Bug #6568).
FIX: Now computes color properly.

BUG: (12/9/14, SMR) Select All shows nondisplayable text (Bug #6566).
FIX: Check for nondisplayable text in EditMenu.doSelection().

IMP: (12/9/14, GVG) Ability to replace pins which should not be used - 
use SoG track information instead (Bug #6564)
Second implementation.

IMP: (12/8/14, GVG) Ability to replace pins which should not be used - 
use SoG track information instead (Bug #6564)
First implementation.

BUG: (12/8/14, GVG) Intermittent concurrent issue while replacing pins (Bug #6501)
FIX: Avoid replacements inside enumerator (see #6559)

BUG: (12/8/14, GVG) IllegalArgumentException while replacing NodeProto in 
NodeInst pin (Bug #6559)
FIX: Detecting if node is linked.

BUG: (12/5/14, GVG) IllegalArgumentException while replacing NodeProto in 
NodeInst pin (Bug #6559)
FIX: Just new code so Dima can debug it = no fix yet

BUG: (12/2/14, GVG) Telesis: wrong sequence of indices in case of
2-d buses (Bug #6485) 
FIX: Swap two loops grabbing data from single array.

BUG: (12/2/14, GVG) Telesis problem (Bug #6466)
FIX: Adding all allegro_pins for a given port regardless whether is a bus or not.

BUG: (12/2/14, SMR) SOG router should put contacts on grid (Bug #6554).
FIX: Now adjusts locations.

BUG: (12/1/14, SMR) DEF import doesn't handle duplicate exports right (Bug #6551).
FIX: Alter node to match DEF information.

BUG: (12/1/14, SMR) Need to use proper units everywhere (Bug #6550).
FIX: Fixed Icon and Grid preferences, Node and Arc info dialogs.

BUG: (12/1/14, SMR) SOG router lets big pins block routing (Bug #6549).
FIX: Do not put pins into blockage data.

************************* Version 9.06-g: ******************************

IMP: (11/25/14, SMR) SOG improvements (Bug #6541) 

BUG: (11/18/14, GVG) ArrayIndexOutOfBoundsException in Telesis (Bug #6530)
FIX: Detect if variable is an array.

IMP: (11/17/14, GVG) Adding CM1 in the latest technology.

IMP: (11/13/14, SMR) SOG router now handles metal removal layers (Bug #6522).

BUG: (11/10/14, SMR) SOG router gives warnings about gridding (Bug #6502).
FIX: Now sort and remove duplicate grid elements.

************************* Version 9.06-f: ******************************

BUG: (11/4/14, SMR) SOG router crashes with multicolored layers (Bug #6492)
FIX: Handle color values properly.

BUG: (10/24/14, GVG) Telesis problem (Bug #6466) 
FIX: Special condition for non-bus networks

IMP: (10/23/14, SMR) SOG cell data now knows the mask color associated with each track (Bug #6369).

BUG: (10/16/14, SMR) SOG debugging doesn't report mask inconsistencies (Bug #6469)
FIX: Now report problem.

BUG: (10/16/14, SMR) DEF import fails to assign masks right (Bug #6467).
FIX: New Technology method to find the correct arc.

BUG: (10/16/14, GVG) NPE in LEF import (Bug #6468) 
FIX: Detect when mask in null (at least during regression)

BUG: (10/15/14, GVG) DEF can't create a node (Bug #6467)
FIX: DEF code has trouble to match layer functions and arcs for masked layers

BUG: (10/14/14, SMR) PNG regression may crash (Bug #5828).
FIX: Fixed missing technologies in display data.

IMP: (10/2/14, GVG) Need uniform way to identify layers with multiple masks (Bug #6445)
Added functionality

IMP: (10/2/14, GVG) Make sure Job.getPreferences() is used to get EditPreferences (Bug #6447)
Original code that generated the exception fixed.

IMP: (10/1/14, SMR) Now have multiple mask colors for the metal layers (Bug #6445).

************************* Version 9.06-e: ******************************

BUG: (10/1/14, AM) GDS array bisection needs to use fixed point coordinates (Bug #6410).
FIX: Implemented patch.

BUG: (9/30/14, SMR) SoG router loses names of lines it fails to route (Bug #6431)
FIX: Restore names when routes fail.

IMP: (9/26/14, GVG) SoG: extend import parse to assign values to colored 
layers as well (Bug #6438). No applying to "TRACK" yet.

IMP: (9/25/14, GVG) Ability to replace pins which should not be used (Bug #6436)
Making code available via Async menu

IMP: (9/24/14, GVG) DEF: make available in GUI ignore vias block option (Bug #6433)

IMP: (9/24/14, GVG) SoG: not allow to upload non-existing nets via GUI (Bug #6432)

BUG: (9/24/14, SMR) Node "Get Info" dialog sometimes moves nodes improperly (Bug #6386).
FIX: Use proper technology.

BUG: (9/24/14, DN) DELIB writer leaves litter on the disk (patch to fix attached)  (Bug #6398).
FIX: Apply Adam's patch to io.output.DELIB.

BUG: (9/23/14, DN) Classloader issues in Job serialization (patch attached) (Bug #6413).
FIX: Apply Adam's patch to EJob.

IMP: (9/23/14, GVG) DEF: ability to ignore the VIAS section (Bug #6429)

IMP: (9/23/14, GVG) SoG: bus support in routing data import (Bug #6428)

BUG: (9/23/14, DN) Massive corruption if cell names differ only in capitalization (Bug #6362).
FIX: "Library has not cell names which differ only by case" is a database invariant.
     The fix is disabled by flag Snapshot.CELLNAMES_IGNORE_CASE .

************************* Version 9.06-d: ******************************

BUG: (9/18/14, GVG) Should primitivePort be mandatory in primitiveNode? (Bug #6417) 
FIX: Adding condition to Technology.xsd

BUG: (9/17/14, GVG) Should primitivePort be mandatory in primitiveNode? (Bug #6417) 
FIX: Catching the error in ArcProto for now.

BUG: (9/17/14, SMR) SOG router crashes with multi-mask situations (Bug #6406).
FIX: Better analysis.

BUG: (9/17/14, AM) NCC annotation "ExportsToIgnore" needs an underscore (Bug #6412).
FIX: Added it.

IMP: (9/16/14, GVG) Ability to transform non-colored metal pins into colored ones (Bug #6407) 
Added to the standalone tool. Can't be done while reading GDS.

BUG: (9/16/14, GVG) DEF import ignores Mask information (Bug #6370).
FIX: Clean mask variable once information is used

BUG: (9/16/14, AM) Need "Save As..." context menu in explorer (Bug #6399).
FIX: Added it.
 
BUG: (9/16/14, SMR) DEF import doesn't handle RECTs in NETs (Bug #6405).
FIX: Handle RECTs properly.

IMP: (9/12/14, GVG) CDL and "/" before instance names: ability to turn on/off the special character (Bug #6389) 
Added as Spice/CDL option.

BUG: (9/11/14, SMR) Cell expansion saving may throw an exception (Bug #6376).
FIX: Ignore expansion saving when cell name is too long.

BUG: (9/11/14, AM) Schematic DRC misses some port size matches (Bug #6379).
FIX: Patched code.

BUG: (9/10/14, SMR) SOG router needs to handle multiple masks (Bug #6369).
FIX: First pass at extensions.

BUG: (9/8/14, GVG) NPE: XML Tech reader doesn't detect invalid layer in arcs (Bug #6383) 
FIX: Preventing the NPE. XML reader checks possible invalid layers in arcs.

BUG: (9/8/14, AM) 270-degree-rotated mirrored nodes can have negative angles (Bug #6377).
FIX: Ensure positive values.

BUG: (9/5/14, GVG) DEF import ignores Mask information (Bug #6370).
FIX: Mask # can be defined before layer name.

BUG: (9/4/14, GVG) SOG: NPE while importing preferences (Bug# 6374) 
FIX: Detect if arc is actually found.

BUG: (9/4/14, GVG) SoG: Preferences dialog doesn't recognize more than 1 layer with the same layer function (Bug# 6373) 
FIX: Checking name match as well

BUG: (9/3/14, SMR) DEF import ignores Mask information (Bug #6370).
FIX: Handle MASK for distinguishing metal layers.

************************* Version 9.06-c: ******************************

BUG: (8/26/14, SMR) Merging only allowed for DEF (Bug #6348).
FIX: Disallow that option for all other formats.

BUG: (8/25/14, GVG) java.lang.OutOfMemoryError: can't create offscreen surface on macosx (Bug #6341) 
FIX: Limit max size by getting values from screen

BUG: (8/25/14, SMR) GDS cannot merge (Bug #6348).
FIX: Disallow that option when importing GDS.

BUG: (8/22/14, GVG) GDS cannot read BOXes with BOXTYPE in them (Bug #6349).
FIX: BOXTYPE element treated as Shape element

BUG: (8/22/14, SMR) GDS cannot read BOXes with BOXTYPE in them (Bug #6349).
FIX: Ignore BOXTYPE field.

BUG: (8/21/14, GVG) TEST ioReadGen FAILED (Bug #6237)
FIX: Reference data in test code was not up to date

BUG: (8/20/14, SMR) DEF import may complain about improper contacts (Bug #6346).
FIX: Handle improper contacts properly.

BUG: (8/20/14, SMR) SOG router throws assertion when connecting to prohibited layers (Bug #6336).
FIX: Fixed createRoute() method to insert contacts properly.

BUG: (8/19/14, GVG) SoG: automatic update of layer status if layer is marked/unmarked as "avoid (Bug #6335)
FIX: Added redrawArcOverridesList() to preventClicked()

IMP: (8/19/14, GVG) Telesis: replace @ by _ in net names, using correctTelesisName now (Bug #6343)

BUG: (8/19/14, SMR) DEF overwrites VIA cells (Bug #6337).
FIX: Ignore existing cells redefined by DEF VIAs.

BUG: (8/18/14, SMR) ActionListener fails for Check Boxes in SOG Cell Properties (Bug #6335).
FIX: Trying ItemListener instead.

BUG: (8/18/14, GVG) More fixes for (Bug #6257). Code should match indices where
not range is found 

BUG: (8/15/14, GVG) Telesis output throws exception when data is bad (Bug #6257) 
FIX: Major changes in code that matches network ports with instance ports

BUG: (8/15/14, GVG) SoG: assertion in SeaOfGatesCellBuilder$MyShapeBuilder (Bug #6336)
FIX: Temporary return in standalone tool - no real fix

IMP: (8/15/14, SMR) SOG router should be able to handle prohibited layers better (Bug #6334)
FIX: If layer is disallowed, can insert contact under some circumstances.

BUG: (8/14/14, GVG) Telesis output throws exception when data is bad (Bug #6257) 
FIX: New algorithm to compose the port elements associated to a net.

IMP: (8/12/14, GVG) SoG: get warnings in ErrorLogger to facilitate debugging (Bug #6315)

************************* Version 9.06-b: ******************************

BUG: (8/12/14, GVG) SOG: inclusion pattern not working as expected (Bug #6313)
FIX: Regular expression standalone tool forces "X-" as first characters.

BUG: (8/11/14, SMR) DEF import throws assertions (Bug #6312).
FIX: Print more informative error messages.

BUG: (8/5/14, AM) Panning can be erratic (Bug #6302).
FIX: Patched EditWindow.panXOrY()

IMP: (8/5/14, AM) GDS import now uses hierarchy to instantiate arrays (Bug #6294).

BUG: (7/23/14, AM) "Wire Up One Level" from diffusion crashes (Bug #6275)
FIX: Fix it.

BUG: (7/27/14, AM) Multi-layer exports are written to only one GDS layer, randomly chosen. (Bug #6274)
FIX: Write pin text to all layers an export connects to.

BUG: (8/4/14, SMR) SOG router flags vias that are exactly spaced (Bug #6293).
FIX: Check for precise distance before flagging.

BUG: (7/31/14, GVG) DEF: wrong assignment of specialwidth (Bug #6286)
FIX: Not assigning value if specialwidth is zero 

IMP: (7/31/14, GVG) XML tech parser should complain that default#ofMetals is not between rage defined (Bug #6278) 

IMP: (7/31/14, GVG) SOG standard alone: setup GDS import with ignore option for unknown layers (Bug #6248) 

BUG: (7/23/14, AM) Electric throws away partially-read simulation data when encountering premature EOF (Bug #6268)
FIX: Warn user, but show waveforms anyways.

BUG: (7/29/14, GVG) DEF: wrong assignment of specialwidth (Bug #6286)
FIX: Reset width after every +

IMP: (7/29/14, GVG) SoG: setup dialog should not complain about no selected arc (Bug #6285)
FIX: Call techChange() before getCurrentlySelectedArc() during dialog initialization

BUG: (7/29/14, SMR) SOG router still does off-grid layout (Bug #6283).
FIX: Contacts near destination must still be on-grid.

BUG: (7/29/14, SMR) GDS output writes incompatible export characteristics (Bug #6273).
FIX: Made export characteristic writing a Setting.

BUG: (7/24/14, AM) Electric spends 95% of its rendering time asking the OS for font metrics (Bug #6266)
FIX: Use a SoftReference cache for GlyphVectors

BUG: (7/24/14, AM) Electric SPICE parser chokes on multiple spaces between .subckt parameter names (Bug #6265)
FIX: Use regexp " +" instead of " "

BUG: (7/24/14, AM) Electric should handle gzipped simulation output transparently (Bug #6264)
FIX: Handle it.

BUG: (7/28/14, GVG) More NPEs in SoG if XML tech is not well defined (Bug #6279) 
FIX: Catch those null elements.

BUG: (7/28/14, GVG) NPE in SoG if no all metals are defined (Bug #6277)
FIX: Skip metals with no information

BUG: (7/28/14, SMR) DEF import should handle MASK keyword in PIN LAYER statement (Bug #6247)
FIX: Ignores more MASK statements.

BUG: (7/23/14, AM) Electric complains about negative-dimension multicutbox boundaries (Bug #6262)
FIX: Do not complain.

BUG: (7/23/14, AM) "Expand all" requires exponential time instead of linear time (Bug #6261)
FIX: Traverse the hierarchical design ONCE, then update visibilities.

BUG: (7/23/14, SMR) SOG Router still makes short circuits (Bug #6258).
FIX: Fixed blockage generator optimizer.

BUG: (7/23/14, SMR) Telesis export fails (Bug #6257).
FIX: Changed assertions to proper error handling.

BUG: (7/21/14, SMR) DEF import should handle MASK keyword in PIN LAYER statement (Bug #6247)
FIX: Now ignores MASK.

BUG: (7/16/14, GVG) SoG standalone: figure out what to do to set the units differently in this mode assertion while calculating quality metrics (Bug #6238)
FIX: Method StandAlone.initPrefs has a parameter with a map of non-factory prefs .

************************* Version 9.06-a: ******************************

BUG: (7/16/14, GVG) SoG standalone: assertion while calculating quality metrics (Bug #6242)
FIX: Assertion due to unrouted arc - do not calculate metrics if cell was extracted.

BUG: (7/16/14, SMR) SoG needs to give numbers in the desired units (Bug #6239).
FIX: Changed "formatDouble()" calls to "formatDistance()".

IMP: (7/15/14, GVG) SoG: output data in Units setup by user (Bug #6239)
FIX: First changes in checkGridValidity

BUG: (7/15/14, GVG) Bug 6222 - Number of non-cap transistors wrong 
FIX: Base port in 4-port transistor is now defined as "IN"

BUG: (7/15/14, GVG) Number of non-cap transistors wrong (Bug #6222)
FIX: Adding the new calculation for non-cap (no forcing gnd/vdd condition).

IMP: (7/15/14, GVG) SoG: add the "Route may fail" messages to the ErrorLogger (Bug #6236)

BUG: (7/14/14, GVG) GDS is writing out too many layers (Bug #6226)
FIX: text/export are not written if main layer is not visible. 

IMP: (7/10/14, GVG) Improve reporting on errors in XML tech files (Bug #6220)

IMP: (7/9/14, GVG) Make quality metrics available from the GUI (Bug #6215)

IMP: (7/9/14, GVG) SoG standalone - ability to export quality metrics (Bug #6216)

BUG: (7/7/14, GVG) ErrorLogger should work on current EDatabase (Bug #6211)
FIX: Use EDatabase.currentDatabase() instead

IMP: (7/7/14, GVG) SoG standalone - ability to have access to errors for further analysis (Bug #6210)
Stop creating lines for non-Manhattan geometries if they are more than 100.

BUG: (7/7/14, GVG) NPE in SoG control dialog after adding some grid info (Bug #6208)
FIX: Detecting the not-found-arc case now

BUG: (7/7/14, GVG) Electric doesn't check if cell is being used when deleting it in a group (Bug #6207)
FIX: DeleteCellGroup must check if cells are in used.

BUG: (7/1/14, SMR) Right-click when two arcs are selected wires them wrong (Bug #6138).
FIX: Handle nonmanhattan situation right.

IMP: (7/1/14, SMR) Node "Get Info" dialog can now "See" selected ports (Bug #6196).

BUG: (7/1/14, SMR) "Select Object" dialog crashes on reg-exps (Bug #6195).
FIX: Added "Regular expression" checkbox.

IMP: (6/30/14, GVG) SoG: add metric calculations (Bug #6193)

BUG: (6/30/14, SMR) SOG router doesn't handle complex geometry (Bug #6187).
FIX: Handle complex Manhattan polygons in connectivity extraction.

BUG: (6/30/14, SMR) Unicode not handled right (Bug #6189).
FIX: Implemented patch from GNU user to use OutputStreamWriter.

************************* END OF Version 9.05, GNU RELEASE *************
************************* Version 9.05-r: ******************************

BUG: (6/25/14, SMR) Waveform window doesn't handle signals in time axis (Bug #6182).
FIX: Fixed display and dragging in waveform windows.

IMP: (6/23/14, GVG) Undoing Bug #6161 "Continue the reading process when 
cellnames are duplicated"

IMP: (6/23/14, SMR) Sea of Gates router handles X and Y spacing rules (Bug #6174).

BUG: (6/19/14, DN)  Instance name doesn't move (Bug #6146)
FIX: In CircuitChangJobs.moveSelectedText replace small dX, dY by 0.25.
     It is minimal granularity of TextDescriptor text offset.

BUG: (6/19/14, GVG) Character "/" should not be allowed for cell/group names in 
DELIB format (Bug #6159)
FIX: Don't allow "/" in library and cell names

BUG: (6/19/14, GVG) Assertion while saving General Cell Lists,  part of Cell info 
functionality (Bug #6165)
FIX: Filename cached before the celllists job starts.

IMP: (6/17/14, GVG) Continue the reading process when cellnames are duplicated - 
ignore second version (Bug #6161)

BUG: (6/17/14, SMR) Must convert to longs for large database coordinates (Bug #6156).
FIX: Fixed VectorCache and Highlighting.

BUG: (6/17/14, DN) Large coordinates in DEF and unable to create unrouted arc (Bug #3848)
FIX: Part of the fix - provide correct values to new EPointlong in EPoint.fromGrid().

IMP: (6/17/14, DN) Hide method Topology.getArcAutoname that became public after Bug #6114 

IMP: (6/16/14, GVG) Better catch of owner timed out while copying using clipboard (Bug #6147)

IMP: (6/16/14, GVG) Don't stop change job if one element in list has already 
changed (Bug #6145) 

BUG: (6/16/14, GVG) Change dialog doesn't set properly current selection (Bug #6144)
FIX: Assign currentlySelected accordingly in Change:reload() 

IMP: (6/16/14, GVG) Better warning messaging when Layout Text can't be generated (Bug #6143)

BUG: (6/12/14, GVG) DEF after GDS: still conflicts with duplicate net names (Bug #6136)
FIX: Use name only when they are not special nets

BUG: (6/11/14, GVG) DEF after GDS: still conflicts with duplicate net names (Bug #6136)
FIX: Check first if arc with conflict name already exists.

BUG: (6/11/14, SMR) Spice/CDL uses obsolete "ignore resistors" options (Bug #6135).
FIX: Switch to using network tool preference for that.

BUG: (6/10/14, GVG) Spice with CDL misses some convert brackets tasks (Bug #6133)
FIX: Spice:getPortName() was not sanitized in case of a non-bus + global treatment

BUG: (6/10/14, SMR) Verilog export has minor issues (Bug #6066).
FIX: Implemented patch from GNU user.

BUG: (6/9/14, GVG) Out of range for lineList: ErrorLogger (Bug #6131)
FIX: Fixed index access.

************************* Version 9.05-q: ******************************

IMP: (6/4/14, GVG) DEF: better detection of existing networks already available 
to avoid using the same name (Bug #6106). More changes to avoid arcs with 
same names.

BUG: (6/3/14, SMR) SOG takes too long to preprocess (Bug #6122).
FIX: Ignoring pin geometry in blockage calculation.

BUG: (6/2/14, SMR) DEF import cannot handle POLYGON Nets (Bug #6107).
FIX: Now handle them.

IMP: (6/2/14, GVG) SoG: consider HorizontalMetals and VerticalMetals as input values 
in control setup (Bug #6111) 

BUG: (6/2/14, GVG) SoG: IndexOutOfBoundsException in ErrorLogger (Bug #6119) 
FIX: Detecting the case.

BUG: (6/2/14, SMR) SOG cell properties dialog should warn when net names are unknown (Bug #6108).
FIX: Now warns during import and when adding individual nets.

BUG: (5/30/14, GVG) DEF: cells might be set with the current technology available in TechPalette (Bug #6115) 
FIX: Set the technology after cell is read in

IMP: (5/30/14, GVG) DEF: if instance already defined, assign name provided in DEF file (Bug #6114) 

IMP: (5/30/14, GVG) DEF: should support COVER option for COMPONENTS (Bug #6113) 

IMP: (5/29/14, GVG) DEF: better detection of existing networks already available 
to avoid using the same name (Bug #6106) 

IMP: (5/29/14, GVG) SoG: standalone mode needs a mechanism to show progress (Bug #6103) 

IMP: (5/29/14, GVG) SoG standalone - ability to control spine option (Bug #6104) 

IMP: (5/29/14, GVG) Add HSPICE Calibre option (Bug #6102)

BUG: (5/29/14, SMR) SOG cell properties needs multiple-select ability (Bug $6101).
FIX: Now handles multiple selection.

BUG: (5/28/14, SMR) SOG router reports inconsistent length data (Bug #6099).
FIX: Calculate length as segments are planned.

BUG: (5/28/14, SMR) Need smarter spine detection and handling in SOG router (Bug #6097).
FIX: Now handle areas with extreme height/width ratio.

IMP: (5/27/14, SMR) Added Spice output for Xyce engine (Bug #6094).

BUG: (5/23/14, GVG) NPE in standalone SoG router if tech can't be loaded (Bug #6089)
FIX: detect the case

IMP: (5/23/14, GVG) Ability to rerun failed nets with new limit value in standalone 
SoG router (Bug #6088)

IMP: (5/22/14, SMR) SOG Router now does spine routing (Bug #6085).

IMP: (5/22/14, GVG) Ability to abort display of a large list of items in Select Object dialog (Bug #6084)
Ask user if display operation should continue if number of items > 1000 (arbitrary number).

BUG: (5/20/14, SMR) SOG router fails because of internal null value (Bug #6070).
FIX: Catch null case and handle it.

IMP: (5/19/14, GVG) SoG Import file to setup contact inclusion and metal orientation (Bug #6080) 
Keywords HorizontalEven and ContactInclusion available now

BUG: (5/19/14, SMR) Display of text with linefeeds is inaccurate (Bug #6079)
FIX: GNU user patched ExecDialog.java

************************* Version 9.05-p: ******************************

BUG: (5/14/14, GVG) Verilog not writing cells with template when "No empty cell" option is on (Bug #6066) 
FIX: Detect properly when cell has a Verilog template to avoid rejecting it if option is on.

BUG: (5/14/14, GVG) SoG properties importer should convert <> to [] (Bug #6065) 
FIX: Convert net names

BUG: (5/14/14, SMR) NGSpice output doesn't display right in waveform window (Bug #6064).
FIX: Fixed endian problems (fix submitted by Holger Wachtler).

BUG: (5/13/14) EDIF: Electric should create an open polygon with information included here (Bug #5944) 
FIX: Use open-polygon art node for these definitions

IMP: (5/12/14, GVG) Better message when text size is not valid in EDIF (Bug #6057) 

BUG: (5/12/14, GVG) EDIF ignores (orientation R90) (Bug #5943) 
FIX: Made value available when Exports/Annotation objects are created.

BUG: (5/9/14, GVG) EDIF writer ignores angle for annotations (Bug 6053) 
FIX: Analyze rotation associated with TextDescriptor

BUG: (5/9/14, GVG) Electric can't import own exported EDIF (Bug 6050) 
FIX: Making sure Exporter doesn't write empty GDS values

IMP: (5/9/14, GVG) Detection of invalid integer definition in EDIF - adding # for comments (Bug #6052)
Adding detection of ")" or empty string. Added # for comments.

BUG: (5/7/14, GVG) NPE in transforming from one tech to another (Bug #6049) 
FIX: Detecting if directory is hidden

IMP: (5/6/14, GVG) SoG: give preference to list of arcs to route than values from file (Bug #6046) 

BUG: (5/6/14, SMR) SOG router must adjust contact widths for wider arcs (Bug #6043).
FIX: Now generates oversize contacts.

IMP: (5/6/14, GVG) Assertion in case no layer with rules are found while DRC'ing layout (Bug #6037)
Replacing assertion by warning message in Debug mode 

IMP: (5/5/14, GVG) New X contact for top layer and AP (Bug #6044) 

IMP: (5/5/14, SMR) Using SOG cell properties (Bug #6034).

BUG: (5/2/14, GVG) Assertion in case no layer with rules are found while DRC'ing layout (Bug #6037)
FIX: Better warning message for now. Adding DRC rules to AP layer in latest tech (see Bug #6036)

IMP: Redefine contact12 layer in latest private tech as ART (Bug #6036) 

IMP: (5/1/14, SMR) Improved SOG cell properties (Bug #6034).

IMP: (4/29/14, GVG) Improve technology converter for internal usage (Bug #6018)

IMP: (4/29/14, GVG) Skip hidden files in DELIB (Bug #6017) 
Using File.isHidden() function

IMP: (4/29/14, GVG) NPE in JELIB parser (Bug #6016)
Catching it as error now.

************************* Version 9.05-o: ******************************

IMP: (4/28/14, SMR) Improved messages in the sea-of-gates debugger (Bug #6013).

IMP: (4/24/14, GVG) SoG standalone tool: ability to accept only certain primitives (Bug #6006) 

BUG: (4/24/14, SMR) Undo operates differently in text windows, confuses the user (Bug #5978).
FIX: Have TextWindow.undo() and redo() give more descriptive errors.

BUG: (4/23/14, GVG) Component Menu doesn't display proper NodeProto function from Popup group (Bug #6002) 
FIX: Use the function name for the selection

BUG: (4/22/14, GVG) SoG reports zero length of routed wires (Bug #5980) 
FIX: Catching length value before clearing resolution structures

BUG: (4/22/14, GVG) Contact size in VerticalRoute.buildRoute() should consider contact rotation (Bug #5999) 
FIX: Detect 90/180 rotation and adapt contact size. Other values are not considered

IMP: (4/22/14, GVG) Stitch tool should properly compute the rotation of the contact nodes (Bug #5998)
Using $horizontal to take the decision.

BUG: (4/22/14, AM) NCC exportsToIgnore does not work on parts of bus exports (Bug #5591).
FIX: Added Adam's patch to tool/ncc/netlist/NccNetlist.getExportsAndGlobals()

BUG: (4/22/14, AM) NCC exportsToIgnore are not applied to globals (Bug #5413).
FIX: Added Adam's patch to tool/ncc/netlist/NccNetlist.getExportsAndGlobals()

BUG: (4/22/14, SMR) GDS preference "Collapse VDD/GND pin names" should be in Export (Bug #5997).
FIX: Moved the preference and enforce that digits must follow the names to be merged.

BUG: (4/21/14, GVG) Unable to change arc layer (Bug #5993) 
FIX: Don't call CircuitChangeJobs.replaceNodeInsts if no node replacements are available

BUG: (4/21/14, SMR) GDS skeletonization import should preserve top-level pins (Bug #5974) 
FIX: Fixed skeletonization to get sizes right (more fixes)

BUG: (4/19/14, GVG) Stitch generation: NPE if bottom layer not found (Bug #5985) 
FIX: Just detect case and abort generation

IMP: (4/18/14, GVG) SoG standalone tool: ability to ignore certain primitives (Bug #5984)
This is not meant to be available via the GUI.

BUG: (4/18/14, GVG) SoG standalone tool not using user's preferences (Bug #5983) 
FIX: Passing structure to SeaOfGatesEngine.routIt now.

BUG: (4/18/14, GVG) NPE in SoG GUI (Bug #5982)
FIX: Detect if no cell is available in GUI. Better not to open a dialog to prevent NPEs.

IMP: (4/17/14, GVG) Better control of scale used while importing technologies from LEF (Bug #5979) 

BUG: (4/16/14, SMR) GDS Skeleton import should preserve exports (Bug #5974).
FIX: Top-level exports are now kept.

BUG: (4/16/14, GVG) Get GDS Export/Import of annotations working (Bug #5973)
FIX: Consistent usage of variables to read text.

IMP: (4/16/14, GVG) Consolidate usage of default text in GDS import/export (Bug #5972)

BUG: (4/16/14, GVG) gdsOutDefaultTextLayerSetting is being used for export pins (Bug #5969)
FIX: Code refactored.

************************* Version 9.05-n: ******************************

BUG: (4/14/14, GVG) GDS Include Text option should be available as valid 
for in/out streams (Bug #5968)
FIX: Moved option to the section valid for import/export (bottom section)

IMP: (4/14/14, GVG) Modify pin and text layers in private tech (Bug #5967)

BUG: (4/10/14, SMR) Verilog output insists on "vdd/gnd" labels (Bug #5946).
FIX: Allow existing net names, favoring "vdd/gnd" if a choice.

IMP: (4/8/14, GVG) Enable commentGraphics in EDIF input (Bug #5941)
First attempt to parse this information

BUG: (4/7/14, GVG) CDL_TEMPLATE_KEY not available from interface (Bug #5939) 
FIX: Made template available under tools -> Simulation(Spice) -> Set CDL

IMP: (4/7/14, GVG) EDIF and multiple pins for the same Export in the icon view (Bug #5935) 
Fixing changes that broke the EDIF 5 regression.

BUG: (4/7/14, SMR) Verilog import fails if referenced cells are not found (Bug #5921).
FIX: Now generates dummy icon cells when none can be found.

IMP: (4/4/14, GVG) EDIF and multiple pins for the same Export in the icon view (Bug #5935)
First set of changes

BUG: (4/3/14, GVG) Remove "OutputBackupRedundancy is accessed from null" (Bug #5933)
FIX: Catch IOTool.getBackupRedundancy() before the standalone tool starts

IMP: (4/3/14, SMR) SOG hor/ver usage can now be forced (Bug #5932).

IMP: (4/2/14, GVG) Make setHorizontalEven available to standalone SoG tool (Bug #5928) 

BUG: (4/2/14, SMR) Verilog reader doesn't handle forward references (Bug #5922).
FIX: Handles it now.

BUG: (4/2/14, SMR) Verilog reader doesn't handle all assign statements (Bug #5920).
FIX: Added some, but still don't handle behavioral verilog.

IMP: (3/31/14, GVG) Verilog reader: allow instantiate submodule before being define (Bug #5922) 
FIX: Adding temp variable to control that. It should be a User preference.

BUG: (3/31/14, SMR) DEF import places cell instances wrong (Bug #5918).
FIX: Make sure lower-left of instance is at DEF coordinate.

BUG: (3/28/14, DN) SOG router should preserve network names (Bug #5906)
FIX: Sort arcc in SeaOfGatesCellBuilder.

BUG: (3/27/14, GVG) ArrayIndexOutOfBoundsException while extracting geometry (Bug #5909)
FIX: Detecting the index==-1 during extraction.

IMP: (3/27/14, GVG) DEF Import should not open another window if cell already exist (Bug #5907) 

************************* Version 9.05-m: ******************************

BUG: (3/15/14, GVG) ArgumentsParser not parsing properly options without argument (Bug 5904) 
FIX: better detection of -1 when no arguments are provided.

IMP: (3/25/14, GVG) Ability to provide more information in case of running in debug mode 
for standalone tool (Bug #5903) 

BUG: (3/25/14, SMR) Zoomed-out text sizes are wrong (Bug #5897).
FIX: Approximate text width when it is less than 1 pixel in height.

IMP: (3/25/14, SMR) DEF import now keeps net names (Bug #5902).

IMP: (3/24/14, GVG) XML tech reader should warm if GDS layer information is overwritten 
by previous definition (Bug #5896)

BUG: (3/24/14, SMR) LEF import reuses pins that are on the wrong layer (Bug #5890).
FIX: In LEF.readPort(), make sure layers are compatible.

BUG: (3/17/14, GVG) ArgumentsParser wrongly detecting "-" if they are part of file path (Bug #5891)
FIX: Detect the first consecutive "-" out of the argument instead of using lastIndex

IMP: (3/14/14, GVG) Better control of LEF reading process in case of "minor" errors in the input (Bug #5885)
First attempt.

IMP: (3/13/14, GVG) Java8 and mismatches in IO regression results (Bug #5827) 
Added class JavaCompatiblity to track changes due to Java8 release.

IMP: (3/10/14, GVG) SoG preferences should include new technologies (Bug #5876) 

BUG: (3/10/14, GVG) NPE in SoG parameters setting (Bug #5874)
FIX: Detect if a cell has been selected.

BUG: (3/6/14, GVG) SoG: NPE if no cell is present (Bug #5866) 
FIX: Detect cases where technology is not loaded yet

BUG: (3/6/14, GVG) Number exception while creating tech from GDS map (Bug #5843)
FIX: Adding better message to determine where the error is.

BUG: (3/5/14, GVG) Don't generate like ",X/Yp" as GDS values (Bug #5844)
FIX: Detecting case where no normal layer is found.

IMP: (3/5/14, GVG) Allow layer type "dummy" as GDSLayerType (Bug #5859)

IMP: (3/2/14, SMR) Improve use of inefficient Network methods (Bug #5841).

BUG: (2/28/14, GVG) NPE while importing LEF to extract tech info (Bug #5837) 
FIX: Detect when tech=null in LEFDEF:getArc()

BUG: (2/28/14, GVG) IllegalStateException after deleting cells and leaving NCC dialog open (Bug #5836)
FIX: Return with null Highlighter if cell is not linked.

************************* Version 9.05-l: ******************************

BUG: (2/25/14, SMR) DEF output can loop badly (Bug #5826).
FIX: Reduced n-squared network problem.

BUG: (2/25/14, GVG) DRC crashes on built-in sample cells library (Bug #5824)
FIX: Detect better mixture of different technologies in the layout cell.

BUG: (2/19/14, GVG) NPE in Gerber import (regression mode) (Bug #5801)
FIX: Detect the null graphics in regression mode.

BUG: (2/18/14, GVG) Cell compare tool not adding mismatches to auxiliary cell (Bug #5797)  
FIX: Put entire algorithm in a Job class - collect mismatches in another PolyMerge.

BUG: (2/16/14, SMR) Gerber import has bugs (Bug #5796).
FIX: Now use curved primitives and now have PixelDrawing handle 2-point polygons.

BUG: (2/14/14, DN) nodes order assertion after SeaOfGatesCellBuilder (Bug #5766) 
FIX: Pull auto-increment out of assertion..

IMP: (2/13/14, GVG) Ensuring valid technology for "FillCellTest still failling" (Bug #3951) 

IMP: (2/13/14, GVG) More functionality to check layout resistors defined in XML tech (Bug #5740) 
Adding the same check in NetCell::internalConnections and NetSchem::internalConnections.

IMP: (2/13/14, GVG) Adding ability to get factory values in SeaOfGates preferences.

BUG: (2/11/14, DN) nodes order assertion after SeaOfGatesCellBuilder (Bug #5766) 
FIX: Use STRING_NUMBER_ORDER.

BUG: (2/10/14, GVG) SoG as standalone doesn't generate same routing as doing it from GUI (Bug #5766) 
Some preferences changes.

BUG: (2/3/14, SMR) LEF and DEF fail to read VIA rules (Bug #5765).
FIX: Now handle rules as well as rectangles.

BUG: (2/3/14, GVG) At least DEF writer should use same metal names rather than 
forcing METAL<level #> (Bug #5720)

IMP: (2/3/14, SMR) Modified the tsmcSun technology to use proper transistor types (Bug #5749).

BUG: (1/30/14, GVG) Verilog should include first wires definition before user-specified 
code that use them (Bug #5758)
FIX: Make sure wire declaration is before includeTypedCode(cell, VERILOG_CODE_KEY

BUG: (1/30/14, SMR) Finding text in selected objects is buggy (Bug #5757).
FIX: Improved "find text" dialog.

IMP: (1/30/14, GVG) Different layer for complex resistor in private technology (Bug #5756)

BUG: (1/29/14, GVG) User Preferences dialog pushed back if layer 
color change involves multiple layers (Bug #5753)
FIX: Don't pass cell EditWindow to JOptionPane.

IMP: (1/29/14, SMR) LEF export now understands 2-level hierarchy (Bug #5720)

BUG: (1/28/14, GVG) Color reset in layers doesn't work (Bug #5739)
FIX: Force the closing of the preferences dialog (avoid in-place code)

BUG: (1/28/14, SMR) NCC doesn't recognize all transistor types (Bug #5749).
FIX: Fixed com.sun.electric.tool.ncc.netlist.PrimitiveNameToFunction.java

************************* Version 9.05-k: ******************************

IMP: (1/27/14, GVG) New sophisticated resistor for internal tech (Bug #5741)
More modifications.

BUG: (1/24/14, GVG) Wrong calculation of number of cuts when space is limited (Bug #5742) 
FIX: Added function MultiCutData::getNumCutsAlong()

IMP: (1/24/14, GVG) New sophisticated resistor for internal tech (Bug #5741)

IMP: (1/24/14, GVG) More functionality to check layout resistors defined in XML tech (Bug #5740)
Adding assertions for now. No checking functionality added yet.

IMP: (1/23/14, GVG) Ability to ignore technology information in LEF files (Bug #5734) 

IMP: (1/22/14, SMR) Now have DEF export (Bug #5720).

IMP/MAP: (1/22/14, GVG) Store in ErrorLogger warnings related to non-Manhattan geometries found by SoG (Bug #5731) 

BUG: (1/17/14, GVG) NPE while NCC two schematics (Bug #5723)
FIX: Prepare layout data with default layout tech for technology if input cells are schematics.

IMP: (1/17/14, DN) "database/geometry/bool" is translated from Scala to Java.

IMP: (1/17/14, DN) "Change" command preserves parameters in BatchChanges (Bug #5711).
  BatchChanges are translated from Scala to Java.

IMP: (1/15/14, GVG) Assuming null or empty pattern if <pattern> is not defined in XML tech file (Bug #5635) 

IMP: (1/15/14, SMR) "Change" command has option to preserve parameters (Bug #5711)

BUG: (1/10/14, DN) Undoing "Change" crashes (Bug #5684)
FIX: Don't keep IconNodables in NetSchem. 

IMP: (1/9/14, GVG) Printing layers of selected elements in cell (Bug #5699)
Another option under Cell -> Cell Info was added for selected items.

BUG: (1/9/14, GVG) DRC doesn't notice wide rules at different levels of hierarchy (Bug #5694) 
FIX: Fix bug in getSpacingDistances which didn't compute the largest size of a polygon. Changed getMaxSurround()

BUG: (1/9/14, GVG) StatusBar displays wrong technology with more than 1 EditWindow available (Bug #5698) 
FIX: Get tech from cell if cell is not null. 

BUG: (1/9/14, GVG) NPE in LayerVisibility (Bug #5697)
FIX: No solution yet, just added an extra assertion

************************* Version 9.05-j: ******************************

IMP: (1/8/14, GVG) DEF reader should check whether exports have been ignored due to no location by LEF IO (Bug #5693) 

BUG: (1/6/14, GVG) GDS and visibility layers (Bug #5664)
FIX: Caching layers visibility using another method as new LayerVisibility() can't be used
since it takes values from User preferences.

IMP: (1/6/14, GVG) DEF to use already defined Export if location matches (Bug #5685) 

BUG: (1/6/14, GVG) NPE in fill layout due to serialization problem (Bug #5683) 
FIX: Make TechType:Transistor serializable.

BUG: (1/2/14, SMR) SOG Router blocks ports too much (Bug #5678).
FIX: Add more blockage around ports to keep them clear.

BUG: (12/21/13, DN) More "invalid argument portProto" - continuation of 5388 - while writing Verilog (Bug #5659)
FIX: In Network.getPortList get network by subname, not by port index.

BUG: (12/19/13, GVG) LEF reader doesn't guarantee correct tech selected (Bug #5657) 
FIX: Make sure the proper tech is assigned

IMP: (12/16/13, GVG) DEF should look for existing NodeInsts before creating one (Bug #5651) 

IMP: (12/13/13, GVG) Moving latest reader to proper place.

BUG: (12/11/13, SMR) SOG Router stack-overflows during node extraction (Bug #5638).
FIX: Use arrays instead of the call stack.

BUG: (12/11/13, SMR) SOG Router fails if a contact is missing (Bug #5629).
FIX: Warn the user and ignore layers above the contact.

IMP: (12/10/13, GVG) Transforming <> into [] in GDS Input if cadence compatibility is on (Bug #5637) 

BUG: (12/10/13, GVG) Merge in Cell Import should not depend on library save on disk (Bug #5636) 
FIX: Not forcing a change to ask for the merge.

************************* Version 9.05-i: ******************************

IMP: (12/9/13, SMR) LEF/DEF need option to ignore ungenerated pins (Bug #5630).
FIX: Added preference in DEF, added LEF preferences panel.

IMP: (12/4/13, SMR) New "Routing Exclusion" node in Generic technology
used by SOG router to exclude different layers in the area (Bug #5568).

BUG: (12/4/13, SMR) The cmos90 technology issues errors during startup (Bug #5616).
FIX: Fixed the errors (private technology, so no details are available).

IMP: (12/3/13, SMR) SOG router warns when it finds nonmanhattan geometry (Bug #5568).

BUG: (12/3/13, SMR) SOG router issues R-Tree errors (Bug #5613).
FIX: Fixed SeaOfGatesEngine.Wavefront.createRoute to be thread safe.

BUG: (12/2/13, SMR) ALS waveform regression fails (Bug #5609).
FIX: Fixed regression script and expected results.

BUG: (11/25/13, SMR) LEF import ignores empty PIN statements (Bug #5594).
FIX: Create pins at origin and warn the user.

IMP: (11/22/13, GVG) Increase number of metals in Electric (Bug #5581)
More changes in XSD file as well as Layer.java

BUG: (11/22/13, GVG) Improve LEF reader to skip VIA section properly (Bug #5589) 
FIX: Apply same rule as for VIARULES.

BUG: (11/20/13, SMR) Maze router crashes (Bug #5584).
FIX: In routeNet(), convert ERectangle to Rectangle2D.

IMP: (11/19/13, GVG) Increase number of metals in Electric (Bug #5581)

BUG: (11/19/13, GVG) NPE while importing Tech info from LEF (Bug #5580) 
FIX: Detect if curTech is null

BUG: (11/19/13, SMR) DEF import doesn't handle RECT nets (Bug #5576).
FIX: Handles that and also COMPONENTS with no location.

BUG: (11/18/13, GVG) NPE in LEF import (Bug #5577) 
FIX: Detect when layerWidthsFromLEF is not initialized

BUG: (11/18/13, GVG) NPE reading a particular DEF (Bug #5575)
FIX: Detect the case when lay info is null

BUG: (11/12/13, SMR) Restoring stimuli from disk doesn't show all data (Bug #5551).
FIX: Fixed SimulationTool.restoreStimuli() to call "fillScreen()" when done.

BUG: (11/7/13, SMR) NCC "blackbox" directive prints even with no message (Bug #5538).
FIX: Fixed NccBottomUp.hasBlackBoxAnnotation() to ignore zero-length strings.

BUG: (11/7/13, SMR) Zero-length arcs should use port angle if sensible (Bug #5537).
FIX: ArcInst.newInstanceNoCheck() does this.

IMP: (11/5/13, GVG) Added busyCursor to Network tool to provide info to user
if tool is still working on big design (Bugs #5215 and #5219)

BUG: (11/5/13, SMR) Some technologies have zero port angle ranges (Bug #5529).
FIX: Fixed the Artwork, Schematic, and Bipolar technologies.

************************* Version 9.05-h: ******************************

IMP: (11/4/13, GVG) Adding ability to handle poly resistors with 3 terminals (Bug #5526)

BUG: (10/28/13, SMR) Node GetInfo fails when units are not scalable (Bug #5492).
FIX: Use proper "atof" method when converting back.

BUG: (10/22/13, SMR) Spice output handles cell names that start with digits wrong (Bug #5481).
FIX: Now call "getSafeCellName()" when writing "X" line cell names.

BUG: (10/22/13, SMR) Want to control visibility of simulation probe layer (Bug #5476).
FIX: Now listed in the layers tab of the sidebar.

IMP: (10/21/13, GVG) Ability to read Calibre DESIGNrev files (Bug #5450) 
Stable version. simProbeNode can be defined with outline now

************************* Version 9.05-g: ******************************

BUG: (10/16/13, GVG) NPE while Writing Verilog (Bug #5463)
FIX: Detecting if module exists and return it in parseModule();

IMP: (10/11/13, GVG) Ability to read Calibre DESIGNrev files (Bug #5450) 
Preliminary version.

BUG: (10/1/13, SMR) Preferences fail to save (Bug #5429).
FIX: Enhanced error message to help user figure out solution.

BUG: (10/1/13, SMR) Sea of gates router gives spurious errors (Bug #5428).
FIX: Cleaned up messages.

IMP: (9/26/13, SMR) Place and Route works for Verilog (Bug #3567).

************************* Version 9.05-f: ******************************

IMP: Add two new layers to latest 40nm tech (Bug #5410)

BUG: (9/17/13, SMR) 3D view doesn't draw everything (Bug #5398)
FIX: View3DWindow.View3DEnumerator.enterCell() shouldn't exit on zero-size error.

BUG: (9/17/13, GVG) IllegalArgumentException while building image icons (Bug #5397)
FIX: Detect the case and return null

BUG: (9/12/13, DN) More "invalid argument portProto" (Bug #5388).
FIX: Treat IconNodeInsts specially. 

BUG: (9/12/13, DN) IndexOutOfBoundsException related to invalid argument portProto (Bug #5387).
FIX: Check for IconOfParent.

BUG: (9/5/13, DN)  Invalid argument portProto in basic std libraries here (Bug #5364).
FIX: Simplify NetworkTool.getNetworksOnPort().
     Use Netlist.getNetwork(Nodable no, Name portName) instead of Netlist.getNetwork(Nodable no, PortProto pp, int busIndex).

BUG: (9/4/13, DN) Electric should detect export inconsistencies between icons and schematics (Bug #5331) 
FIX: Minor fix: warning on '<' and '>' in name.

BUG: (8/29/13, DN) ArrayIndexOutOfBoundsException in renaming icon instance (Bug #5330)
FIX: When IconNodeInst is passed as Nodable, NetSchem.getNetMapOffset(Nodable,PortProto,int)
  determines correct Nodable and prints warning in debug mode.

BUG: (8/28/13, GVG) ArrayIndexOutOfBoundsException in renaming icon instance (Bug #5330) 
FIX: Detect out of array in NameImpl::subname()

BUG: (8/22/13, GVG) TimingAnalysisTest failures (Bug #3950) 
FIX: Calling the correct function with TimingAnalysisTest:getFunctionName()

************************* Version 9.05-e: ******************************

IMP: (8/22/13, GVG) Add four new layers to latest 40nm tech (Bug #5317) 

BUG: (8/20/13, GVG) Flat option in GDS output doesn't check GDS:skipLayer() function (Bug #5313) 
FIX: In flat use GDS:skipLayer() in GDS:writeRecursively() as well.

BUG: (8/14/13, GVG) wiringShortcuts not working if the last tech in the palette is not layout (Bug #5298) 
FIX: Use cell.getTechnology in ClickZoomWireListener.wireTo()

BUG: (8/14/13, GVG) Wrong technology when setting visibility in metal layers (Bug #5297) 
FIX: Pass the Tech class to the function.

IMP: (8/14/13, GVG) ICC export and vias (Bug #5275). Special case for array of vias.

************************* Version 9.05-d: ******************************

IMP: (8/8/13, GVG) In case of long subcircuit names, truncate at the beginning in SPICE/CDL (Bug #5290) 
FIX: Characters in the front are removed in Spice:getUniqueCellName()

IMP: (8/7/13, GVG) Name of cdltemplate file should match name provided in dialog box (Bug #5288) 

BUG: (8/6/13, DN) Ability of limit # of highlights in big designs (#Bug 5219)
FIX: NetworkHighlighter don't use Highlighter because it installs itself as DatabaseListener. 

IMP: (8/2/13, GVG) Add warnings with layers that being ignored due to visibility setup (Bug #5276) 
FIX: Added layer warnings in errorLogger structure.

BUG: (8/1/13, SMR) Spice import doesn't handle single files (Bug #5229)
     And it always places after importing (Bug #5270).
FIX: Spice import command is now two different commands:
     "Spice Deck (Single file)" and "Spice Decks (Whole directory)"
     Also, new Spice preference "Use current placement algorithm after reading"

IMP: (7/31/13, GVG) Finish visibility option during GDS Import (Bug #5251)

BUG: (7/29/13, GVG) NPE in DoAllRoutesJob (Bug #5266) 
FIX: Two changes: detect NULL and search network with contains rather than equals

IMP: (7/28/13, SMR) Added "Edit / Arc / Connect Arcs that Cross Named Network..." command (Bug #5264).

IMP: (7/25/13, GVG) Ability to filter layers included in GDS Export by visibility (Bug #5251)
New preference valid for import/export

BUG: (7/24/13, GVG) Can't import Spice decks if folder name contains whitespace (Bug #5241)
FIX: Use TextUtils.decodeString() to guarantee proper treatment of whitespace in folder names.

************************* Version 9.05-c: ******************************

IMP: (7/24/13) Appending library name to Spice cells (Bug #5238)
FIX: Forcing isLibraryNameAlwaysAddedToCellName=true in Spice rather than am user preference.

BUG: (7/23/13, DN) NotSerializableException after undoing Ctrl-C (Bug #5237)
FIX Combined listener WindowFrame.ElectricEventListener. Clean geomList and textList in Clipboard. 

IMP: (7/23/13, GVG) isLibraryNameAlwaysAddedToCellName=true in Spice.
It should be soon controlled by preference.

BUG: (7/23/13, GVG) NPE after importing Spice Decks (Bug #5235)
FIX: Detecting NULL case.

BUG: (7/23/13, GVG) NPE in importing files if folder has space in its name (Bug #5234)
FIX: Detect when File.list() returns null

BUG: (7/22/13, GVG) Can't import Spice deck at all (Bug #5229)
FIX: wholeDirectory=false in FileMenu.importLibraryCommand.

IMP: (7/19/13, DN) Avoid duplication of EditPreferences.workingDirectory and User.getWorkingDirectory().

BUG: (7/19/13, SMR) GDS map export crashes on unknown layers (Bug #5220).
FIX: It is correct to test the result of getGDSValues().

IMP: (7/18/13, GVG) New keyword in Spice for poly resistors (Bug #5222)  
Changed the strings in io.output.Spice.java

************************* Version 9.05-b: ******************************

BUG: (7/17/13, SMR) GDS skeleton import uses too much memory (Bug #5197).
FIX: Optimized GDS import to skeletonize faster and with less memory.

IMP: (7/17/13, DN) Want to change the precision of numbers in netlists (Bug #5140).
FIX: CodeExpression can't cache its spiceText now. Explicit field OutputPreferences.unitsPrecision .

BUG: (7/16/13, DN) New: ArrayIndexOutOfBoundsException in CellRevisionConn (Bug #5212)
FIX: Don't getBuffer in CellRevisionConn.putKilled when node is deleted.  

BUG: (7/16/13, DN) Assertion in makeUnits (Bug #5207)
FIX: EditingPreferences is a thread-local variable.

BUG: (7/16/13, GVG) Extra / in CDL output (Bug #5206) 
FIX: Undoing the change done on 7/15/2013 as extra "/" is also found
in CDL templates (in orange cells).

BUG: (7/15/13, GVG) Extra / in CDL output (Bug #5206) 
FIX: Remove the line in io/output/Spice.java when CDL=true

IMP: (7/15/13, SMR) Want to change the precision of numbers in netlists (Bug #5140).
Another set of changes.

BUG: (7/12/13, GVG) GDS Import function doesn't work with big files (Bug #5196) 
FIX: Don't use getContentLength() since it returns "int". Use getContentType instead.

IMP: (7/12/13, GVG) Better messages when import failed due to invalid size in file (Bug #5195)
Added message explaining the case.

IMP: (7/11/13, GVG) Better location of MemoryInfo in StatusBar (only available in debug mode) (Bug #5190) 
Moved field to the left and added max memory allocated (-Xmx option)

IMP: (7/10/13, GVG) Regression script modified (Bug #5189)

BUG: (6/28/13, GVG) Timeout while importing electricPrefs.xml as projsettings.xml (Bug #4666) 
FIX: Detecting if first line correspond to a Project Preferences file (headers in those files
don't follow XML standard) 

BUG: (6/28/13, GVG) NPE in chooseInputFile - can't import project preferences (Bug #5168)
FIX: Detecting the null case.

************************* Version 9.05-a: ******************************

BUG: (6/27/13, GVG) Order of Spice signals doesn't longer match with values found in old LVS file (Bug #5152)
FIX: Force lexicographical order in private menu controlled by option (see private menu dialog).

IMP: (6/27/13, GVG) Verilog netlist of empty cells (Bug #5150)
Added via User option in Verilog.

IMP: (6/26/13, GVG) First changes for Verilog netlist of empty cells (Bug #5150)

IMP: (6/25/13, SMR/GVG) Want to change the precision of numbers in netlists (Bug #5140).
New User preference in Units section added.

BUG: (6/21/13, SMR) Rotated nodes in menu should be used when changing layers (Bug #5139).
FIX: Fixed VerticalRoute.buildRoute()

************************* END OF Version 9.04, GNU RELEASE *************
************************* Version 9.04-p: ******************************

IMP: (6/19/13, SMR) Added ability to save selections by clicking on
     the selection area of the status bar (Bug #5130).

BUG: (6/18/13, GVG) ReadProjectSettingsFromLibrary' cannot serialize parameter (Bug #5122)
FIX: Not allowing EditPreferences in ReadLibrary Job. Undoing change done for (Bug #3654)

BUG: (6/18/13, SMR) Spice output may write bus notation (Bug #5121).
FIX: Fixed getPortName() so global names do not substitute arrays.

IMP: Added DFTM export for parallel routing (Bug #5120).

IMP: Two new transistors were added to a private tech. Just leaving here
a reference for the need of 9.04-p release.

IMP: (6/13/13, GVG) Renaming Allegro functionality to Telesis since that
is the correct name. See http://www.simplescript.org/FileConverter/ReadMe.txt.
Message to inform when Allegro parameters were not found and cell is skipped.

************************* Version 9.04-o: ******************************

BUG: (6/11/13, SMR) Setting conflicts produce confusing errors (Bug #4595).
FIX: Fixed ProjSettings.readSettings() to make more sense.

BUG: (6/6/13, SMR) Regression accesses icon preferences from job (Bug #2945).
FIX: Use EditingPreferences for icon data.

BUG: (6/6/13, SMR) Reading libraries may access user preferences (Bug #3654).
FIX: Added directory information to EditingPreferences.

BUG: (6/5/13, SMR) Cells with huge text do not fill the screen (Bug #4446).
FIX: Fixed EditWindow.getBoundsInWindow() to always compute text size.

BUG: (6/4/13, SMR) GDS export for external tool interface may fail (Bug #5069).
FIX: Fixed IRDropDialog and SunAsyncMenu to turn flattening off.

BUG: (6/4/13, SMR) Round primitives do not technology-edit right (Bug #5068).
FIX: Fixed LibToTech.calcBaseRectangle() to consider circular layers

BUG: (6/3/13, SMR) Cross-library copy doesn't preserve cell groups (Bug #5064).
FIX: Fixed CellChangeJobs.copyRecursively().

************************* Version 9.04-n: ******************************

BUG: (5/29/13, SMR) Converting schematics to Bipolar crashes (Bug #5055).
FIX: Fixed ViewChanges and Technology.

BUG: (5/29/13, SMR) Long GDS strings may write incorrectly (Bug #4883).
FIX: In output.GDS.outputString(), fix string length calculation.
 
IMP: (5/29/13, SMR) Now have GDS export preference "Flat design" to flatten
     circuit in GDS output (Bug #4970).

BUG: (5/23/13, SMR) Spice output doesn't use global partition names properly (Bug #5044).
FIX: Use global partition name instead of power/ground export name when
     explicitly writing port names in subcircuit headers.

BUG: (5/21/13, SMR) Spice output doesn't always parameterize cell names (Bug #5034).
FIX: In output.Spice.parameterizedName(), change "getDefinedParameters()"
     to "getParameters()".

************************* Version 9.04-m: ******************************

BUG: (5/19/13, GVG) Flattening of L/R mirrored zero length arcs (Bug #5027)
FIX: Detecting cases and not allowing extended tail/head.

IMP: (5/8/13, SMR) Added "curved pin" bit to primitives and use it
     when wiring a bend (Bug #4985).

BUG: (5/8/13, SMR) LEF crashes when layer names are bad (Bug #4984).
FIX: Catch exceptions in LEFDEF.setupPolyLayer().

BUG: (5/7/13, GVG) NPE in ManipulateExports (Bug #4982)
FIX: Detect the null export entry

BUG: (5/7/13, SMR) Extraction fails when there is outline information below (Bug #4981).
FIX: Fixed CellChangeJobs.extractOneLevel() to handle "trace" information properly.

IMP: (5/3/13, GVG) Ability to flat design in GDS IO (Bug #4970).
First changes - no working yet.

BUG: (5/1/13, SMR) Creating a new CVS repository uses wrong extension (Bug #4963).
FIX: Changed tool.project.Project.writeCell() to use the proper extension.

BUG: (4/30/13, GVG) ioReadGen and ioBasic don't run from test menu (Bug #4697) 
FIX: Wrong reference value/directory path.

BUG: (4/30/13, GVG) "." should be considered as invalid character in library name (Bug #4959) 
FIX: Fixed readExternalLibraryFromFilename to not consider characters after "." if they
don't match with FileType extensions.

************************* Version 9.04-l: ******************************

BUG: (4/29/13, GVG) Calling wrong external drc script in full chip DRC for new tech
FIX: Correct script now

BUG: (4/29/13, SMR) CIF roundflashes are written too small and don't read back (Bug #4956).
FIX: In output.CIF.writePoly(), double the radius and
     in input.CIF.outputFlash() create new points for each vertex.

BUG: (4/26/13, SMR) Zero-length arcs don't extract properly (Bug #4940).
FIX: Added orientation to CellChangeJobs.replaceExtractedArcs().

BUG: (4/24/13, SMR) Primitives with ports outside highlighted area select badly (Bug #4936).
FIX: Improved Highlighter.distToNode() to handle these ports.

BUG: (4/24/13, SMR) Extracting rotated cell instances fails (Bug #4933).
FIX: In CellChangeJobs.doArbitraryExtraction() call extractOneLevel()
     with node orientation, not IDENT.

BUG: (4/24/13, SMR) Renaming a cell may ask about cell group changes but ignores the choice (Bug #4893).
FIX: Remove code that offers a choice...there is none.

************************* Version 9.04-k: ******************************

BUG: (4/17/13, GVG) Electric doesn't detect in transistors/diff contacts do have
correct correct set of layers (Bug #4919)

IMP: (4/16/13, GVG) Adding DRC full chip menu to new tech.

BUG: (4/15/13, GVG) SUE still doesn't parse well schematics with parameter definitions. (Bug #4912)
FIX: Making SueConvertsExpressions true by default.

************************* Version 9.04-j: ******************************

IMP: (4/15/13, GVG) Last changes to get RCX working for the new tech.

BUG: (4/12/13, DN) Broken regression: something is wrong with regression launching: unexpected NPE (Bug #4904).
FIX: Disable dummy tech.

BUG: (4/11/13, GVG) Invalid token exceptions for atto and zepto values (Bug #4900)
FIX: Added missing UnitScales. EvalSpice now gets multiplier comparing all defined units.

IMP: (4/10/13, GVG) More changes for Bug #4881. We can't longer do
equalsIgnoreCase() for UnitScale since Mega uses M rather than meg.
Added function UnitScale.equalsTo() to be consistent in TextUtils and 
SpecialProperties.

IMP: (4/9/13, GVG) DRC with no Density and LVS for the new technology

BUG: (4/9/13. GVG) NPE while getting image resources (Bug #4892)
FIX: Creating ImageIcon without URL if resource can't be loaded.

BUG: (4/8/13, SMR) Project preferences do not get reset (Bug #4667).
FIX: Modified all preferences panels with "project" preferences to reset.

IMP: (4/5/13, GVG) UnitScale MEGA: "M" instead of "meg" (Bug #4881).
Making 1M to show as 1M rather than 1000k in Spice mode.

IMP: (4/4/13, GVG) Make PolyMerge serializable to compare layouts (Bug #4879)

BUG: (4/4/13. GVG) EvalSpice parses "1M" as 1 milli*-ohm rather than 1000k (Bug #4878)
FIX: don't use equalsIgnoreCase when evaluating "M" character in EvalSpice.parseNumber().

BUG: (4/3/13, GVG) Not sorting properly layer per GDS values (Bug #4875)
FIX: In LayerSortByGDSIndex.compare, the code was not getting the GDS value.

************************* Version 9.04-i: ******************************

IMP: (4/3/13, GVG) NPE if head/tail nodes can't be found in JELIB library (Bug #4874)
FIX: Detect those cases and stop the reading process.

BUG: (4/2/13, GVG) NPE in layer sorting by GDS value (Bug #4872)
FIX: LayerSortByGDSIndex should consider layers without values.

BUG: (4/2/13, GVG) Set Font in MessagesWindow can't be brought back to original/default value (Bug #4871)
FIX: Setting properly the current font.

BUG: (4/2/13, GVG) Name of resistors and transistors hard-coded (Bug #4870)
FIX: Make PrimitiveNameToFunction to accept primitive node names based on function.

BUG: (4/2/13, GVG) Conversion from TSCM to CLN assumed external libraries are defined 
at the beginning of the file (Bug 4869)
FIX: This is not true for libraries with cells with versions. Extra checking removed.
 
IMP: (4/2/13, DN) Repeat Adam's fix in LayerDrawing.
     Fix rendering of ports on mirrored icons to make it
     consistent with rendering of ports on rotated icons (Bug #4808).

BUG: (4/1/13, GVG) Converting to alternate layout view crashes (Bug #4867)
FIX: Detecting cases when layers are not available in given layout technology.

BUG: (3/28/13, GVG) 3D viewer doesn't handle properly subcells with zero-area nodes inside (Bug #4853)
FIX: getZValues() returns true if a valid layer for 3D drawing was found

BUG: (3/28/13, GVG) Bad 3D transformation while rendering complex device in new technology (Bug #4852)
FIX: Not detecting zero area subcells, causing infinity radious value.
 
IMP: (3/28/13, GVG) "Set M<number" Visible" command should only be valid for layout tech (Bug #4844)
Printing error if number of metals in current tech is less than visibility level.

IMP: (3/28/13, GVG) Using isDefinedParameter() to determine if Units must be disabled or not (Bug #4842).

IMP: (3/27/13, GVG) Should we allow to change unit in parameters associated to icon instances? (Bug #4842) 
Disabling Units pulldown if ni is a NodeInst

IMP: (3/27/13, GVG) Add ErrorLogger to SUE reader (Bug #4843)

BUG: (3/27/13, SMR) "Copy Routing Topology" may fail with busses (Bug #4841).
FIX: Analyze bus names more carefully to get a better match.

BUG: (3/27/13, DN) Can't change Units associated to parameters (Bug #4831)
FIX: Use CellGroup.updateParam(Object newValuem, Unit newUnit).

BUG: (3/26/13, GVG) Class exception if cell is included in "Delete Entire Group" option from Explorer (Bug #4839)
FIX: Don't distinguish anymore btw DeleteGroup and DeleteCell. Use same function deleteCellGroupAction()

BUG: (3/26/13, GVG) NPE when deleting ExplorerTree elements that contain cell groups (Bug #4838)
FIX: Detect the selection of cell groups and treat them differently as cells.

BUG: (3/26/13, SMR) Adding a key binding closes preferences (Bug #4835).
FIX: Do not assign parent window to "add" subwindow.

BUG: (3/25/13, GVG) SUE should add parameters found in Icon section (Bug #4837)
FIX: Detecting default values and adding them as parameters.

BUG: (3/25/13, GVG) SUE reader doesn't properly assign units to capacitance, resistors and inductances (Bug #4836)
FIX: Just detect the Unit properly in the SCHEMATIC_ section.

BUG: (3/22/13, GVG) Can't set show value in the MultiInfo dialog (Bug #4832)
FIX: The "Leave Alone" value for show is -1 rather than 0.

BUG: (3/22/13, GVG) Can't change Units associated to parameters (Bug #4831)
FIX: Delete the parameter before adding it with the new TextDescription.

IMP: (3/21/13, GVG) Allow SUE to look for subcells already defined in other libraries (Bug #4823)

BUG: (3/21/13, SMR) Bicmos and mocmossub technologies give warnings (Bug #4821).
FIX: Added second port to bicmos:Poly1_Poly2_Cap and added metal to
     bicmos:Metal-1-Polysilicon-1-2-Con.

************************* Version 9.04-h: ******************************

IMP: (3/19/13, GVG) Better location of variables defined in SUE reader (Bug #4816).

BUG: (3/19/13, SMR) Should not warn about missing things from "restricted" repository (Bug #4815).
FIX: No longer warn.

IMP: (3/18/13, GVG) SUE: merge lines if they belong to text or label (Bug #4810) 
     Previously was done for text, now adding label.

IMP: (3/18/13, GVG) Add DCVoltage to Pulse element in spiceparts library (Bug #4809)

IMP: (3/16/13, GVG) Fixing net printing as not all ports were reported for busses (Bug 4727)

IMP: (3/13/13, AM) Fix rendering of ports on mirrored icons to make it
     consistent with rendering of ports on rotated icons (Bug #4808).

IMP: (3/13/13, AM) When "Mirror Up <-> Down" and "Mirror Left <-> Right"
     is invoked with only node text selected, cycle through the possible anchors
     instead of doing nothing.  This makes it possible to change text anchors with a
     keystroke (i.e. without the "Node Properties" dialog) and doesn't use up any
     additional keystrokes if the user already has one assigned to the mirroring
     commands (Bug #4807).
 
BUG: (3/11/13, AM) Allow "wire up one level" to work from poly arcs/pins (Bug #4783).
FIX: add else-branch in ClickZoomWireListener

IMP: (3/5/13, GVG) Allegro output available (Bug 4727) - Final changes.

BUG: (3/4/13, GVG) Spice output is supposed to be case insensitive (Bug #4730) 
FIX: SortNetsByName and SortAggregateNetsByName consider Topology.isCaseSensitive() now

BUG: (3/4/13, GVG) STL test failed when all Export tests are run from the test menu (Bug #4731) 
FIX: Taking the technology from the cell to analyze

BUG: (3/1/13, GVG) NPE when running PNG test from menu (Bug #4728) 
FIX: Detecting when context is null in this case.

IMP: (3/1/13, GVG) Allegro output available (Bug #4727) 

IMP: (2/28/13, GVG) suelib* are considered as library directories (_ removed)
Allow to read longer texts that continue in the next lines without + in front. Sue allows that.

IMP: (2/27/13, GVG) LEF output to connect exports if exportsConnectedByParent is 
available (Bug #4723) 

IMP: (2/25/13, GVG) Adding random solid colors to layers when imported from
GDS map file.

BUG: (2/25/13, GVG) ClassCastException in About dialog box (Bug #4719) 
FIX: Don't cast to String, use toString() instead

************************* Version 9.04-g: ******************************

IMP: (2/21/13, GVG) Removing a private technology and reducing number of metals in 
another.

IMP: (2/21/13, GVG) Avoiding printing "null" if techId is not found during
parsing of DELIB header.

BUG: (2/20/13, SMR) Reset of Layer Preferences doesn't work (Bug #4701).
FIX: Fixed LayersTab.java

BUG: (2/18/13, GVG) Can't read DELIB files if path contains spaces (Bug #4696)
FIX: Decode filePath in case of possible encoded spaces.

BUG: (2/18/13, GVG) DELIB write can't handle spaces (Bug #4695)
FIX: Decode filePath in case of possible encoded spaces.

************************* Version 9.04-f: ******************************

BUG: (2/18/13, SMR) Verilog globals netlist wrong (Bug #4689).
FIX: Allow "glbl." in front of names, don't convert to "glbl_".

IMP: (2/15/13, GVG) TechEditor should not write empty GDS values (Bug #4685)

IMP: (2/15/13, GVG) Ability to create a tech XML file from a GDS map file (Bug #4686)
Calling "normal" gds value DRAWING now to be consistent with typical GDS map files.

IMP: (2/15/13, GVG) LEF tech reader (Bug #4684). First changes.
Reader creates layers from file which is considered good enough for now.

BUG: (2/14/13, GVG) NPE when uploading from a non-tech file in private menu (Bug #4682) 
FIX: Set the linereader before setting basic values.

BUG: (2/14/13, SMR) GDS import/export doesn't handle port characteristics (Bug #4681).
FIX: Now read characteristics during import and write them during export.

BUG: (2/14/13, GVG) DFX reader relies on current technology for the non-maincell (Bug #4680)
FIX: Pass Artwork to functions that create the cells.

IMP: (2/14/13, GVG) Extend GDS reader/writer to support new GDS type (Bug #4678)
Reader supports multiple layers with same GDS values. Pick the first now.

IMP: (2/13/13, GVG) Detect if there is collision in hashing function used for 
mapping layers in GDS import (Bug #4677) 

BUG: (2/13/13, GVG) DRC reports wrong results (implant xtors, NMOS) (Bug #4640) 
FIX: Special deal for implant-diffusion interaction in transistors for old tech nmos.

BUG: (2/12/13, GVG) DRC reports wrong results (implant xtors, NMOS) (Bug #4640) 
FIX: Implant transistors had the same error as in bug 4490

IMP: (2/8/13, GVG) GDS export should consider TEXT values if they are available (Bug #4663) 

IMP: (2/8/13, GVG) Extend Technology schema to support new GDS type (Bug #4662) 

BUG: (2/8/13, GVG) Assertion in TechEditoWizard when metal info is null (Bug #4661)
FIX: Return null if the string is empty.

IMP: (2/7/13, GVG) Extend GDS dialog to deal with new types (Bug #4658) 

BUG: (2/7/13, GVG) IndexOutOfBoundsException if less than two layers are defined in fillSeries
FIX: Detecting the case now.

BUG: (2/7/13, GVG) NPE in TechEditor if gds values for metals are not defined (Bug #4657)
FIX: Detecting the absent case.

BUG: (2/7/13, GVG) NPE in TechEditor while accessing GDS info (Bug #4656) 
FIX: Detecting properly the null case (no info case).

IMP: (2/7/13, SMR) Allow other GDSType associated to layers (Bug #4653) 
GUI changes

BUG: (2/6/13, GVG) Silicon Compiler and nondeterministic results in regressions (Bug #4652) 
FIX: SilCompPrefs object is passed as parameter

IMP: (2/6/13, GVG) Allow other GDSType associated to layers (Bug #4653) 
First set of changes.

BUG: (2/6/13, SMR) Routing 45-degree should offer multiple choices for connecting to an arc (Bug #4651).
FIX: Improved InteractiveRouter.getConnectingPoints() to allow other choices.

BUG: (2/6/13, GVG) NPE in external extraction tool (Bug #4650) 
FIX: Detecting if LIBDIRS file has empty lines.

IMP: (2/5/13, SMR) Hard-to-select mode now has a special cursor (Bug #4646).

BUG: (2/4/13, SMR) Force-directed-2 placement algorithm is unstable (Bug #3202).
FIX: Marked it so in the manual, since it is not being developed anymore.

IMP: (2/1/13, GVG) Adding DMYPOLY1 in Technology.xsd. It was left behind
while working on Bug #4588

BUG: (1/31/13, GVG) NPE in LayerDrawing when cell is deleted with Undo command (Bug #4635)
FIX: Detect if cell is not null before starting drawing process

************************* Version 9.04-e: ******************************

BUG: (1/30/13, SMR) Spice output doesn't honor ascending/descending order (Bug #4633).
FIX: Modified base class, Topology.java, to consider original export ascending/descending order.

IMP: (1/29/13, GVG) GDS dialog box should detect if input is not a number (Bug #4630)
Side effect: it won't check types if layer fields are wrong.

IMP: (1/29/13, GVG) Mark with green/red/yellow the matching results in 
Import -> GDS Layer map (Bug #4631). Marking red the mismatches and gray the matches.

IMP: (1/29/13, GVG) Consolidate GDS info in class LayerInfo with GDSLayers (Bug #4361)

IMP: (1/29/13, GVG) Ability to control number of columns defined by TechEditorWizard (Bug #4629)

BUG: (1/29/13, SMR) Preferences test fails if component menu was edited (Bug #4628).
FIX: Added component menu entries to exclusion code.

IMP: (1/29/13, SMR) Created new command: "Cell / Replace Instance with Duplicate Cell"
     to replace the selected cell with a new cell copy (Bug #2105).

BUG: (1/29/13, GVG) XML tech parser doesn't complain about bad GDS layer description (Bug #4360)
FIX: GDSLayers.parseLayerString rewritten to catch those errors.

BUG: (1/28/13, GVG) 9.04c v/s 9.04d: Export GDS/CIF test from the menu (Bug #4592)
FIX: Technology scale will be taken from cell, not from the current technology in the GUI.

IMP: (1/28/13, GVG) Possible to detect error during parsing rather than technology building? (Bug #4573) 

BUG: (1/28/13, GVG) Include Text in GDS io is also used in the export function (Bug #4594)
FIX: "Include Text" option is now outside of the "Import" frame.

IMP: (1/25/13, GVG) Detect wrong layer names during parsing (Bug #4593) 

BUG: (1/25/13, GVG) Misleading error message when there are errors in soft xml tech (Bug #4572)
FIX: Error message amended.

IMP: (1/25/13, GVG) Electric should not include artwork data in GDS if layer with gds=1 
is not included in GDS Map (Bug #4574). GDS=1 is normally associated to well type layer.

IMP: (1/24/13, GVG) Name inconsistencies in ArcProto functions associated to poly arcs (Bug #4588)

BUG: (1/23/13, SMR) Changing cell's technology doesn't update menus (Bug #4587).
FIX: In CellProperties.SetCellOptions.terminateOK(), switch technologies.

BUG: (1/23/13, GVG) ErrorLogger export should properly write character & down in XML (Bug #4585)
FIX: Character added in ErrorLogger:correctXmlString().

BUG: (1/23/13, SMR) Verilog netlisting ignores standard-cell preferences (Bug #4299).
FIX: Removed preference override in Tool menu.

IMP: (1/17/13, SMR) Finished demo of Photonics technology (Bug #4228).

IMP: (1/16/13, GVG) Ability to sort nodes in TechPalette:Pure according to 
same setup used for layers (Bug #4521). Using the same Layer function as in the rest of the code.

BUG: (1/15/13, GVG) Wrong transistor type from transistors series section (Bug #4517)
FIX: Detect function based on prefix

BUG: (1/14/13, GVG) GDS output writing geometry for pins (Bug #4502)
FIX: Regression got fixed to detected the case in the future

BUG: (1/14/13, SMR) Layers from other technologies may appear on top (Bug #4343).
FIX: Draw other technology's layers first so they are lower in opaque stack.
     Also removed inconsistent alpha blending from PixelDrawing.java

************************* Version 9.04-d: ******************************

BUG: (1/10/13, GVG) DRC reports wrong results (connected diff arcs, NMOS) (Bug #4490)
FIX: lambda box associated with electric active regions in transistor amended in nmos.xml

BUG: (1/10/13, GVG) GDS output writing geometry for pins (Bug #4502)
FIX: Detecting pins in GDS.java and skip them for output

BUG: (1/3/13, SMR) Expanding multiple levels can produce incorrect geometry (Bug #4478).
FIX: In CellChangeJobs.extractOneLevel() must carry orientation and track it properly.

IMP: (12/20/12, SMR) Extraction tool capable to deal with more complex contact structures (Bug #4412)

BUG: (12/20/12, SMR) Extraction tool should keep layers that can't extract (Bug #4440) 
FIX: Make sure interconnect layers are ignored while determining arcs to use.

IMP: (12/20/12, GVG) Ignore nodes equals to smallestDotWidth in Layout image import (Bug #4445) 

IMP: (12/19/12, GVG) Allow asymmetric definition of layers in mult_contacts (Bug #4441) 
First changes.

IMP: (12/19/12, GVG) Ability to define extra bits for layers (Bug #4437) 

************************* Version 9.04-c: ******************************

IMP: (12/14/12, DN) Remove field NodeInst.nodeIndex for faster database change.

BUG: (12/13/12, GVG) Assertion in DRC minarea with nmos technology (Bug #4424) 
FIX: Adding DIFF as active layer to consider

IMP: (12/13/12, GVG) Don't safe team if list is empty (Bug #4423)

IMP: (12/13/12, GVG) Alternative way to deal with more complex SizeOff definitions in TechWizard

IMP: (12/13/12, GVG) Some changes for "Allow PSEUDO layer in transistors extraction (Bug #4422)

IMP: (12/12/12, GVG) More flexible way to define SizeOff in contacts in TechEditorWizard

BUG: (12/12/12, SMR) Technology palette switches at bad times (Bug #4380).
FIX: Removed window frame resetting call in WindowFrame.WindowsEvents.windowActivated()

BUG: (12/11/12, SMR) AutoStitch runs job twice (Bug #4410).
FIX: Force CircuitChanges.cleanupCell() to start CleanupChanges by hand.

IMP: (12/10/12, GVG) Wizard should avoid defining multiple nodes with same name (Bug #4397)

BUG: (12/10/12, GVG) NPE in UserPreferences 3D if ThreeDTab is used (Bug #4411) 
FIX: Detecting if the view is null

IMP: (12/10/12, GVG) Allow definition of 4-layer contacts (Bug #4405)

IMP: (12/10/12, DN) Use ni.getNodeId() instead of ni.getNodeIndex() for removing swapped pairs in AutoStitch and DRC.

IMP: Printing more information for users in case plugin-dependent menus can't be loaded (Bug #4402)

BUG: (12/6/12, DN) Assertion in CellRevisionConn (Bug #4399)
FIX: In CellRevisionConn.updateBlocks consider change of node's protoId.

IMP: (12/6/12, GVG) Better catch not function type call (Bug #4400)

IMP: (12/5/12, GVG) Ability to define multicut rectangular contacts (Bug #4396) 

BUG: (12/5/12, GVG) sizey is not considered in multicutbox (XML tech definition) (Bug #4394)
FIX: sizey now considered in AbstractShapeBuilder:calculateInternalData

BUG: (12/5/12, SMR) Want PNG regression (Bug #3929).
FIX: Added regression.

BUG: (12/3/12, GVG) Cadence preferences for some key bindings look wrong (Bug #4388) 
FIX: Some key bindings still have the original values.

BUG: (12/3/12, SMR) Nonmanhattan arcs fail with rotated ports (Bug #4389).
FIX: Fixed RouteElementArc.doAction() to allow off-grid ports.

BUG: (11/29/12, SMR) Technology switches too easily (Bug #4380).
FIX: Changed detection and handling of technology switches.

IMP: (11/27/12, GVG) STL IO output capability (Bug #4379)
FIX: Implementation with regression included.

************************* Version 9.04-b: ******************************

BUG: (11/27/12, GVG) LEF output not writing correct LAYER info associated to PIN section (Bug #4378) 
FIX: Fixing the hardcoded text associated to metal layers on pins.

IMP: (11/27/12, GVG) Improve report message when parser errors are found (Bug #4377)

IMP: (11/27/12, GVG) Assign layer number/type to nodes whose layers in not found in GDS importer (Bug #4376) 

BUG: (11/26/12, GVG) NPE in 3D (Bug #4375)
FIX: Detecting the case.

BUG: (11/23/12, DN) Long EPoints take too much memory (Bug #4367)
FIX: EPoint is abstract. It has subclasses EPointInt and EPointLong.

BUG: (11/20/12, GVG) Wrong GDS for dummy vias if vias contain text/pin info (Bug #4359)
FIX: Just take value from the data structure.

IMP: (11/20/12, DN) Make bookshelf import deterministic.

BUG: (11/19/12. GVG) Creating XML tech from file doesn't deal with GDS pin/text values (Bug #4347)  
FIX: Added extra parsing condition for pin/text

IMP: (11/19/12, GVG) Error messages improved when parsing XML tech with errors.

BUG: (11/19/12, GVG) GetArcInfo dialog not wide enough (Bug #4345) 
FIX: Make sure the button fills the space assigned to that location.

BUG: (11/19/12, SMR) Extraction doesn't get right transistor (Bug #4322).
FIX: Try transistors in area order, not just by complexity.

BUG: (11/15/12, GVG) NPE while importing GDS skeleton (Bug #4320) 
FIX: Detect the case when no cell is found in the gds file.

IMP: (11/14/12, GVG) Better error message when there is no arc associated to layer in LEF PATH section

BUG: (11/14/12, SMR) Doing undo during a change job causes nondeterministic behavior (Bug #2398).
FIX: Warn user if change jobs are running.

IMP: (11/13/12, GVG) Catching exception in LayerSortingType.valueof() in case someone
has an invalid LayerSorting preference by mistake.

BUG: (11/12/12, GVG) FillCellTest still failing (Bug 3951) 
FIX: No longer DRC errors and update the reference library autoFillCellLibResult.jelib

IMP: (11/9/12, GVG) Ability to control how layers are listed in different dialogs" (Bug #4239) 
FIX: At least all functions that display layers have the same functionality to list Layers.

IMP: (11/9/12, GVG) Many changes for "Ability to control how layers are listed in different dialogs" (Bug #4239) 

BUG: (11/9/12, GVG) NPE in 3D dialog when no 3D feature is on (Bug #4279) 
FIX: Detect the null case during construction of the dialog.

IMP: (11/7/12, GVG) Added external connection to Calibre DRC for new 40nm tech.

IMP: (11/7/12, GVG) Get JavaWebStart to work with 9.03 (latest GNU release) (Bug #4176) 

BUG: (11/7/12, SMR) Error logger slow to search (Bug #3692).
FIX: Added map to ErrorLogger for faster search.

BUG: (11/4/12, DN) Assertion in makeGridBox (Bug #4255)
FIX: In ImmutableArcInst.getFixpExtendOverMin convert integer to long to avoid overflow.

BUG: (11/3/12, DN) Multi-threaded ERC and new machine with many cores (Bug #3882)
FIX: Use simple spread algorithm.

IMP: Report missing arc primitives similar to the missing node primitives cases (Bug #4256) 
Added missing arc primitives to the list displayed. Add "(arc)" to distinguish from nodes with
identical names.

BUG: (11/1/12, SMR) Live lists don't work with arrow keys (Bug #4254).
FIX: Changed from mouse listener to action listener

BUG: (11/1/12, GVG) Multi-finger transistors generator not working for internal 40nm tech (Bug #4253)
FIX: Properly detecting M1 as arc function

BUG: (11/1/12, SMR) When including bad Verilog, no errors are available (Bug #4247).
FIX: Put errors in error log.

BUG: (11/1/12, GVG) NPE in MultiFingerTransistor (Bug #4252)
FIX: Detect case when technology doesn't have transistors

************************* Version 9.04-a: ******************************

IMP: Adding new 40nm tech in the private version.

IMP: (10/29/12, GVG) Refactoring of sorting functions for layers and moved GDSLayers class to the technology package.
These changes are for Bug #4239 (Ability to control how layers are listed in different dialogs)

BUG: (10/29/12, SMR) Component menu preferences still think menu changed (Bug #4211).
FIX: Fixed flag when resetting.

BUG: (10/29/12, SMR) Verilog parse errors clutter Verilog netlisting (Bug #4247).
FIX: Suppress Verilog parse errors during netlisting.

IMP: (10/25/12, GVG) GDS Map importer improvements (Bug #4240)

IMP: (10/25/12, GVG) Ability to control how layers are listed in different dialogs (Bug #4239)
Started using the function tech.getLayersSortedByUserRule() in GDSTabs and 3D View.

BUG: (10/25/12, GVG) GDS tab in preferences doesn't start with current technology (Bug #4238)
FIX: Properly set the current item in technologySelection.

IMP: (10/23/12, GVG) Can we avoid moving the facet-center? (Bug #4217)
Avoid moving the center if multiple elements are selected

BUG: (10/23/12, SMR) Component menu preferences fails with null primitive functions (Bug #4213).
FIX: Validate and repair functions.

BUG: (10/22/12, GVG) LEF export doesn't comply with metal and via name standards.
Issues with UNIT definition (Bug #4229)
FIX: Names fixed and not dividing unit by 1000

IMP: (10/22/12, SMR) Now have initial Photonics technology (Bug #4228).

BUG: (10/21/12) LEF export doesn't write all VIA and METAL layers (Bug #4226)
FIX: Getting the number of metals/vias from the technology under analysis

BUG: (10/21/12) LEF Export generates invalid layer definition for vias (Bug #4225)
FIX: Removed extra space and ";"

BUG: (10/18/12) Problem with the sound system on Linux makes Electric to crash (Bug #4218)
FIX: Put extra try/catch

BUG: (10/17/12, DN) Display may skip subcells that are rotated (Bug #4209).
FIX: In AbstractLayerDrawing.getSearchBoubds() reverse orientation of parent cell when
     computing bounds for subcell search.

IMP: (10/17/12, GVG) GetMultiInfo Dialog with wrong initial size/difficult to resize (Bug #4215)
FIX: Defined min sizes for some panels. Moved Apply button to the right group (with OK and Cancel).

IMP: (10/17/12, GVG) Mark Variable parse exception as warning during library reading (Bug #4214)
FIX: Call logWarning with the message.

BUG: (10/17/12, GVG) NPE in ComponentMenu with mocmos tech (Bug #4212)
FIX: Detect when function associated to NodeProto or NodeInst is null

BUG: (10/17/12, SMR) Display may skip subcells that are rotated (Bug #4209).
FIX: In VectorDrawing.render() reverse orientation of parent cell when
     computing bounds for subcell search.

BUG: (10/17/12, SMR) Node extraction doesn't consider oversize cuts (Bug #4153).
FIX: Now reject contacts with cuts that are too small.

BUG: (10/17/12, SMR) Component menu doesn't remove changed warning after reset (Bug #4211).
FIX: Fixed change detection.

BUG: (10/15/12, GVG) Unexpected results when rotating a list of elements and the center is in that list (Bug #4210)
FIX: Avoid adding the center from the highlighted list of elements.

BUG: (10/15/12, GVG) Cell usage for layout cells (Bug #4208)
FIX: Skip the extra checking when the cell is a layout.

IMP: (10/15/12, GVG) EDIF should detect invalid attribute value (Bug #4207)
FIX: Added extra code to detect "=" in the expression. This is similar to Bug #4200

BUG: (10/15/12, SMR) Node extraction fails, makes big pins (Bug #4189).
FIX: Fixed N/P distinction, removed immense pins.

IMP: (10/11/12, SMR) EDIF preferences now has "Stitch cells when reading" (Bug #4194).

BUG: (10/11/12, SMR) Autostitch gives errors when stitching busses (Bug #4194).
FIX: In AutoStitch.testPoly() do not connect between bus and wire.

BUG: (10/10/12, GVG) EDIF reader doesn't detect badly formed variables (no close parenthesis) (Bug #4200)
FIX: Added the warning messages.

IMP: (10/9/12, GVG) Ability to import all parameters in EDIF import (Bug #4195)
New option in EDIF preference added

IMP: (10/2/12, SMR) Added synchronized clock trees (Bug #3845).

BUG: (10/1/12, GVG) Export SKILL and wrong command to instantiate subcells (Bug #4177)
FIX: Fixed wrong commands after dbOpenCellViewByType for subcells.

BUG: (9/27/12, GVG) NPE in Spice out when trying to use default parameters in top cell (Bug #4154)
FIX: Detect the case and use default value without executing evalParam with a null info.getParentInst()

IMP: (9/26/12, DN) Try ForkJoin from scala-library in ERCWellCheck.

BUG: (9/25/12, DN) IllegalArgumentException during deletion step (Bug #4146)
FIX: In GetInfoNode.doLoadInfo ignore unlinked nodes.

IMP: (9/24/12, DN) Enable strict API checks in CellRevision connectivity methods

************************* END OF Version 9.03, GNU RELEASE *************
************************* Version 9.03-c: ******************************

BUG: (9/18/12, SMR) Waveform window crashes when reload clicked (Bug #4133).
FIX: Do not call PageStorage.close() in Stimuli.finished().

BUG: (9/18/12, SMR) Node extraction fails for asymmetric transistors (Bug #4123).
FIX: Try transistors when flipped.

IMP: (9/18/12, SMR) Better Auto-routing without loops (Bug #4132)

IMP: (9/17/12, GVG) Better detection of Auto-routing in infinite loop (Bug #4132)

IMP: (9/17/12, GVG) Check if layer provided in tech file really exists (Bug #4131)

BUG: (9/17/12, GVG) Can't select correct ArcInst in Select Objects if there are multiple
arcs with same name (Bug #4128)
FIX: Don't look for the arc based on name. Use the Object obj already available

BUG: (9/17/12, SMR) Node extraction fails for complex technology transistors (Bug #4123).
FIX: Examine transistors in proper order and allow artwork layers.

BUG: (9/13/12, GVG) Out of bound exception if transistor doesn't have the expected active ports (Bug #4122)
FIX: Case detected (no port associated to active layers)

IMP: (9/11/12, GVG) Electric Webstart not up to date after Ant migration (Bug #4116)

IMP: (9/6/12, GVG) Control number of lines displayed in errors dialog (Bug #4105)
Related to Bug 4004

BUG: (9/6/12, SMR) 45-degree arcs not handled right yet (Bug #3982).
FIX: Fixed bug in 45-degree arcs, improved nonManhattan display command.

BUG: (9/4/12, GVG) NP in Extraction tool applied to schematics (Bug #4095)
FIX: Detecting the case of a non-layout cell.

BUG: (9/4/12, SMR) "Clear" button in "Highlighting" section of "Layers" sidebar
     gives warning messages (Bug #4094).
FIX: Find missing layers and avoid the warnings.

BUG: (9/4/12, GVG) NP in showNetworkCommand probably due to a bad connected port (Bug #4093)
FIX: Detect the case and report the error in the messages window

IMP: (9/4/12, GVG) Getting rid of "MoveNodeWithExport is accessed from Move (running)"

IMP: (8/30/12, GVG) Avoid exception trace if debug option is not used. (Bug #4082)

BUG: (8/28/12, SMR) Layer visibility not recached when technologies change (Bug #4060).
FIX: LayerVisibility now able to rebuild itself.

BUG: (8/27/12, GVG) Assertion if DRC deck does only contain min width rules (Bug #4068)
FIX: Add the layer to list of layers with rules when reading min width data.

BUG: (8/24/12, GVG) RuntimeException due to null file in Layout Image tool (Bug #4066)
FIX: Detect the empty filename

IMP: (8/23/12, GVG) Trimming searchText in Cell Search dialog in case you
place extra white spaces by mistake.

IMP: (8/22/12, SMR) Added "Tool / Generation / Acute Angle Fill"
     to fill corners of acute arc joins (Bug #3982).

************************* Version 9.03-b: ******************************

BUG: (8/21/12, SMR) Display crashes if cell bounds is null (Bug #4053).
FIX: Tests added in VectorCache.forceRedraw().

BUG: (8/20/12, SMR) LEF import doesn't handle polygons (Bug #4046).
FIX: Added polygon handling to pins and obstructions.

BUG: (8/20/12, SMR) DRC check in Array command runs even when dimmed (Bug #4050).
FIX: Do not run DRC check if checkbox dimmed, even if checked.

BUG: (8/17/12, GVG) Unknown PORT keyword (POLYGON) in LEF (Bug #4046)
FIX: Preliminary change to get going the reading process.

BUG: (8/17/12, SMR) EDIF import doesn't handle icons without schematics (Bug #4000).
FIX: Fixed import to work right.

IMP: (8/16/12, GVG) Added more messages in case technology doesn't have any DRC rule defined

IMP: (8/15/12, GVG) Cleaning changes related to "Clean up code in MTDRCLayoutTool
with code in DRC.java (Bug #2862)"

IMP: (8/15/12, GVG) Remove class MOSRules and DRCRules (Bug #3071)

IMP: (8/15/12, GVG) No warning if two xml technologies with the same name are uploaded (Bug #2905)
FIX: Added advise to remove invalid soft tech from preferences

BUG: (8/14/12, SMR) EDIF export fails when icon has no schematic (Bug #4000).
FIX: Fixed icon-only cells and mixed schematic/layout writing.

BUG: (8/14/12, GVG) Missing 3D demo file 'helphtml/demoCage.j3d' in GNU release (Bug #4036)
FIX: Added *.j3d in build.xml

BUG: (8/14/12, SMR) 3D features should be included in GNU release (related to Bug #3960)
FIX: Added Java3D to GNU build

BUG: (8/14/12, SMR) EDIF export of schematic transistors fails (Bug #4029).
FIX: Write both types of transistors.

BUG: (8/13//12, GVG) ClassCastException in Copy cells/groups from TreeExplorer (Bug #4027)
FIX: Detecting if root element is not CellGroup

BUG: (8/13/12, SMR) EDIF output doesn't handle layout right (Bug #4021).
FIX: Improved EDIF for layout cells.

BUG: (8/10/12, SMR) Explorer command "Copy Entire Group" doesn't handle
     multiple groups (Bug #3997).
FIX: Now handles multiple groups.

IMP: (8/11/12, SMR) When creating new cell from explorer tree, and
     a cell group is selected, use group name as default (Bug #4019).

BUG: (8/10/12, SMR) Very long alert dialogs are too wide (Bug #4004).
FIX: Break into shorter lines.

BUG: (8/10/12, SMR) Explorer command "Delete Entire Group" doesn't handle
     multiple groups (Bug #3997).
FIX: Now handles multiple groups.

BUG: (8/9/12, SMR) EDIF import doesn't connect (Bug #3992)
FIX: Allow slop in port connections.

BUG: (8/9/12, SMR) EDIF import crashes if icon has geometry (Bug #3998).
FIX: Handle situations where there is no cell for creating circuitry.
     Also write primitives properly.

BUG: (8/9/12, SMR) Cross-library copy fails if moving entire group (Bug #4016).
FIX: Queue cell deletion until after all copying.

IMP: (8/8/12, GVG) Allow reference to already read libraries in EDIF Import (Bug #4015)
Detecting if the cell already exists.

BUG: (8/7/12, SMR) EDIF import complains about criticality clause (Bug #3992).
FIX: Ignoring unused EDIF.

BUG: (8/6/12, GVG) NPE while exporting a more complex schematic (Bug #3999)
FIX: Detecting the null CellNetInfo when looking for equivalent ports.

BUG: (8/6/12, GVG) NPE in timing code (Bug #3996)
FIX: Detecting if NCC parameters are not found.

************************* Version 9.03-a: ******************************

BUG: (8/2/12, SMR) Need better handling of 45-degree arcs (Bug #3982).
FIX: Special handling in AbstractShapeBuilder.Shrinkage.

BUG: (7/31/12, GVG) Exception due to different GraphicsDevice for 3D views (Bug #3977)
FIX: Different way obtain GraphicsConfiguration. Solution found on the web.

BUG: (7/31/12, GVG) Change in AbstractTest.getEmptyRegressionPath() broke GDS_Export regression (Bug #3976)
FIX: ExportGDS and IO regressions have incompatible use of getRegressionPath(). Added new function.

IMP: (7/30/12, GVG) Node extraction regression added (Bug #3942).

BUG: (7/27/12, SMR) Node extraction fails in many cases (Bug #3942).
FIX: Now using minimum technology resolution for gridding.

BUG: (7/26/12, GVG) Absent of javax.media.Manager in path (Bug #3961)
FIX: Better caching of exception with classes are not found in makeExtraMenu.

IMP: (7/26/12, GVG) Catch ServiceLoader errors to understand better which plugins are missing (Bug #3959)

BUG: (7/26/12, SMR) Missing private components listed in "About" dialog (Bug #3958).
FIX: Show missing private components only in Debug mode.

IMP: (7/25/12, GVG) Std Spice Lib for timing in local menu allows to include cells defined in other libraries

IMP: (7/25/12, GVG) Reorganized submenus associated to timing in local menu to reflect which ones are
tech independent.

BUG: (7/24/12, GVG) skipSizeInPalette ignored in TechPalette? (Bug #2424)
FIX: Cleaning the code so there is no more reference to this keyword in TechEditWizard.

BUG: (7/24/12, GVG) No adding port in layers defined for nomulticase when distance is negative (Bug #3957)
FIX: Condition removed

BUG: (7/24/12, SMR) Node extraction doesn't grid-align right (Bug #3942).
FIX: Use technology grid, not user grid.

IMP: (7/23/12, GVG) Make visibility menus depend on EGraphics.getMaxTransparentLayer()
rather than fixed values.

BUG: (7/20/12, GVG) Assuming Current Tech in LEF reader (Bug #3926)
FIX: Previous fix was not right. The curTech should be taken from LEF structure.

BUG: (7/20/12, GVG) Found UnsupportedOperationException in FilGen plugin (Bug #3952)
FIX: Replace clone() for fromLambda()

BUG: (7/20/12, GVG) NPE in CompileVerilogStruct.getCell() (Bug #3949)
FIX: Marking as hasErrors if the file can't be read.

BUG: (7/20/12, GVG) EditingPreferences changes left some timing analysis tests not running (Bug #3948)
FIX: Amended signature of timing analysis functions

BUG: (7/20/12, GVG) NPE in LayerDrawing if technologies get mixed up? (Bug #3947)
FIX: Detecting when shapes are null.

BUG: (7/20/12, GVG) TechWizard doesn't generate arcs for some omulti_contacts_series (Bug #3943)
FIX: Detect if contact portname is not found as arcName. Error message is printed

BUG: (7/20/12, SMR) Extractor leaves original geometry behind (Bug #3942).
FIX: In Connectivity.extractContactNodes(), allow all layers into the merge.

IMP: (7/18/12, GVG) Calibre errors reader only creates groups if some elements will
be added to them.

BUG: (7/18/12, GVG) "Too many open file" errors in Calibre errors reader (Bug #3940)
FIX: Close those File pointers in readDensityErrors.

BUG: (7/17/12, GVG) NPE in TechnologyTest (Bug #3938)
FIX: Detect when project settings file can't be opened.

IMP: (7/17/12, GVG) Adding prBoundary to the 90nm tech

BUG: (7/16/12, SMR) Static Timing Analysis netlisting ignores Verilog views (Bug #3930).
FIX: This happened because of Bug #3883, so new command restores verilog views.

BUG: (7/13/12, SMR) Rendering may fail if cell is invalid (Bug #3928).
FIX: Always allocate top-level array in VectorCache.buildTopOnlyShapes().

IMP: (7/12/12, GVG) Managing to include the cell names in the XML Logger file (Bug #3884)

BUG: (7/11/12, GVG) File/Export/PNG: NullPointerException (Bug #3927)
FIX: Detecting if drawing preferences haven't been loaded for the printing process.
Fair treatment of arcs if they are found in the current technology.

IMP: (7/11/12, GVG) Assuming Current Tech in LEF reader (Bug #3926)
FIX: If no tech is provided in the LEF file, the current tech will be used.

IMP: (7/9/12, GVG) Better error message when importing LEF file and not finding the proper layer.

BUG: (6/29/12, GVG) Electric ignores the technology preference when importing GDS (Bug #3910)
FIX: Assign tech to cell after creation in GDS reader.

************************* END OF Version 9.02, GNU RELEASE *************
************************* Version 9.02-k: ******************************

BUG: (6/27/12, GVG) Better handling of 0 as GDS value (Bug #3909)
FIX: Better handling of GDS definitions like "0/19". Removing -1 case since it breaks
XML tech reader.

BUG: (6/26/12, SMR) Crossprobing not working from waveform to schematic (Bug #3907).
FIX: In WaveformWindow.WaveformWindowHighlightListener.highlightChanged()
     fix search for EditWindow.

BUG: (6/21/12, SMR) Electric doesn't export GDS with holes right (Bug #3813).
FIX: Do not break polygons into segments if hole is detected.

BUG: (6/18/12, GVG) [Bug 3882] Multi-threaded ERC and new machine with many cores (Bug #3882)
FIX: No fix/solution yet. Just synchronizing RTNode.Search.nextObject if that solves the
possible locking condition with many threats. No study yet on the performance impact.

BUG: (6/15/12, GVG) NPE in ErrorLogger when export request comes from regression (Bug #3884)
FIX: Detect the cases when GUI is not present.

************************* Version 9.02-j: ******************************

BUG: (6/14/12, SMR) Want Sun/Static Timing Analysis Verilog output to ignore
     Verilog views (Bug #3883).
FIX: Added internal Verilog preference to skip Verilog views.

BUG: (6/13/12, GVG) IO exception due to greater number of metals (Bug #3880)
FIX: Changes to deal with metal13 related structures including functions and arc functions.
No more DRCMode based on NumMetals since it doesn't scale well and not needed for smaller
technologies (<90nm)

BUG: (6/13/12, SMR) Scan Chain generator mangles names (Bug #3881).
FIX: Added option to not-mangle the names.

BUG: (6/12/12, GVG) Status bar doesn't update if you change the tech in a cell (Bug #3855)
FIX: Another implementation: solution in StatusBar code as any attempt in Cell.java:describe() breaks other code

BUG: (6/12/12, SMR) Vector cache crashes when new technology has more layers than last (Bug #3878).
FIX: In VectorCache.addBoxesFromBuilder() test for max layers in technology.

BUG: (6/11/12, GVG) Status bar doesn't update if you change the tech in a cell (Bug #3855)
FIX: Adding tech in case of displaying a cell instance whose tech is different from the current one.

BUG: (5/31/12, GVG) StackOverflowError while duplicating cells with expanded subcells (Bug #3861)
FIX: Getting CellRevision from the appropriate CellId.

BUG: (5/31/12, SMR) Playing with global overrides in Sun menu commands (Bug #3860).
FIX: Removed override.

BUG: (5/30/12, GVG) Electric doesn't check if a soft tech was already defined as known (Bug #3857)
FIX: Report error if soft tech is already defined in TechFactory.getKnownTech.

BUG: (5/30/12, SMR) Must warn that removing a technology is delayed (Bug #3850).
FIX: Added warning to manual and Added Technologies preferences.

BUG: (5/29/12, GVG) NPE in library file (edit)  (Bug #3856)
FIX: Detecting the null case in ReadLibrary. No menu if the URL is null

BUG: (5/29/12, SMR) Do not show memory usage in status bar when hierarchical
     traversal being done (Bug #3854).
FIX: Fixed StatusBar.updateUsedMemory().

BUG: (5/27/12, DN) Earlier check that selectedExport is linked (Bug #3853)
FIX: Avoid non-linked export in EditWindow.

BUG: (5/25/12, GVG) NPE in Interactive Router (Bug #3852)
FIX: Similar null detection for the zero degree case as in 90 degree

BUG: (5/24/12, SMR) Need better tools to reconfigure the component menu (Bug #3827).
FIX: The Component Menu Preferences panel now has additional commands:
     1) splitting a tall column in two
     2) swapping two columns
     3) rotating the elements in a column (up or down)
     4) the ability to drag-and-drop component menu entries to rearrange them

BUG: (5/24/12, SMR) Quick-key "&" conflicts with layer visibility commands (Bug #3847).
FIX: "Repeat Last Command" is now F7.

IMP: (5/23/12, GVG) The usage of LIBDIR and what is considered a valid path (Bug #3837)
FIX: Added mainLibDirectory+LIBDIRS path to the potential dir candidates.

BUG: (5/22/12, SMR) Must change GNU headers (Bug #3849).
FIX: Changed.

BUG: (5/22/12, GVG) Rearrange tech palette if number of rows is > 20 (Bug #3827)
FIX: Done in the tech editor wizard to calculate the number of sections (3 columns of 20 items each)

BUG: (5/22/12, GVG) Too large coordinates (Bug #3829).
FIX: Modifications in private repository

BUG: (5/22/12, DN) Too large coordinates (Bug #3829).
FIX: Mark EPoint constructor as deprecated. Replace some calls of the constructor.

BUG: (5/22/12, GVG) Too large coordinates (Bug #3829)
FIX: Replaced new EPoint() with EPoint.fromLambda()

************************* Version 9.02-i: ******************************

BUG: (5/17/12, GVG) TechEditWizard test not running (Bug #3840)
FIX: Changes for this to avoid the assertion but mocmos test doesn't run.

BUG: (5/17/12, SMR) Need H-tree router for clock distribution (Bug #3845).
FIX: Initial version created.

BUG: (5/17/12, SMR) Cross-library copy fails when a blank line is selected (Bug #3844).
FIX: Skip blank lines.

BUG: (5/17/12, SMR) DEF import should optimize when ignoring interconnect (Bug #3843).
FIX: Now ignores entire block if not reading interconnect.

BUG: (5/17/12, GVG) NPE if new tech in test can't be created (Bug #3842)
FIX: Detecting the case

BUG: (5/17/12, SMR) Spice output writes separate subcircuits for each position
     in the hierarchy if there is a syntax error in an attribute (Bug #3839).
FIX: Detect the syntax errors and print warnings.

BUG: (5/17/12, SMR) Recent LEF changes altered regressions (Bug #3834).
FIX: Must let width information carry-over from LEF import.

BUG: (5/17/12, SMR) Redisplay crashes when libraries change (Bug #3838).
FIX: Tests for null pointers in LayerDrawing, PixelDrawing, and VectorCache.

BUG: (5/16/12, SMR) DEF reader cannot handle quoted square brackets (Bug #3833).
FIX: Now converts them to underscores.

BUG: (5/16/12, SMR) DEF should handle missing cells (Bug #3828).
FIX: Now have DEF preference "Make dummy cells for unknown cells".

BUG: (5/15/12, GVG) NPE in DEF reader for variable that is shared with LEF (Bug #3832)
FIX: Move initialization to initializeLEFDEF()

BUG: (5/15/12, GVG) Wrong version after Ant migration (Bug #3830)
FIX: As of from now, we must update version in Version.java.

BUG: (5/15/12, SMR) Redisplay clears screen when technologies are added (Bug #3821).
FIX: In VectorCache.clearCache(), add call to forceRedraw().

BUG: (5/14/12, SMR) Redisplay still updates windows that didn't change (Bug #3706).
FIX: Fixed redisplay to only work on changes.

BUG: (5/14/12, GVG) LEF doesn't consider pure node for overlap layers (Bug #3826)
FIX: Added code to search for pure node. Similar to case when is sought by name.

BUG: (5/14/12, GVG) Memory issue while importing LEF with two different technologies (Bug #3825)
FIX: Cleaning the layers map, similar to the widths and vias values

BUG: (5/11/12, GVG) NPE when pattern in EGraphics constructor is null (Bug #3822)
FIX: Detecting the case. Assigning null pattern in that case.

BUG: (5/10/12, GVG) NoSuchElementException if XML tech doesn't define arcs (Bug #3818)
FIX: Just detecting the case to avoid the exception.

************************* Version 9.02-h: ******************************

BUG: (5/3/12, GVG) Invariant issue in TechEditorWizard if txt file is loaded more than once (Bug #2951)
FIX: Fixed for sometime already. Just marking as release in this version.

BUG: (5/3/12, DN) Better catching of too large coordinate in GDS import (Bug #3405)
FIX: This has been fixed for a while now. Adding the text here for completeness.
EPoint inherits from AbstractFixpPoint (Dima's work)

BUG: (5/2/12, GVG) NPE in MarkForEditJob (CVS feature) (Bug #3811)
FIx: NPE condition detected when unmark condition is present in Edit$MarkForEditJob.terminateOK()

BUG: (5/1/12, SMR) I can't paste complex polygon in Electric (Bug #3812)
FIX: Detect if there is trace information in Clipboard:copyListToCell

BUG: (4/30/12, SMR) Waveform Window menu entries crash when there is no Waveform Window (Bug #3810)
FIX: No Waveform window case detected.

BUG: (4/29/12, SMR) Include gds from file and skeleton view (Bug #3809)
FIX: Detect if the subcell is a skeleton view.

BUG: (4/27/12, GVG) Electric can't ready {lay.sk} cells? (Bug #3806)
FIX: Detecting if file has a "double" extension like "lay.sk"

BUG: (4/27/12, GVG) Out of bound while clicking in the About dialog box (Bug #3808)
FIX: Just detecting index=-1

BUG: (4/27/12, GVG) Electric is not properly including SPICE external file with external LVS (Bug #3807)
FIX: sp.ignoreModelFiles = false in SunAsyncMenu

BUG: (4/27/12, SMR) NPE while importing GDS skeleton view (Bug #3805)
FIX: Detect when CellBuilder is null in skeleton mode

BUG: (4/26/12, SMR) Message "Moved" not longer in status bar as of 9.02e (Bug #3804)
FIX: Move showCoordinates in EditWindow around

BUG: (4/25/12, GVG) Not proper displayed on gds #/type if gds#=0? (Bug #3411)
FIX: Added more code in the wizard to detect when the GDS value=0 (invalid number). Reset to -1.

BUG: (4/25/12, GVG) Arc generated from extra_layers info should take same function as layer definition (Bug #3652)
FIX: Get the function value from the associated layer

BUG: (4/24/12, GVG) Not cleaning local variable when loading txt file (Bug #3803)
FIX: Local variables are clean before loading the txt file.

IMP: (4/24/12, GVG) Assertion when trying to read again XML tech file (Bug #3729)
Added extra printing in debug mode telling the name of the primitive node repeated.

IMP: (4/24/12, GVG) Include line number in case of errors while reading the Tech wizard file

BUG: (4/24/12, GVG) Veriloging more because it can't match names? (Bug #3772)
FIX: Detecting when VModule is actually defined even though the cell name might not match.

IMP: (4/23/12, GVG) Adding line number in the Calibre LVS errors report.

BUG: (4/19/12, GVG) Assertion while importing Calibre LVS errors (edit)  (Bug #3778)
FIX: Adding more condition for instance errors

IMP: (4/17/12, GVG) Extending facility to import LVS Errors from Calibre.

IMP: (4/11/12, GVG) Another place where those warning messages sent to the messages window when a
library can't be read (Bug #3704). Detect if lib==null in FileMenu.ReadLibrary()

IMP: (4/11/12, GVG) Duplicate Cell Error preventing the reading of the rest of the library (Bug #3662)
Adding information of file where the cell was previously found.

BUG: (4/11/12, GVG) NPE in Undo if GUI can't be started (Bug #3767)
FIX: Catching the null pointer in UserInterfaceMain instead.

************************* Version 9.02-g: ******************************

IMP: (4/10/12, GVG) Adding "mt" to Calibre runs.

BUG: (4/9/12, DN) POLY2CAPAC,OPENEDT2 and OPENEDT3 not in Technology.xsd (Bug #3758).
FIX: Update PrimitiveNodeFun and NodeLayerStyle in Technology.xsd .

IMP: (4/9/12, GVG) Facility to import LVS Errors from Calibre.

BUG: (4/5/12, SMR) NPE in Waveform window (Bug #3739).
FIX: Fixed WaveformWindow.WaveFormDropTarget.drop().

IMP: (4/4/12, DN) Move electric-utils from plugins to electric.

BUG: (4/4/12, GVG) NPE when adding signal to simulation done with test HSpice2 (Bug #3739)
FIX: Detect when no collection is found from collection name.

BUG: (4/4/12, GVG) Few NPEs while testing WaveformTests (Bug #3738)
FIX: Detect the cases where the library can't be read.

BUG: (4/4/12, SMR) Cell names can be changed to have spaces in them (Bug #3737).
FIX: Unified cell name checking into Cell.isBadCellNameCharacter().

BUG: (4/4/12, SMR) Circles lose partial degrees when changed (Bug #3736).
FIX: Fixed CircuitChangeJobs.PossibleVariables to include circles.

IMP: (4/2/12, GVG) Get Electric to abort big import DEF job (Bug #3691).
More places to abort the job: readNet()

BUG: (4/2/12, GVG) Invalid notches errors after fixes done for 3685 (edit) (Bug #3714)
FIX: Catching properly corner case where 1 geometry is single point rather a valid area
in Quick:getIntersectionToPolygon(). You need changes in electric-utils as well.

BUG: (4/2/12, SMR) Cell parameters "Copy From Cell" doesn't get attributes (Bug #3730).
FIX: Include attributes as well as parameters.

BUG: (3/29/12, SMR) Pointer arrow missing when highlight is off screen (Bug #3718).
FIX: In Highlighter.ensureHighlightingSeen() allow all types of highlights.

IMP: (3/28/12, GVG) New entry in private menu

BUG: (3/28/12, SMR) Verilog crashes when schematic and icon ports don't match (Bug #3716).
FIX: Do not pursue missing exports.

BUG: (3/27/12, GVG) Merge two ways of marking standard cells (Bug #2174)
FIX: Removing "Mark Current Cell as Standard Cell" from private menu.
Forcing people now to use the Cell -> Properties menu

BUG: (3/27/12, GVG) Verilog can't parser  "assign #<delay> a=b" (Bug #3715)
FIX: Adding extra conditions to deal with tilde, hash and expressions in parseAssign.

BUG: (3/26/12, DN) Ability to detect invalid files due to CVS merge problems (Bug #3713).
FIX: In Export.newInstanceNoIcon detect this case.

BUG: (3/26/12, GVG) Merge two ways of marking standard cells (Bug #2174)
FIX: Removing "Set Verilog Standard Cell Template" from private menu

************************* Version 9.02-f: ******************************

IMP: (3/23/12, GVG) Those warning messages sent to the messages window when reading
a library that doesn't exist (Bug #3704). Detect properly if ReadProjectSettingsFromLibrary runs successfully,

BUG: (3/23/12, GVG) Ability to continue launching Electric even though there are issues with some plugins (Bug #3705)
FIX: Catching the error, printing stack in debug mode. Also catching if IRSIM is available in boolean
variable to avoid multiple calls.

BUG: (3/22/12, DN) Redisplay is slow after working at some level of hierarchy and then going up (Bug #3710).
FIX: First fix is to remove reference to CellBackup in VectorCache.VectorCellDef.
    HighlightLine references WindowFrame by WeakReference.
    Remove entries in UserInterfaceMain.savedHighlights when EditWindow is closed.
    Fix bounds calculation in AbstractCellDrawing.setClip.
    Return redraw of highlights from render thread to swing thread.

BUG: (3/22/12, SMR) Copy/pasting cell attributes UI is bad (Bug #3709).
FIX: Warn about not duplicating attributes; draw line at target.

BUG: (3/21/12, GVG) NPE in EditWindow.invokeRenderJob (Bug #3708)
FIX: Detect the null EditWindow

IMP: (3/21/12, SMR) GDS can now skeletonize input and merge back with output (Bug #3707).

IMP: (3/21/12, DN) LayerDrawing better draws layers with empty pattern (like prBoundary).

BUG: (3/19/12, DN) ClassCastException accessing SpecialSelectionPort as Export (Bug #3703)
FIX: Fix methods genShapeOfNoe in Schematics technology to return correct ports.
  Rollback changes in NodeInst.

BUG: (3/19/12, GVG) ClassCastException accessing SpecialSelectionPort as Export (Bug #3703)
FIX: Detecting the case in ClickZoomWireListener and NodeInst.

BUG: (3/19/12, SMR) Spice preferences cannot control writing of empty subcircuits (Bug #3702).
FIX: Now in the preference, and it controls CDL as well.

IMP: (3/18/12, DN) Electric activates unstable feature when Java property "electric.unstable" is true.
  It is enabled by java command-line switch "-Delectric.unstable=true".
  About dialog shows more info about search results of ServiceLoader providers.

BUG: (3/18/12, DN) Exception while deleting pins (Bug #3699).
FIX: In database.constraint.LayoutCell check for unlinked node.
  In connectivity methods of CellRevisionJ check for unlinked nodes in debug mode.

BUG: (3/16/12, DN) CircuitChangeJobs.eraseObjectsInList causes a crash in CellReviisonS.getNodeInfo (Bug #3698).
FIX: In CircuitChangeJobs.eraseObjectsInList check for unlinked NodeInst.
  In NodeInst.hasExport/NodeInst.getNumExports/NodeInst.getExports return false/0/empty for unlinked NodeInst.
  In CellRevisionS throw exception for unlinked NodeInst.

BUG: (3/15/12, DN) Jelib reader doesn't unquote node and arc names (Bug #3697).
FIX: In JelibParser.parseNode and in JelibParser.parseArc call unQuote with proper arg.

BUG: (3/15/12, SMR) DEF reader crashes in regressions (Bug #3696).
FIX: Fixed testing for abort.

BUG: (3/15/12, DN) Edit->Change loses polygon shape (Bug #645).
FIX: In ReplaceBuilder.replaceNode copy variables and outline trace.

BUG: (3/15/12, DN) Exception when renaming library (Bug #3694).
FIX: In CellRevisionS.lowLevelWith don't try to reuse connectivity data after Cell or Library rename.

BUG: (3/14/12, DN) UnsupportedOperationException when peeking into Cell (Bug #3693).
FIX: In EditWindow.repaintContents use mutable rectangle.

BUG: (3/14/12, SMR) Want to abort DEF import (Bug #3691).
FIX: Fixed.

BUG: (3/14/12, SMR) Need better LEF reader (Bug #3690).
FIX: Fixed LEF/DEF layer reader and LEF Pin reader.

BUG: (3/13/12, GVG) Assertion in DRC (Bug #3689)
FIX: The condition should not be an assertion. Sending the message in debug mode

BUG: (3/12/12, SMR) Redisplay crashes with icon/schematic issues (Bug #3687).
FIX: More testing for valid arguments to NodeInst.findPortInstFromProto().
   Create a method NodeInst.findPortInstFromEquivalentProto().

BUG: (3/9/12, GVG) Notches in non-Manhattan geometries (Bug #3685)
FIX: Better point selection when geometries are not Manhattan.
Changes in Quick:findInterveningPoints()

************************* Version 9.02-e: ******************************

BUG: (3/8/12, SMR) Redisplay crashes when cell doesn't exist (Bug #3684).
FIX: Fixed PixelDrawing.drawImage() to check for dead cells.

IMP: (3/6/12, GVG) java.io.IOException: Duplicate cell (Bug #3661
This is similar to Bug #3662. Extra code to print e.getMessage()rather that
stack trace in case of failure. Discussion continues in Bug #3662

IMP: (3/6/12, GVG) Avoid the exception printout in non-debug mode (Bug #3651)

IMP: (3/6/12, GVG) ERROR while reading resource: latchesL (Bug #3653)
Just don't print the error message in this particular case since it is experimental.

BUG: (3/6/12, GVG) Failure to save file not properly handled (Bug #3650)
FIX: Catching the failure in DELIB.writeCell properly. Error was not
evaluated by JELIB.writeLib()

BUG: (3/6/12, SMR) Eagle, ECAD, and Pads fail regressions (Bug #3675).
FIX: Look for variables on Schematic exports, not Icon.

BUG: (3/6/12, SMR) NonManhattan wiring crashes (Bug #3678).
FIX: Fixed incorrect logic in InteractiveRouter.getConnectingPoints() and added tests.

BUG: (3/5/12, SMR) "Select Object" draws badly when there are two windows on the cell (Bug #3664).
FIX: Must handle fact that two windows on one cell has only one highlighter.

BUG: (3/3/12, DN) Exception from Export->ShowPortsOnNode for cell with no exports (Bug #3673).
FIX: In ExportChanges.showPortsAndExports check for empty ports list.

BUG: (3/3/12, DN) Following port in lower level going up hierarchy error (Bug #3670).
FIX: In EditWindow.upHierarchy check that selectedExport is linked.

BUG: (3/2/12, SMR) Want Verilog writer to avoid re-declaring signals
     already mentioned in "Verilog declaration" (Bug 3663).
FIX: Examine declarations and remove from automatic generation.

BUG: (3/1/12, SMR) "Instance name" visibility doesn't work (Bug #3647).
FIX: Removed it from Layers tab.

BUG: (3/1/12, SMR) Vector cache crashes (Bug #3659).
FIX: Fixed VectorCache.renderPoly().

BUG: (3/1/12, SMR) Layer drawing fails when width=32 (Bug #3660).
FIX: Fixed AlphaBlender.composeLine().

BUG: (3/1/12, DN) DELIB reader forgives duplicate cells (Bug #3657).
FIX: Don't forgive duplicate Cells.

BUG: (3/1/12, DN) Exception while attempting to write scan chain XML file (Bug #3655).
FIX: Better diagnostics in ScanChainXML when Jtag Controller is undefined.

IMP: (2/29/12, GVG) Adding arc and pin to AP layer in tsmc40 tech.

BUG: (2/29/12, DN) Out of Bounds Exception (Bug #3648).
FIX: In CellRevision.with consider cases when all arcs or nodes are deleted.

IMP: (2/28/12, GVG) Better catching of invalid rule name in Tech.txt file used in Wizard (Bug #3413)

IMP: (2/28/12, GVG) Automatically highlight annotation when it gets created by makeTemplate (Bug #3645)

IMP: (2/28/12, SMR) "Change" dialog now has option to evaluate numbers
     when sorting names (Bug #3646).

IMP: (2/28/12, SMR) "Show Network" now shows like-named nets in other cells
     (in the same cell group) that are being displayed (Bug #3603).

IMP: (2/27/12, GVG) Make Layout Text/Image only for Layout technologies (Bug #3643)

BUG: (2/27/12, GVG) Check error for arc in 3D (Bug #3606)
FIX: Better warning messages when nodes/arcs are flat and can't be displayed in
3D.

BUG: (2/27/12, SMR) "Select Object" doesn't work right if multiple networks
     have the same name (Bug #3603).
FIX: SelectObject.java must track the object, not just the name.

BUG: (2/27/12, SMR) Vector cache doesn't update cell instances properly (Bug #3625).
FIX: Fixed RTNode search of entire tree.

BUG: (2/25/12, SMR) Cell variables are not drawn in new vector cache (Bug #3627).
FIX: Label and update cell variables.

BUG: (2/24/12, GVG) Still "accessed from null" (Bug #3587)
FIX: Values are cached now.

IMP: (2/24/12, GVG) Ability to control the GDS file used by external connection to Calibre (Bug #3629)
This feature doesn't go into the manual.

IMP: (2/24/12, GVG) Ability to specify file in Set Netlist Cell from File (Bug #3628)

BUG: (2/24/12, GVG) NPE in MakeTemplate (Bug #3626)
FIX: Just detect the case when the cell is null and abort the job.

BUG: (2/24/12, DN) Crashes when moving cell group to a different library (Bug #3622).
FIX: In VectorCache.updateVectorCache check if killed Cell was in cache.

BUG: (2/23/12, SMR) Dragging cells to a different window doesn't update focus (Bug #3624).
FIX: Request focus correctly in PaletteFrame.PlaceNewNode.terminateOK().

BUG: (2/23/12, SMR) Crashes when moving cell group to a different library (Bug #3622).
FIX: Must check return value of Cell.getCellGroup() everywhere.

BUG: (2/23/12, SMR) Crashes when editing cell with a deleted export (Bug #3623).
FIX: In SnapshotAnalyze constructor, test for null Export.

BUG: (2/22/12, SMR) Keys getting lost (Bug #3612).
FIX: Rework of key handler (may not solve problem).

BUG: (2/22/12, DN) Edit->Change throws exception (Bug #3619).
FIX: In ReplaceBuilder.CellBuilder.commit add condition "oldArcIndex < arcInsertionPoint".

BUG: (2/16/12, SMR) Status bar doesn't update after a click, only a mouse move (Bug #3609).
FIX: Added status bar update to ALL mouse listeners in EditWindow.java

BUG: (2/22/12, DN) New display algorithm doesn't always show cells correctly (Bug #3620).
FIX: In LayerDrawing.drawCell consider orientation when prepare bounds for R-Tree search.
     Also fixed VectorDrawing.render() to consider orientation.

IMP: (2/21/12, SMR) "Manipulate Exports" and "Manipulate ports on node"
     dialogs are now modeless and can "show" or "highlight" (Bug #3600).

************************* Version 9.02-d: ******************************

IMP: (2/29/12, GVG) Adding arc and pin to AP layer in tsmc40 tech.

IMP: (2/20/12, DN) Remove class CellBackup.Memoization .

IMP: (2/18/12, DN) Faster Node Change when "all in cell" is selected.

BUG: (2/17/12, GVG) NPE in EditWindow:upHierarchy (Bug #3611)
FIX: Catching the NPE condition. Added println in debug mode for further analysis

IMP: (2/16/12, SMR) Rotate command now works on text (Bug #3597).

BUG: (2/16/12, SMR) Deleting an export doesn't report properly (Bug #3610).
FIX: Fixed CircuitChangeJobs.DeleteSelected.doIt().

BUG: (2/16/12, SMR) Status bar doesn't update when a different port is selected
     on the same node (Bug #3609).
FIX: Removed highlighter exclusion from StatusBar.java

IMP: (2/14/12, DN) Refactor database.text.Name into abstract class and implementation.

BUG: (2/14/12, DN) NPE in Edit->Change (Bug #3607)
FIX: NodeInst.Replacement.getAssoc catching if newProto is null

BUG: (2/14/12, GVG) NPE in Edit->Change when changing arcs (edit)  (Bug #3608)
FIX: Catching if np is null

IMP: (2/14/12, DN) Save Felix's dependency injection in branches/felix-injection .

BUG: (2/13/12, GVG) File exception due to no write permission by log4j (Bug #3387)
FIX: Refactored some classes and clean the code where the OS was hard-coded.

IMP: (2/13/12, GVG) Better description of external scripts running under the AsyncMenu

IMP: (2/9/12, DN) Lookup IRSIM and Scala layout merger by ServiceLoader.

BUG: (2/8/12, SMR) Huge cells take too long to redisplay (Bug #3598).
FIX: Added R-Trees to VectorCache and eliminate drawing of cells less than 1 pixel big.

IMP: (2/7/12, DN) Refactor ImmutableLists of ImmutableNodeInsts, ImmutableArcInsts, ImmutableExports.
  A class CellRevisionProvider that creates instance of ImmutableLists.

IMP: (2/6/12, DN) Guard by Job.getDebug() some self-checks in Network code.

IMP: (2/5/12, DN) CellRevision allocates less memory for Cells that haven't been edited.
  ImmutableNet uses nodeIndex and arcIndex from CellRevision.

BUG: (2/3/12, GVG) Small defect error after running multiple times DRC? (Bug #3588)
FIX: Stop DRC if zero width arc is detected since other errors might be triggered.

BUG: (1/30/12, SMR) LEF and DEF files must be read together (Bug #3586).
FIX: LEF reader stores vias in library for use by DEF reader.

************************* Version 9.02-c: ******************************

IMP: (1/26/12, SMR) Rolling the mouse wheel in zoom mode now works (Bug #3584).

IMP: (1/25/12, SMR) Improved icon generation for layout to aggregate busses
     and keep aspect ratio (Bug #3582)

BUG: (1/24/12, SMR) Generating schematics from layout crashes (Bug #3582).
FIX: Fixed ViewChanges.java, and also expanded the "Make Icon" function so that it
     can make an icon directly from a layout.

BUG: (1/22/12, DN) Highlight coloring does not work correctly for coincident layout objects using ctrl-select (Bug #3579).
FIX: Move mouseOverHighlighting from EditWindow.paintComponent to Drawing.paintComponent.

IMP: (1/18/12, SMR) Can now route subcells in SOG router (Bug #3428).

IMP: (1/18/12, GVG) Updating reference to local machine.

************************* Version 9.02-b: ******************************

IMP: (1/12/12, SMR) Shift-middle-drag now lets you drag-out an area
     and select objects in that area, without moving anything (Bug #3569).

BUG: (1/12/12, SMR) Verilog model files with errors crash the netlister (Bug #3568).
FIX: Fixed verilog parser to handle "?" in assigns; fixed Verilog netlister to
     include code that has parse failures.

BUG: (1/9/12, GVG) Wrong min area value for M1/M2? (edit) (Bug #3551)
FIX: The value was relaxed and now taking the first data for Mx.

BUG: (1/5/12, SMR) Verilog reader doesn't handle 1'b1 constants (Bug #3567).
FIX: Fixed CompileVerilogStruct.java to handle it.

BUG: (1/4/12, DN) Router doesn't mark database "dirty"s (Bug #3565)
FIX: In SeaOfGatesHandlers.DefaultSeaOfGatesHook.flush mark changed Library.

BUG: (1/4/12, GVG) Deleting last node of pure arc causes array out of bounds (Bug #3566)
FIX: Detecting if the HighlightEOBJ has valid information of the object.

BUG: (1/4/12, SMR) Node extraction fails when implants are missing (Bug #2401).
FIX: Note missing implants and warn that they may be in subcells and
     can be extracted if Preferences are corrected.

************************* Version 9.02-a: ******************************

BUG: (1/3/12, SMR) Wiring may move endpoints and fail to run arc (Bug #3561).
FIX: Fixed InteractiveRouter.getClosestValue() to keep inside bounds.

BUG: (1/3/12, SMR) Calibre DRC crashes (Bug #3563).
FIX: Fixed CalibreDrcErrors.parseErrorPoint().

BUG: (1/3/12, SMR) Error messages when writing Spice deck for Schematics (Bug #3562).
FIX: In Spice.addNodeInformation(), get network information only if the polygon
     is valid.

BUG: (12/28/11, SMR) Gerber I/O not consistent (Bug #3508).
FIX: Fixed output and input.

BUG: (12/28/11, SMR) Spice waveform plotting crashes (Bug #3556).
FIX: In Stimuli.getMaxTime() check for null simulation engine.

BUG: (12/22/11, SMR) Mouse-over is slow and incorrect (Bug #3554).
FIX: Fixed ClickZoomWireListener.mouseOver().

BUG: (12/21/11, DN) Wrong number of DRC errors in schematics (Bug #3553).
FIX: Return Schematic.schematicDoCheck() to the behavior before the change of node bounds calculation.

BUG: (12/21/11, SMR) Schematic DRC fails with new pin sizes (Bug #3550).
FIX: Fixed Schematic.schematicDoCheck() to test zero-size by comparing with
     the primitive's base rectangle, and only for bus pins.

BUG: (12/21/11, SMR) Status bar doesn't update in MDI mode (Bug #3549)
FIX: In StatusBar constructor, always call Highlighter.addHighlightListener(this).

BUG: (12/20/11, DN) Cross-Library Copy Argument Exception (Bug #3547).
FIX: Specialize ElectricObject.copyVarsFrom to subclasses. NodeInst.copyVarsFrom respects TRACE variable.

IMP: (12/20/11, DN) Calculation of node bounds doesn't require CellBackup.getMemoization() .

IMP: (12/16/11, DN) Calculation of port shape doesn't require CellBackup.getMemoization() .

IMP: (12/16/11, DN) Better scaling of isolated port in schameatic:And/Or/Xor .

IMP: (12/13/11, DN) Database invariant: ImmutableNodeInsts with trace always has Orientation.IDENT .

BUG: (12/13/11, DN) Some primitive ports have negative width.
FIX: Swap lx and hx in
     cmos90:P-Transistor:diff-right
     cmos90:N-Transistor:diff-right
     cmos90:VTH-P-Transistor:diff-right
     cmos90:VTH-N-Transistor:diff-right
     cmos90:VTL-P-Transistor:diff-right
     cmos90:VTL-N-Transistor:diff-right
     cmos90:P-Well-RPO-Resistor:right-rpo
     cmos90:N-Well-RPO-Resistor:right-rpo
     cmos90:P-Poly-RPO-Resistor:right-rpo
     cmos90:N-Poly-RPO-Resistor:right-rpo

IMP: (12/11/11, DN) Methods PrimitiveNode.genShape and PrimitivePort.genShape .

BUG: (12/8/11, SMR) Verilog port-direction analysis is wrong (Bug #3534)
FIX: Better analysis counts the number of outputs on a network.

IMP: (12/1/11, SMR) Added "Global Routing" to Sea-of-Gates routing preferences (Bug #3428).

BUG: (12/1/11, SMR) Technology editor crashes converting Technology to Library (Bug #3520)
FIX: ArcInfo.compactCell() converts ERectangle to Rectangle2D before changing it.

IMP: (12/1/11, DN) Get rid of NodeLayer.fixup .

IMP: (11/26/11, DN) Technologies EFIDO, PCB and RCMOS are defined by xml.

IMP: (11/26/11, DN) PrimitivePort is immutable.

BUG: (11/25/11, FS) Catch NumberFormatException in minarea API, if min area value is a double (Bug #3300)
FIX: Add try and catch for minarea parameter and errorLogger parameter

IMP: (11/24/11, DN) Arc bounds don't consider shrinkage when CellBackup.ARC_BOUNDS_CONSIDER_SHRINKAGE=false.

BUG: (11/22/11, DN) Mouse highlight is slow when a single highlight is selected (Bug #3504).
FIX: In LayerDrawing algorithm redraw connected network in render thread.

IMP: (11/21/11, DN) DBMath.pointInRect on fixed-point point/rect returns exact result
  not considering TINYDELTA.

IMP: (11/20/11, DN) Fixed-point AbstractFixpRectangle.
   ERectangle becomes its subclass. ERectangle doen't store double coordinates.
   Mutable FixpRectangle is another its subclass.
   Geometric bounds are ERectangles. Poly bounds are FixpRectangles.
   R-Tree implementation respects subclasses of AbstractFixpRectangle.

IMP: (11/18/11, DN) FixpTransform is an AffineTrasnsform that can transform fixed-point coordinates.

BUG: (11/16/11, DN) Display algorithms redraw all highlights on every mouse move (Bug #3504).
FIX: LayerDrawing algorithm redraws most highlights on selection change only.
    Mouse-over highlight color has transparency component, because main highlights
    are drawn before mouse-over highlights now.

IMP: (11/16/11, DN) Make Highlighters almost immutable.

BUG: (11/13/11, DN) EditWindow.pulsatingTimer scans all highlights (Bug #3504).
FIX: Highlighter supports a list of "difficult" highlights. Pulsating timer scans them.

BUG: (11/13/11, DN) StatusBar.updateSelected text is called too often (Bug #3504).
FIX: Flags StatusBar.highlighterShown indicates that no update is necessary.
  More accurately track Highlighter.change .

IMP: (11/13/11, DN) Keep Poly points in a special class PolyBase.Point .

IMP: (11/13/11, DN) Technology objects keep coordinates in ECoord objects.

IMP: (11/12/11, DN) Resolution is ECoord object.

BUG: (11/11/11, DN) Deprecated Technology.getFactoryScaledResolution() is still used in GDS.
FIX: Replace by Technology.getFactoryResolution().

BUG: (11/10/11, DN) Serialization error in Cleanup Cell (Bug #3500).
FIX: Remove EditingPreferences field from CircuitsChangeJobs.Reconnect .

IMP: (11/9/11, SMR) Added new context menu entry: "Close All at This Level" to collapse
     the current location in the Explorer tree (Bug #3491).

IMP: (11/8/11, DN) Rename Dimension2D.Double to com.sun.electric.util.EDimension and make it immutable.
     Make it aligned to 2/DBMath.GRID .

BUG: (11/8/11, DN) Users of electric-core library can't compile because of new ElectricPreferences parameters.
FIX: Restore some deprecated method from Version 9.00 .

BUG: (11/8/11, DN) Regressions failed because too much was deleted in revision 13353 .
FIX: Restore method Schematics.getShapeOfPort().

IMP: (11/7/11, DN) Canonize outline of FILLED, CLOSED, OPENED pure layer nodes - removed duplicate adjacent vertices.
     For FILLED and CLOSED consider also same start and end points.
     Sometimes boxes are encoded by 5-point pure layer nodes.
     After canonization ShapeBuilders recognize such nodes as boxes.

IMP: (11/6/11, DN) Remove package com.sun.electric.util.concurrent from electric-core to avoid clash with electric-concurrent.
     The class ElectricWorkerStrategy became an anonymous inner class of Main.
     Rename package com.sun.electric.tool.io to com.sun.electric.util.io in electric-utils to
     avoid clashes with electric-core.
     Move PropertiesUtils and BaseProperties from electric-core to electric-utils.
     Split TextUtils into database-independent com.sun.electric.util.TextUtils in electric-utils and
     database-dependent com.sun.electric.database.text.TextUtils in electric-core .

IMP: (11/5/11, DN) New AbstractShapeBuilder and tis subclasses.
     Uses fixed-point coordinate encoded in longs instead of former double coordinates.

IMP: (11/3/11, DN) Simplify parallel Dijkstra threads in SeaOfGates.
     Winning thread commits route layout. Second thread releases resources.
     So there is no need in special termination actions.

BUG: (11/2/11, DN) Error parsing in XML tech confusing (Bug #3474).
FIX: In TechPool change text of ErrorMessage.

BUG (10/27/11, SMR) Wiring horizontally when grain is 45-degrees is unstable (Bug #3468).
FIX: InteractiveRouter.getClosestAngledPoint().

IMP: (11/2/11, DN)  Repair SeaOfGatesEngineNew3. Remove SeaOfGatesEngineNew and SeaOfGatesEngineNew2.

IMP: (10/31/11, DN) Don't use thread-local EditingPreferences.

BUG: (10/29/11, DN) Cell.CellGroups.equals is true on same-named Cells from different Libraries.
FIX: Cell.CellGroups.equals compares libraries too.

BUG: (10/27/11, DN) Electric starts AWT thread in "-batch" mode.
FIX: Remove "javax.media.j3d.VirtualUniverse" from econfig.xml .

BUG (10/27/11, SMR) Wiring at 45-degree angles doesn't work (Bug #3468).
FIX: InteractiveRouter.planRoute and InteractiveRouter.getConnectingPoints().

IMP: (10/27/11, DN) Release electric-minarea-api-2.1 .
     Add parent projected for minarea implementations:
      electric-minarea-parentjava-0.1
      electric-minarea-parentscala-0.1 .

BUG: (10/26/11, SMR) ALS simulation adds transitions at 200ns (Bug #3467).
FIX: In ALS.addExports() do not put signal at 200ns.  Instead, added new
     Engine method getMinTimeRange() to force window size.

BUG: (10/25/11, DN) Binary jar doesn't contain JMF.
FIX: Change scope of JMF from provided to default.
     Search implementation of MoviceCreator with ServiceLaoder .

BUG: (10/23/11, DN) Poly that contains box is flagged bitRectangle=1 .
     This tag is not cleared after non-Manhattan rotation.
FIX: PolyBase.transform clears bitRectange flag.

IMP: (10/22/11, DN) Methods that access thread-local EditingPreferences are
     replaced by method with explicit EditingPreferences parameter. Old methods are deprecated.

BUG: (10/15/11, DN) Regressions with logging failed.
FIX: In log4j.xml set console Target to System.err .

IMP: (10/14/11, DN) Replace slf4j-log4j12 by slf4j-jdk14 in dependencies of
     electric-core and electric-distribution.

IMP: (10/14/11, DN) Replace Java Logger by slf4j Logger in sources.

BUG: (10/14/11, DN) Electric hangs during startup (Bug #2391).
FIX: In UserInterfaceMain constructor push a dummy Runnable into old EventQueue before
     starting new EventQueue.

IMP: (10/12/11, DN) Move fast JELIB reader from private debug menu to public debug menu.

IMP: (10/12/11, FS) Move minarea debug menus to a public debug menu. Launch Electric
 	with option "-debug"

IMP: (10/11/11, DN) Move electric/electric-test to plugins/electric-utils.

IMP: (10/10/11, SMR) Added "Tools / Generation / Multi-Finger Transistor Cell..."
     to generate cells with multi-finger transistors (Bug #3434).

************************* END OF Version 9.01, GNU RELEASE *************
************************* Version 9.01-e: ******************************

IMP: (9/28/11, GVG) Ability to load other libraries stored in a resource location.
Submenu in LE will appear if given library is available in com/sun/electric/lib/

BUG: (9/28/11, DN) Electric slowly loads huge libraries.
FIX: Don't internalize strings in text.Name .

IMP: (9/23/11, GVG) Moved experimental min area commands under Tool/DRC into
Sun menu until they are well documented.

IMP: (9/15/11,SMR) Routing improved: honors horizontal/vertical layer
     usage; has debugging mode for failed-route visualization; has
     "selection" preference for routing mode that disables topology
     changes (Bug #3428jn).

BUG: (9/15/11, SMR) Verilog conversion to rats-nest fails for layouts
     that come from Verilog with busses (Bug #3427jn).
FIX: When in "schematic" mode, allow unrouted arcs if wires don't fit.

IMP: (9/13/11, DN) Clean plugin artifacts for new maven repository. New plugin versions are:
  electric-parent-5
  electric-irsim-api-0.1
  electric-minarea-api-2.0
  electric-movie-api-1.1
  electric-irsim-0.3

  electric-movie-jmf-1.0 is disabled because jmf-2.1.1e is not in central maven repository.

IMP: (9/13/11, DN) Remove deprecated method from electric-minarea-api.ErrorLogger interface.

IMP: (9/10/11, DN) Clean maven pom.xml's for new maven repository.
  Remove unused dependency on minarea-deltamerge0 from electric-sunlabs.
  Don't create jar-with-dependencies in electric-minarea implementations.

IMP: (8/19/11, GVG) Better handling of assertion in TechEditorWizard (Bug #3410)
Printing string with parser error. Exception only in debug mode.

BUG: (8/16/11, GVG) ArrayIndexOutOfBoundsException in tech wizard (Bug #3404)
FIX: Detecting when via size mismatches with metal size while uploading txt file with
tech information.

BUG: Scala don't work in Eclipse 3.7 (Bug #3378jn)
FIX: Remove unnecessary test cases in electric-merge to fix the compile cycle in Eclipse 3.7

IMP: (8/3/11, SMR) Improvements to LEF/DEF reader (Bug #3386jn).

IMP: (7/21/11, GVG) It would be good to add a reminder in the manual that (Bug #3375)
those "accessed from JavaBsh script" messages can't be avoided

BUG: (7/21/11, FS) Fix javadoc issues with doc-files (Bug #3376)
FIX: add the necessary information to the pom.xml file

BUG: (7/19/11, SMR) HSpice output with multiple TR files crashes if the files
     have multiple sweeps in them (Bug #3368jn).
FIX: Handle all sweeps from all files (may not be right).

BUG: (7/19/11, SMR) "Make Alternate Layout" gives warnings about preferences (Bug #3373jn)
FIX: Removed unused IconParameters declaration in ViewChanges.MakeLayoutView.MakeLayoutVisitor.

IMP: (7/15/11, GVG) Use library name when exporting GDS data with allCells option on (Bug #3369jn)

IMP: (7/12/11, GVG) Little information in case of starting external script
from a non-EditWindow window (Bug #3367jn)
Added extra messages to clarify the execution since external scripts run async'd

BUG: (6/27/11, SMR) Want to be able to force a number of processors in SOG routing (Bug #3219jn)
FIX: Now have Routing preference to force a number of processors.

BUG: (6/16/11, GVG) DRC throws assertion on MOCMOS NPN transistors (Bug #3358jn)
FIX: Detecting the case and avoid the assertion check

BUG: (6/6/11, DN) Rotated nodes connected with rigid arcs constrain badly (Bug #3278jn).
FIX: Fixed LayoutCell.java

************************* Version 9.01-d: ******************************

BUG: (5/9/11, SMR) Missing extension in file read not always resolved (Bug #3152jn).
FIX: Fixed reading file and preferences.

BUG: (5/5/11, SMR) Expansion status gets turned off (Bug #2630jn).
FIX: Fixed many operations (change, rename, etc.)

IMP: (5/5/11, SMR) Initial Gerber export added (Bug #3305).

BUG: (5/4/11, SMR) Expansion state not being used properly (Bug #3302).
FIX: Fixed PostScript, HPGL, SVN, Array, cut/copy/paste, cell package/extract,
    Get-info.  Also added first Gerber output module.

BUG: (5/4/11, SMR) CIF regression crashes (Bug #3303).
FIX: Handle cell expansion tests better.

BUG: (5/3/11, SMR) Cell instance expansion wrong inside Jobs (Bug #3302jn).
FIX: Caching expansion before calling Jobs.

BUG: (5/3/11, SMR) Arcs in lower-levels of HPGL are incorrect (Bug #3296jn).
FIX: Transform arcs appropriately.

BUG: (5/3/11, DN) Assertion while reading minarea file found in simple.tar.gz (Bug #3291)
FIX: In MinArea.convertLayoutCell use Cell.newInstance to avoid creation of CellCenterNode.

BUG: (5/2/11, SMR) Technology editor crashes on bad technology (Bug #3292jn).
FIX: Fixed technology generation to be more informative and forgiving.

BUG: (4/28/11, SMR) Waveform window has memory leak (Bug #3145jn).
FIX: Moved CachingPageStorage to Stimuli and improved cleanup there.

BUG: (4/14/11, SMR) Behavioral Verilog netlists (with Sun menu) should suppress
     parameters on standard cells; should write "parameter" statements for
     cell parameters, and should use those names instead of values (Bug #3050).
FIX: Done in Verilog.java.

BUG: (4/12/11, SMR) Text Preferences doesn't complain about invalid size numbers (Bug #3039).
FIX: Check number validity.

BUG: (4/11/11, SMR) IRSIM waveform window resets all signals at 10ns (Bug #3048).
FIX: Fixed Analyzer.convertStimuli() and also Panel.setXAxisRange.

BUG: (4/11/11, SMR) Verilog compiler should ignore behavioral code (Bug #3049).
FIX: Ignoring "initial begin" blocks.

************************* Version 9.01-c: ******************************

IMP: (4/6/11, SMR) New GDS Export Preference: "Export all cells in Library" (Bug #3047).

BUG: (4/4/11, SMR) Want to reduce the number of Verilog compilers (Bug #2991).
FIX: Switched all Verilog compilation to the new one.

BUG: (4/4/11, SMR) Want to convert Verilog to schematics (Bug #3046).
FIX: Added Verilog preference to choose the cell type.

BUG: (3/30/11, SMR) Existing Verilog parser crashes (Bug #3032).
FIX: Switching the "File / Import / Verilog" command to use the new Verilog parser.

BUG: (3/29/11, SMR) Text Preferences gives error if sizes is blank (Bug #3039).
FIX: Do not change size if new value is invalid.

IMP: (3/27/11, DN) Add command "TOool|DRC|check minarea...".

BUG: (3/9/11, SMR) Mirroring a node with the "getinfo" dialog doesn't adjust
     text that is offset and non-centered (Bug #3042).
FIX: Added calls in GetInfoNode.ChangeNode.doIt() to use CircuitChangeJobs methods.

BUG: (3/4/11, SMR) Node "getinfo" dialog doesn't work for polygonally-defined nodes (Bug #3041)
FIX: In GetInfoNode.ChangeNode.doIt() handle polygonal nodes specially.

IMP: (3/2/11, GVG) How to generate lay files from Electric libraries (Bug #3038)
Scale is set to largest common divisor of all coordinates.

IMP: (3/2/11, GVG) How to generate lay files from Electric libraries (Bug #3038)
Made available export to vectorCache format from ToolMenu/DRC menu.

BUG: (2/25/11, GVG) Exception on verilog netlisting (Bug #3032)
FIX: Moved module reading so anything coming in the file will be ignored and
there is no need to add new parameters. Modules must be defined before they are
instantiated.

BUG: (2/25/11, GVG) Out of Bounds Exception in Verilog reader (Bug #3037)
FIX: Due to parameters now described with instances (start with #). Skipping them now.

BUG: (2/25/11, SR) Verilog external code must appear at beginning of netlist (Bug #3026)
FIX: moved the top-level cell's external code to the top of the file.

BUG: (2/25/11, DN) Add Import minarea test to DRC menu.

BUG: (2/24/11, SMR) Editing text cells in an external editor is broken (Bug #3035).
FIX: Fixed recovery of external editor data. Also added context menu entry
     in Explorer Tree that lets you edit a cell without displaying it first.

BUG: (2/23/11, GVG) exception on verilog netlisting (Bug #3032)
FIX: Added more elements to ignore while parsing the Verilog file

BUG: (2/22/11, FS) exception on verilog netlisting (Bug #3032)

FIX: add the missing libraries to maven.dependencies

BUG: (2/22/11, FS) Add information about the installed plugins to the About Dialog (Bug #2981).
FIX: If Java3d is not installed in the JDK folder, the compilation and the about dialog crashes.

BUG: (2/21/11, DN) Add information about the installed plugins to the About Dialog (Bug #2981).
FIX: Add information about plugins to "About" dialog.

BUG: (2/20/11, DN) Manhattan minarea checker can't handle serpentine transistors (Bug #3031).
FIX: In database.geometry.bool.VectorCache recognize Manhattan polygons.

************************* Version 9.01-b: ******************************

IMP: (2/16/11, SMR) Improved "About" dialog to show Electric environment (Bug #3008).

IMP: (2/8/11, SMR) New command "Tools/Placement/Floorplan and Place Current Cell"
    automatically selects appropriate placement sequence from cell characteristics. (Bug #2977).

IMP: (1/31/11, GVG) Make available routing quality metrics as a command (Bug #3027)
Submenu "Routing Quality Metric" was added. It works on current cell.

IMP: (1/31/11, GVG) Adding execution time to WireQualityMetric

BUG: (1/31/11, GVG) exception when attempting to change net name (Bug #3026)
FIX: Defining constructor ArcInstKey() with no parameters.

BUG: (1/31/11, DN) Arc creation is slow (Bug #3016).
FIX: In NodeInst.getShapeOfPort avoid call of getCellTree() when handle shape of subcell ports.

************************* Version 9.01-a: ******************************

IMP: (1/28/11, DN) Set electric-irsim version to 0.1 .

BUG: (1/278/11, SMR) Invalid networks in Sea-of-Gates router are ignored (Bug #3023).
FIX: Remove them and report error in error-log (not messages window).

IMP: (1/27/11, GVG) UnroutedNets and StackedVias metrics for Bug #3013

BUG: (1/27/11, GVG) NPE in Select Object if no cell is in EditWindow (Bug #3024)
FIX: Detecting the null cell

IMP: (1/27/11, GVG) Better ErrorLog Info in SeaOfGates when it can't route nets (Bug #3022)

BUG: (1/27/11, SMR) Infinite loop in sea-of-gates router (Bug #3020).
FIX: DRC loop in SeaOfGatesEngine.advanceWavefront() exits on no-progress.

BUG: (1/27/11, SMR) Sea-of-gates router does not always abort (Bug #3019).
FIX: Pass "job" to all routing methods and use it.

IMP: (1/26/11, GVG) Metrics for routing tool (Bug #3013)

IMP: (1/21/11. GVG) Cells created by Bookshelf importer should use a layout tech (Bug #3005)
     Mocmos will be used as layout tech and m1 pins

BUG: (1/21/11, GVG) ImportBOOKSHELF test doesn't pass (Bug #2996)
FIX: Just updating the data since nothing wrong with the latest generated library.

IMP: (1/20/11, SMR) More Verilog compilation features (Bug #2991).

BUG: (1/12/11, SMR) Placement framework creates invalid arcs (Bug #3014).
FIX: In PlacementAdapter.doPlacement(), compute arc end coordinates.

BUG: (01/07/11, FS) Concurrent modification exception in ForceDirected2 (Bug #3011)
FIX: Use Iterator instead of for-each loop

IMP: (01/6/11, SMR) Added new Placement algorithm for row/column based
     Simulated Annealing (Bug #2977).

BUG: (01/06/11, FS) Unexpected assertion in Genetic Placement 1 (Bug #3010)
FIX: remove assertion

BUG: (01/04/11, FS) Exception in experimental SeaOfGates (Bug #2997)
FIX: Use the electric worker strategy

BUG: (12/18/10, DN) Failure in GDS reader when include text is enabled.
FIX: In input.GDS makeText fix if condition to ulm != null.

BUG: (12/28/10, SMR) Unroute removes well/substrate contacts (Bug #3003).
FIX: In Routing.findNetEnds() allow well/substrate primitives.

BUG: (12/27/10, SMR) Crash when drawing arc (Bug #3006).
FIX: Fixed Highlighter.findAllInArea() to calculate need for temp names only if necessary.

IMP: (12/22/10, FS) Add logging facade and logging environment

Bug: (12/22/10, FS) AStar 2 doesn't care about timeouts
FIX: Add some timeout information

Bug: (12/22/10, FS) Lee Moore 1 doesn't terminate on small designs (Bug #3001)
FIX: Accept small partitions on small designs

BUG: (12/22/10, FS) Lee Moore 1 doesn't care about timeouts (Bug #2999)
FIX: Timeout handling added

BUG: (12/20/10, GVG) Bookshelf reader could not read all files (Bug #2992)
FIX: Detect cases when invalid weight values are found in the file. Assigning Integer.MAX_VALUE

BUG: (12/18/10, GVG) NPE in CompileVerilogStruct with Verilog file generated by Design Compiler (Bug #2994)
FIX: Detect the case and stop the execution.

IMP: (12/13/10, SR) Want to read structural Verilog for place-and-route (Bug #2991).
First changes in.

BUG: (12/12/10, DN) Silicon Compiler can't handle Alliance structural VHDL because of vdd/vss names (Bug #2989).
FIX: Enhance handling power/ground names in CompileVHDL .

BUG: (12/13/10, FS) Eval<Languaga>.java in database package (Bug #2980)
FIX: Java files moved to com.sun.electric.tool.lang and created a JUnit test case

IMP: (12/12/10, DN) CIF reader can read Exports (disabled b io.input.CIF.MAKE_EXPORTS = false.

BUG: (12/12/10, DN) Should the configurator messages be avoided by default (Bug #2978).
FIX: In XmlInitSav.int log with CONFIG level instead of INFO level.

BUG: (12/12/10, DN) Ability to read structural VHDL generated by Alliance (Bug #2988).
FIX: Do necessary fixes in CompileVHDL. Add adder4{vhdl} to Generation regressions.

************************* END OF Version 9.00, GNU RELEASE *************
************************* Version 9.00-r: ******************************

BUG: (12/8/10, DN) CIF reader stops at unknown user commands (like 4 ... ) (Bug #2983).
FIX: In io.input.CIF.parseStatement issue USERS command on unknown user commands.

BUG: (12/8/10, DN) CIF reader numerate lines from 0 in error messages (Bug #2982).
FIX: In io.input.CIF.errorReport use 1-base line numbers.

BUG: (12/8/10, DN) CIF reader truncates layer names to 4 characters (Bug #2979).
FIX: In io.input.CIF.parseStatement() remove 4-characters restriction.

BUG: (12/8/10, DN) Crash if Max Perm Space is set (Bug #2963).
FIX: Launcher launches Launcher with -NOMINMEM instead of Main.

BUG: (12/8/10, DN) electric-core doesn't compile on 64-bit compiler.
FIX: Increase compiler memory from 256m to 384m.

BUG: (12/8/10, SMR) CIF input loses precision in scaled cells (Bug #2971)
FIX: In CIF.java, round values after scaling them.

BUG: (12/7/10, DN) maven.dependencies in electric-core includes electric-sunlabs (Bug #2975)
FIX: Exclude maven.dependencies in huge-jar distribution (bin, gnu, gnubin).

BUG: (12/5/10, DN) javax/media/Manager on MacOSX? No 3D Control dialog?
FIX: Less print when JMF is absent.

IMP: (12/3/10, DN) Repair build in maven-2.3.1 in electric-parent.
     Switch to version com.sun.electric:electric-parent:2

BUG: (12/2/10, GVG) java.lang.OutOfMemoryError while running "mvn install" (Bug #2969)
FIX: Increased maxmem in pom.xml to 256m

IMP: (12/1/10, DN) Rename package com.sun.electric.scala to com.sun.electric.database.geometry.merge .

BUG: (12/2/10, FS) Test errors in BlockedRangeTest (electric-concurrent)? (Bug #2967)
FIX: fix heap size issue

IMP: (12/1/10, DN) Add build.xml and scala runtime to the GNU distributions.

************************* Version 9.00-q: ******************************

BUG: (11/25/10, DN) Too verbose message when there no scala runtime.
FIX: Handle LinkageError during parsing econfig.xml .

BUG: (11/21/10, FS) well check hangs (Bug #2965)
FIX: handle if number of well areas is smaller then number of threads

BUG: (11/19/10, FS) Not possible to set thread number in ERC (Bug #2960)
FIX: Use a preinitialize variable to set #threads

BUG: (11/18/10, SMR) GDS output is bad for polygons with holes (Bug #2957).
FIX: In GDS.outputBoundary() fixed point generation.

IMP: (11/18/10, FS) New task structure in PI

IMP: (11/16/10, DN) Current version and buildDate in Version.java are obtaned by Maven filtering.

IMP: (11/16/10, FS) Handle enums as parameters in the configuration framework

BUG: (11/15/10, SMR) R-Tree is not marked "dirty" when nodes added/removed (Bug #2956).
FIX: Fixed in Topology.java

IMP: (11/14/10, DN) Irsim doesn't import electric classes.

BUG: (11/13/10, DN) Version number must be updated in many places (Bug #2950)
FIX: Request filtering for maven.dependencies .

IMP: (11/10/10, FS) Remove unnecessary system.out: electric-configuration (Bug #2947)

BUG: (11/10/10, DN) Memory leak in IRSIM simulation (Bug #2953).
FIX: Don't keep pointers to Panels, Signals, Listeners in static variables in com.sun.electric.tool.user.waveform .

IMP: (11/9/10, DN) Replace ProgressDialog in electric-irsim by ProgressMonitorInputStream in electric-core.

IMP: (11/9/10, DN) Move electric-jmf to trunk/plugins/electric-movie-api and trunk/plugins/electric-movie-jmf .

BUG: (11/6/10, DN) In samples:tech-MOSISMOS n-transistors are connected to vdd and p-transistors are connected to gnd (Bug #2952)
FIX: Edit samples:tech-MOSISMOS - mirror transistors bottom<->up and rename exports.

BUG: (11/4/10, DN) "ant mac-app" using mvn? Doesn't work for sunlabs (Bug $2948)
FIX: Copy app-resources from electric-distribution to electric-sunlabs.
   This is a quick solution that violates "Don't repeat yourself"

IMP: (11/3/10, DN) Move OpenFile dialog and IOException handling out of IRSIM and ALS Engines.

IMP: (11/3/10, DN) Add com.sun.electric.api.movie.MovieCreator API .
  Wrap JMFImageToMovie in com.sun.electric.plugin.JMF.MovieCreatorJMF .

IMP: (11/2/10, DN) Create release of com.sun.electric:electric-parent:1 .
    Tag it in "https://svn.sunlabs.com/svn/electric/tags/electric-parent-1 .
    Upload this pom artifact to java.net repository .
    Switch "trunk/electric/pom.xml" to use electric:parent:1 instead of electric-parent:1-SNAPSHOT .

IMP: (10/31/10, DN) Make pom hierarchy similar to Maven (add trunk/electric/electric-distribution) .

IMP: (10/31/10, DN) Set project version in maven pom.xml files to 9.00-q-SNAPSHOT .

BUG: (10/31/10, FS) ArrayIndexOutOfBoundsException in Parallel Infrastructure (Bug #2945)
FIX: Fix parallel for work distribution

IMP: (10/30/10, DN) distro is created only when profile -Pdistor is activated .
   The electric launcher "trunk/electric/electric-core/target/electric-core-SNAPSHOT.jar"
   loads other components from local maven repository.

IMP: (10/30/10, DN) One more assembly target "distro" .
    This is a directory with all jars and unix/windows scripts to launch the main jar.
    Scripts were derived from maven startup scripts.
    Distro is invoked by scripts trunk/electric/target/electric-9.0-SNAPSHOT-distro/bin/electric[.bat]

BUG: (10/29/10, DN) "ant mac-app" using mvn? (Bug $2948)
FIX: Reorganize maven projects a little. The parent of all maven projects is electric/electric-parent .
     Project electric is a container of subprojects and a project to package huge jar.
     Insert a call of osxappbundle-maven-plugin into pom.xml as a template for Gilda .

BUG: (10/28/10, FS) econfig.xml information printed not only in debug mode (Bug 2946)
FIX: removed, because it is not really necessary

************************* Version 9.00-p: ******************************

BUG: (10/20/10, DN) Make syntax of Electric version compatible with maven version (Bug #2943)
FIX: Dash is allowed in Version string. The current version is renamed to "9.00-p" .
     Library writers still write version in old format.

IMP: (10/20/10, SMR) GDS import can handle references to existing libraries (Bug #2942).

BUG: (10/19/10, DN) GDS import is all zero-size (Bug #2941).
FIX: Constructors of all subclasses of Input.InputPreferences respect parameter "factory" now.

BUG: (10/19/10, FS) Why did we add the xxxMB/yyyMB text on the bottom bar? (Bug #2940)
FIX: Show memory usage only in debug mode + fix license issue

BUG: (10/19/10, SMR) GDS import is all zero-size (Bug #2941).
FIX: In FileMenu.ImportLibrary constructor, restore call to initFromUserDefaults().

IMP: (10/18/10, SMR) Updated author information in About dialog (Bug #2937).

IMP: (10/18/10, SMR) Standardized error messages for missing components (Bug #2933).

BUG: (10/18/10, SMR) Waveform window and other places show small numbers as zero (Bug #2936).
FIX: Fixed TextUtils.convertToEngineeringNotation().

BUG: (10/14/10, DN) Compiling issue in frehley after last update in main branch (Bug #2935)
FIX: Rename util.config.SetterInject.CreateBy to util.config.CreateBy.

IMP: (10/14/10, FS) Electric-Dependency-Injection: include + parameter + singleton handling

IMP: (10/13/10, FS) Initial version of Electric-Dependency-Injection

BUG: (10/13/10, SMR) "New" graphing commands in Sun Async menu do not compile
     if plugin is missing (Bug #2931).
FIX: Made the code use reflection.

IMP: (10/13/10, DN) Add Spring-less dependency injection environment and use it in ERC again.

BUG: (10/13/10, DN) Some Compaction tests failed on Ubuntu boxes (Bug #2932)
FIX: Launch the compareJob before the QuitJob.

BUG: (10/12/10, SMR) Want to be able to rename Waveform Window signals (Bug #2788).
FIX: Can now double-click over signal name in Waveform Window and rename it.
     Does not rename crossprobed object in Electric...just assigns a new display name in the Waveform Window panel.

BUG: (10/11/10, DN) java -jar electric.jar doesn't longer work (Bug #2927)
FIX: In Launcher.initClasspath check for null combinedArray.

BUG: (10/11/10, SMR) Spice should not write OPTIONS NOMOD NOPAGE line (Bug #2925).
FIX: Removed the line from Spice.java.

BUG: (10/11/10, SMR) Postscript output fails for colored text (Bug #2922).
FIX: Use EGraphics to make colors.

************************* Version 9.00o: ******************************

BUG: (10/12/10, GVG) Main branch doesn't longer compile (jarLight2) after last sync with Maven (Bug #2929)
FIX: Lines causing the compilation failure in Launcher.java commented out.

BUG: (10/12/10, FS) Rollback log4j + commons-logging + spring (Bug #2926)
FIX: rolled back in trunk

IMP: (10/11/10, FS) Add spring environment and use it in ERC for ThreadPool

IMP: (10/11/10, FS) Additional folder handling for experimental stuff

IMP: (10/11/10, FS) Use log4j and common-logging

BUG: (10/8/10, GVG) TextUtils.eatWhiteSpaces v/s String.trim() (Bug #2907)
FIX: Per our discussion, trimLeading removed from the code.

BUG (10/8/10, FS) Strange debug message in CircularArray (Bug #2920)
FIX: debug message removed

BUG: (10/7/10, DN) Display didn't refresh after changing Text Preference from Bug #2790.
FIX: Implement new TextPreference in GraphicsPreferences instead of EditingPreferences.

IMP: (10/6/10, SMR) New Text Preference to show temporary names on nodes (Bug #2790).

BUG: (10/5/10, SMR) Missing technologies in GNU/debug mode should not give errors (Bug #2916).
FIX: Fixed in TechFactory.p().

IMP: (10/5/10, DN) Cleaned maven and trunk builds.

BUG: (10/5/10, SMR) No confirmation dialog when deleting a cell group (Bug #2915).
FIX: Added dialog in ExplorerTree.java.

IMP: (10/5/10, DN) Jar manifest contains SplashScreen-Image and Class-Path attributes.

BUG: (10/4/10, SMR) Interactive resizing allowed when nodes are locked (Bug #2914).
FIX: In SizeListener.sizeObjects() check for change prevention.

BUG: (10/4/10, SMR) Rotating mirrored nodes does not adjust text properly (Bug #2913).
FIX: In CircuitChangeJobs.RotateSelected.rotateText() removed special case
     that depends on the "wasSameMirror" parameter.

BUG: (10/4/10, FS) TextUtils.eatWhiteSpaces v/s String.trim()
FIX: rename TextUtils.eatWhiteSpaces to TextUtils.trimLeading

IMP: (10/3/10, FS) Electric shows used memory and total memory size in status bar

IMP: (10/3/10, DN) Electric tries to add plugins from maven repository on startup.

BUG: (9/30/10, DN) Electric-bundle hangs on machine without java3d.
FIX: Catch NoClassDefFoundError in MenuCommands.makeExtraMenu .

BUG: (9/29/10, SMR) Waveform window may be wrong (Bug #2912).
FIX: In BTreeSignal.BTreeRasterView constructor, adjust requested number of
     samples if it is close to the actual number of samples.

IMP: (9/28/10, SMR) SVG now has preferences panel to specify scale and margin (Bug #2907).

IMP: (9/24/10, DN) Replace calls of plugins.Java3D by similar inline code.

BUG: (9/23/10, SMR) GDS import ignores pins with bad names (Bug #2910).
FIX: Now convert to valid export names.

************************* Version 9.00n: ******************************

IMP: (9/22/10, DN) Refactor PlaceingFrame to isolate from Electric internals .

BUG: (9/22/10, SMR) SVG coordinates are not integers (Bug #2909).
FIX: Adjust transformations to produce integer coordinates.

IMP: (9/20/10, DN) Move Orientation.java to electric.util.math .

IMP: (9/20/10, SMR) Added Spice and Verilog Model Files preferences
     to use or force Verilog views (Bug #2908).

IMP: (9/19/10, DN) Class RoutingFrame.RoutingFramePrefs to control routing preferences.

IMP: (9/17/10, DN) Remove plugin with Russian manual because it is too old.

IMP: (9/16/10, SMR) Can now read multiple Nanosim files (Bug #1413).

IMP: (9/11/10, DN) Move getJarLocation from Launcher to Main.

IMP: (9/10/10, GVG) TechEditor and area rules (Bug #2903)
     MinArea MinEnclosedArea supported now in the txt file.
     Added minarea and minenclosedarea to 40nm tech for more testing.

BUG: (9/8/10, GVG) build.xml and Scala compilation (Bug #2906)
FIX: Forcing "ant -DNOSCALA" and modifications in build.xml to deal with no ScalaProjects dir.

BUG: (9/8/10, GVG) Can't run anymore (Bug #2905)
FIX: Made ElapseTimer serializable plus new GenMath/DBMath imports in tests code

IMP: (9/8/10, FS) Move GenMath and DBMath com.sun.electric.util.math

IMP: (9/8/10, FS) Refactoring: ElapseTimer, use ElapseTimer instead of single
     timestamps. This refactoring removes the function: getElapsedTime, this is
     solved inside the ElapsedTimer

BUG: (9/7/10, SMR) Cannot read simulation output that is broken into multiple
     files (Bug #1413).
FIX: Fixed HSpiceOut.java to read multiple .tr files.

BUG: (9/3/10, FS) StackOverflowError in ERC regression (Parallel.ThreadPool.initialize) (Bug #2902)
FIX: Solve infinite-recursion + added test case for this bug

IMP: (9/2/10, FS) Refactoring of parallel infrastructure: no dependencies to other
     electric packages

BUG: (8/30/10, SMR) Need to warn users who request too much memory (Bug #2900).
FIX: Improved the General Preferences dialog to advise on upper memory limits.

************************* Version 9.00m: ******************************

IMP: (8/28/10, DN) Add Scala LayoutMerger for area check.

BUG: (8/26/10, DN) No time reporting in MTDRC (Bug #2897)
FIX: Print time in MultiTaskJob. Use startJobOnMyResult in DRCToolTest.basicMTDRCTest.

IMP: (8/26/10, GVG) Working on "DRC slow for the tfc chip" (Bug #2851).
Using map instead of list to check cell interactions.

BUG: (8/24/10, SMR) Going down-hierarchy into arrayed schematic node
     doesn't show the path in the status bar (Bug #2890).
FIX: Fixed EditWindow.showCoordinates().

BUG: (8/23/10, DN) Natural sort order of NodeInst is not consistent with order of NodeInsts in a Cell.
FIX: Use TextUtil.STRING_NUMBER_ORDER in NodeInst.compareTo .

IMP: (8/23/10, DN) Methods Cell.addNodes with ImmutableNodeInst args.

BUG: (8/23/10, SMR) Array command gives preference access errors (Bug #2894).
FIX: Made pref class for the creation job.

IMP: (8/23/10, SMR) Improved "Manipulate Exports" dialog to change many
     characteristics at once (Bug #2895).

IMP: (8/23/10, GVG) Working on "DRC slow for the tfc chip" (Bug #2851).
Work done with worstInteractionDistance values.

IMP: (8/21/10, GVG) Working on "DRC slow for the tfc chip" (Bug #2851).
More ways to reduce getShapeOfNode() for only layers with rules.

BUG: (8/20/10, GVG) MDT DRC not properly skipping layers without rules (Bug #2991)
FIX: Applying rules filter during task creation

IMP: (8/20/10, DN) ErrorLogger knows about ImmutableNodeInsts.

BUG: (8/20/10, DN) Round-off errors in NodeInst.setTrace (Bug #2893)
FIX: Use EPoints in NodeInst.setTrace.

IMP: (8/19/10, GVG) Remove class MOSRules (Bug #2880)

BUG: (8/18/10, GVG) NPE in Multi-threaded DRC (Bug #2889)
FIX: Detecting properly non-layout layers (Universal from generic in the particular design)

BUG: (8/18/10, SMR) Rotated nodes do not interactively resize correctly (Bug #2887).
FIX: Fixed in SizeListener.getNewNodeSize().

IMP: (8/18/10, FS) Bookshelf Weights + Bookshelf Header per file (export) +
Speedup export (net list)

BUG: (8/18/10, FS) Simulated Annealing 2 eats up memory without running the tool (Bug #2886)
FIX: create all arrays at execution time of the placement tool (while calling runPlacement)

IMP: (8/18/10, FS) Add immutable list

IMP: (8/18/10, FS) Test of private methods: Annotation TestByReflection

IMP: (8/17/10, GVG) More changes for "DRC slow for the tfc chip" (Bug #2851).
Looking for way to reduce getShapeOfNode() for only layers with rules.

BUG: (8/16/10, DN) Node bounds is incorrect (Bug #2884).
FIX: Let busPinNode always has NodeLayers.

BUG: (8/12/10, SMR) SUE import fails (Bug #2883).
FIX: Fixed importing to make parameters have inheritance and to autostitch when done.

************************* Version 9.00l: ******************************

IMP: (8/11/10, GVG) Improve error message in Verilog when encountering signature problem (Bug #2882)

BUG: (8/11/10, GVG) NPE in Verilog parser (Bug #2881)
FIX: Added handling of nested loops in always statement.

IMP: (8/9/10, GVG) Working on "DRC slow for the tfc chip" (Bug #2851).
Reducing # of calls of Technology.getRuleIndex.

IMP: (8/6/10, DN) Cell.getUniqueNameIndex considers both prefix and suffix.

IMP: (8/6/10, DN) Methods Cell.addExport and Cell.addExports with ImmutableExport args.

BUG: (8/5/10, SMR) Cannot outline-edit hard-to-select nodes (Bug #2875).
FIX: In OutlineListener.mousePressed() set "findSpecial" to true.

IMP: (8/5/10, SMR) Can now use Node Properties to resize a node with outline data (Bug #2873).

BUG: (8/5/10, SMR) Textual HSpice import fails (Bug #2874).
FIX: Fixed reader to handle Text and Binary.

IMP: (8/5/10, FS) Bookshelf exporter

IMP: (8/4/10, JKG) fix bug 2154: update the preferred contact list more often.
Might be too often because tech palette calls the contact prefs code a LOT, but now at least it works.

************************* Version 9.00k: ******************************

BUG: (8/3/10, SMR) Node extraction creates DRC errors (Bug #2829).
FIX: In Connectivity.doExtract() detect off-grid better.
     In RouteElementArc.newArc() avoid using universal arcs

IMP: (8/2/10, SMR) Gerber import alternates layer assignment (Bug #2860).

BUG: (7/30/10, JKG) Hitting escape to cancel a wiring tool action does not reset the highlights (Bug #2842)
FIX: This case was missing in the code for 'escapePressed' in ClickZoomWireListener

IMP: (7/29/10 GVG) Removing deprecated functions in experimental 2 and 3,
new routers codes, Bug #2803

BUG: (7/29/10, DN) NPE in WaveformTests using the GUI (Bug #2868).
    I guess that WindowFrame.finished() should be called from SwingThread only.
    Assertion is added to WindowFrame.finished() .

BUG: (7/29/10, SMR) Vertical waveform axis zero value drawn badly (Bug #2870).
FIX: Fixed in Panel.drawPanelContents().

IMP: (7/29/10, SMR) Added import regressions (Bug #2869).

BUG: (7/29/10, FS) Add "terminal-flag" to electric (Bug #2867)
FIX: Set terminal cells as locked (bookshelf) + propagate terminals to placement nodes
     But: no placement tool uses this information at the moment

IMP: (7/29/10, DN) Skip non-manhattan layers in MANHATTAN mode of DRC area check.

BUG: (7/28/10, FS) ArrayIndexOutOfBoundsException in matrix example
FIX: Data Race on bottom index pointer in UnboundedDEQueue

IMP: (7/27/10, GVG) DRC Warnings reported more than once (Bug #2865)

IMP: (7/17/10, GVG) Getting Waveform script working in regression (Bug #2864)

IMP: (7/26/10, SMR) Added initial waveform window regression tests (Bug #2861).

BUG: (7/26/10, GVG) Exception in Gerber reader because it tries to read wrong file? (Bug #2859)
FIX: Extra filtering of files. Fixed unnecessary concatenation of file path. Removed  topDirName
from gerber files.

BUG: (7/26/10, FS) MultipleQueues + FCQueue not possible
FIX: PJob didn't use all queues for work distribution

BUG: (7/24/10, FS) German umlauts cause compiler warnings
FIX: Use international translation of German umlauts

BUG: (7/24/10, FS) Interrupt Exception in LockFreeStack (Bug #2856)
FIX: Fixed. Save return from backoff algorithm instead of exception.

IMP: (7/22/10, GVG) DRC regression failing due to memory problem in sport test (Bug #2854)
Just disconnecting sport/area/local test since it takes too much time to run.

IMP: (7/22/10, SMR) Added 6 experimental routers from Karlsruhe (Bug #2803).

************************* Version 9.00j: ******************************

IMP: (7/21/10, FS) Add Scheduler Factory to Parallel Infrastructure

IMP: (7/20/10, FS) Add FCQueue proposed by Nir Shavit and integrated the queue
	as a scheduler for the parallel infrastructure.

IMP: (7/20/10, FS) Parallel metrics: bounding box - minimum spanning tree (MST)

BUG: (7/20/10, SMR) Canceling undo warning dialog with ESC fails (Bug #2852).
FIX: Fixed ToolBar.undoCommand.run().

IMP: (7/19/10, FS) Add progress bar to bookshelf import

BUG: (7/19/10, DN) Database regression fails due to UnsupportedOperationException in testMakeGridPoly.
FOX: In ImmutableArcInstTest.MyBuilder implement addIntBox.

IMP: (7/18/10, DN) The last argument of basicDRCTest specifies min area check algorithm.

IMP: (7/18/10, DN) Add min area check algorithm DRCCheckMinArea.AREA_MANHATTAN .
    It is fast, but accepts only manhattan layout.

IMP: (7/17/10, DN) Laze allocation of "sons" in PolyBase.PolyBaseTree ..

IMP: (7/16/10, DN) Fast path for grid-aligned boxes in AbstractShapeBuilder.pushPoly .

IMP: (7/15/10, SMR) Added Spice Opus output format (Bug #2848).

BUG: (7/15/10, SMR) Going up hierarchy can duplicate selection (Bug #2843).
FIX: In WindowFrame.setCellByHistory() and in EditWindow.upHierarchy()
     clear selection before setting new ones.

BUG: (7/14/10, SMR) Restore waveform window functionality (Bug #2846).
FIX: Redid many things.

BUG: (7/13/10 GVG) KeyBehavior not picking arrow keys (Bug #2845)
FIX: Added KeyEvent.KEY_RELEASED as valid ID to accept the event.

BUG: (7/12/10, SMR) Nanosim/Epic waveform reader crashes on bad file (Bug #2816).
FIX: Rewrote Epic reader to use new waveform model.

BUG: (7/11/10, SMR) Changing component choice in component menu should
     change all component menus (Bug #2154).
Fixed in TechPalette.PlacePopupListListener.actionPerformed().

BUG: (7/8/10, SMR) LTSpice (raw format) doesn't display properly (Bug #2841).
FIX: Fixed RawSpiceOut.java to use new sweeps.

BUG: (7/8/10, SMR) Waveform window doesn't handle HSpice sweeps (Bug #2782).
FIX: Added SweptSample class, added getSweepNames() to Signal.

BUG: (7/5/10, SMR) Waveform window draws AC stimuli wrong (Bug #2839).
FIX: Changed ComplexSample constructor to compute hypot() instead of atan2().

BUG: (7/2/10, GVG) Placement regression failed due to change in test library? (Bug #2837)
FIX: Rolled placementTests.jelib to original revision (r1576). Revision r1720 was
modified inadvertent and gives different results.

BUG: (7/2/10, SMR) Explorer-tree context command to create a new cell should
     choose the proper library as the default (Bug #2836).
FIX: Improved NewCell to take a default library.

BUG: (7/1/10, SMR) AC waveform signals crash (Bug #2835).
FIX: Added Adam's patch.

BUG (7/1/10, FS)  Placement regression failed due to missing static method
FIX: add static method from history

BUG: (7/1/10, SMR) Interactive sizing misaligning coordinates (Bug #2827).
FIX: Fixed SizeListener to avoid transforming into the space of the node.

BUG (6/30/10, FS) Force-Directed-1 do not terminate (Bug 2800)
FIX: Kill barrier after termination

BUG (6/30/10, FS) Add Placement Tools to Test Menu (Bug 2831)
FIX: Added, each tool has the following parameters (#threads 2, runtime 10sec)

BUG: (6/30/10, GVG) Test -> TestPlacement -> Placement1 doesn't work (Bug #2832)
FIX: Don't assume libraries have *.jelib extension. Fixed regression as well.

BUG: (6/30/10, DN) I am not able to perform error-free Node Extraction (Bug #2829).
FIX: I replaced tech.getFactoryScaledResolution() by tech.getFactoryResolution().
  This fix allows to recognize transistors by there are still some DRC errors.
  This fix doen't solve the entire issue but I hope that this fix is reasonable.

IMP: (6/29/10, AM) Remove Signal.isAnalog(), Signal.isBussed()

IMP: (6/29/10, AM) Remove Signal.isDigital()

BUG: (6/29/10, DN) Inconsistency in how export names are compared using canonicString (Bug #2826).
FIX: ElectricObject.uniqueObjectName maintains case-sensitive uniqueness.

IMP: (6/28/10, AM) Eradicate Analysis.java for all eternity.

IMP: (6/28/10, AM) Remove Analysis.getSignals()

IMP: (6/28/10, AM) Remove calls to Analysis' constructor

IMP: (6/28/10, AM) Analysis extends HashMap<String,Signal>

IMP: (6/28/10, AM) Remove Analysis.getSignalsFromExtractedNet()

IMP: (6/28/10, AM) Remove Analysis.findSignalForNetwork()

IMP: (6/28/10, AM) Remove Analysis.getTitle()

IMP: (6/28/10, AM) Remove Analysis.findSignalForNetworkQuickly()

IMP: (6/28/10, AM) Remove Analysis.get{Min,Max}.

IMP: (6/28/10, AM) Remove Analysis.AnalysisType.

IMP: (6/28/10, AM) Remove Analysis.getStimuli().

IMP: (6/28/10, AM) Clean up Analysis.java.

IMP: (6/28/10, AM) Expunge DigitalAnalysis.

IMP: (6/28/10, AM) Remove legacy "bussing" kludge.

IMP: (6/28/10, AM) Have VerilogOut use BusSample.

IMP: (6/28/10, AM) Finish implementing BusSample.createSignal().

************************* Version 9.00i: ******************************

BUG: (6/27/10, AM) Waveform window exception at different places (Bug #2824)
FIX: Deal in a more robust manner with Signals having fewer than two samples.
     Also improve error reporting if things go wrong.

IMP: (6/26/10, GVG) highlight the outline of the geometry in ERC errors (Bug #2752)

BUG: (6/25/10, AM) Waveform window pans wildly when Command-5 is pressed
FIX: Make WaveformWindow.centerCursor() center on the "main" cursor instead
     of the mouse.

BUG: (6/25/10, AM) Extrapolation is not being done when zoomed-in (Bug #2822)
FIX: Make BTreeSignal.RasterView far more clever than before.

BUG: (6/25/10, AM) IRSIM no longer crossprobes as main cursor is dragged (Bug #2807)
FIX: Remove the line that Steve said to comment out.

BUG: (6/24/10, GVG) NPE in ERC if cell to ERC is null (Bug #2821)
FIX: Detect the case and abort the test.

BUG: (6/24/10, AM) interior of waveform appears shaded (Bug #2809)
FIX: Fix incorrect branch test in BTree range query code.

BUG: (6/23/10, GVG) Missing text while editing text in MacOSX Snow Leopard (Bug #2819)
FIX: Add extra width and height depending on the font size rather than fixed numbers (5).

IMP: (6/23/10, FS) Split task parallel runtime classes and pipeline classes

BUG: (6/23/10, SMR) Further improvements needed for LEF output (Bug #2764).
FIX: Added extra LEF statements to output.

BUG: (6/23/10, SMR) Verilog bus display is slow (Bug #2814).
FIX: Optimized triple-nested loop in Panel.processSignals().

BUG: (6/22/10, FS) Using the new version of ERC well check (bucket, path check) (Bug #2804)
FIX: moved old ERC Version to ERCWellCheckOld

BUG: (6/21/10, AM) PSpice not reading (Bug #2812)
FIX: Assign "*.txt" to PSpiceOut.

BUG: (6/21/10, AM) I want to favor HSpice so that it reads the TR0/PA0
     file, even in the presence of the other files (Bug #2815)
FIX: Change priority order in SimulationData.java.

IMP: (6/21/10, FS) First fully draft of SeaOfGates router with new parallel
     infrastructure. Added a two way thread pool: Use this thread pool if you
     want to do two different jobs in parallel, where one job starts the other
     one.

BUG: (6/21/10, AM) LTSpice import throws an exception
FIX: Be more forgiving of bogus data supplied to ScalarSample.createSignal()

BUG: (6/21/10, AM) RawSpiceOut reader complains "Unknown analysis:
constants" (Bug #2811)
FIX: Kludge around ridiculous text/binary nonsense in Input.java.

BUG: (6/21/10, AM) ALS simulation throws an exception (Bug #2806)
FIX: Get ALS.java to call the right method.

BUG: (6/19/10, AM) HSimModel force/release doesn't do error checking
     (Bug #2574)
FIX: Add error checking in HsimModel.java.

BUG: (6/19/10, AM) Electric throws UnsupportedOperationException when
     run with EmptyPreferencesFactory.
FIX: Do not attempt to set the working directory when running in batch
     mode.

IMP: (6/19/10, AM) Finish support for ComplexSample.

BUG: (6/18/10, SMR) Control-key axis-gridding of placed instances fails
     if mouse moving at release (Bug #2437).
FIX: Do gridding on button release.

IMP: (6/19/10, SMR) Added debugging for Karlsruhe parallel routers (Bug #2803).

BUG: (6/18/10, SMR) Layer visibility tab crashes (Bug #2802).
FIX: In LayerTab.setInvisibleLayerConfiguration() handle unset technologies.

IMP: (6/18/10, FS) Experimental version of SeaOfGatesRouter: New parallel
     infrastructure

************************* Version 9.00h: ******************************

IMP: (6/18/10, FS) Refactored SeaOfGatesRouter to have the possibility to
     create different versions

BUG: (6/18/10, FS) Use 1 evaluation step per minimum in placement tool
     Genetic-2 (Bug #2801)

BUG: (6/16/10, AM) Simulation input file reads correctly but looks
     wrong (Bug #2796)
FIX: Correct the erroneous indexing in HSpiceOut.java.

BUG: (6/16/10, AM) The waveform window comes up with no signals but it
     should have remembered the last ones (Bug #2798).
FIX: Fix long-standing confusion between
     WaveformWindow.showSimulationData() by splitting it into
     showSimulationDataInNewWindow() and refreshSimulationData().

IMP: (6/17/10, SMR) When placing an instance of a cell, holding Control
     forces the instance to be on one of the axes (Bug #2437).

BUG: (6/17/10, SMR) Cannot select ports on layout resistors (Bug #2761).
FIX: Generalized code in Highlighter.distToNode() to handle all layout resistors.

BUG: (6/17/10, SMR) Interactive resizing grid-aligns too much when dragging an edge (Bug #2795).
FIX: In SizeListener.getNewNodeSize() set grid direction if edge-dragging.

IMP: (6/16/10, AM) Add BusSample.

IMP: (6/16/10, AM) Add LatticeOperation (lub/glb), and use that
     instead of min/max to compute summaries.  Complex numbers and
     vectors (aka "buses") don't have a meaningful comparison
     operation, but they do have lubs and glbs.

IMP: (6/16/10, AM) Add Sample.lub() and Sample.glb().

IMP: (6/16/10, FS) Modeling the load balancing of work stealing as a uniform distribution.
     (only debug mode)

BUG: (6/16/10, FS) Use a 1x1 grid as smallest in placement tool: Genetic-2 (Bug #2797)

IMP: (6/15/10, AM) Remove AnalogAnalysis.

BUG: (6/15/10, AM) Waveform window signals no longer saved correctly (Bug #2777)
FIX: Ignore analysis stored in preferences.

IMP: (6/15/10, AM) Remove AnalogSignal (use Signal<ScalarSample>).

BUG: (6/15/10, AM) Various complex-valued simulation data were being
     plotted incorrectly.
FIX: Remember to do a Math.hypot() to compute the amplitude.

IMP: (6/15/10, FS) Adding steal tracker debug to concurrent package
     Add additional test cases for parallel infrastructure

IMP: (6/14/10, FS) Adding common metrics for all placement tools and calculate
     Bounding Box and Minimum Steiner Tree after a placement (only debug mode)

BUG: (6/14/10, AM) Reading HSpice output throws an exception (Bug #2793)
FIX: Remember to update parent pointers after splitting a node.

BUG: (6/14/10, AM) HSpice reader attempts to re-insert value that
     already exists (Bug #2749)
FIX: Check to see if the value has already been inserted.

IMP: (6/12/10, AM) Add and document "Display / Display Control / Dock
     messages window to each edit window" preference (off by default).

IMP: (6/12/10, AM) Allow more than one instance of MessagesWindow.

BUG: (6/11/10, GVG) UnsupportedOperationException while running Placement regression (Bug #2792)
FIX: Don't call param.makeTempSettingReal if running in regression mode.

IMP: (6/11/2010, FS) Add sleep and wake up to thread pool

IMP: (6/10/10, AM) Can now view an analog signal as if it were
digital via thresholding (Bug #2789).

BUG: (6/10/10, AM) Analog waveforms missing icons in upper right (Bug #2784)
FIX: in Stimuli.isAnalog()

BUG: (6/10/10, AM) Title of Waveform window is strange (Bug #2783)
FIX: in WaveformWindow.setTitle().

IMP: (6/10/10, AM) RadixTrie improvements (incomplete).

IMP: (6/10/10, AM) Stub for PageStorageWithDeallocation.

IMP: (6/10/10, AM) Fix CachingPageStorage.fsync(int), remove
     PageStorage.fsync()

IMP: (6/10/10, AM) Replace Infrastructure.waitSeconds() with Thread.sleep()

IMP: (6/10/10, SMR) The Measurement display should have be able to show
     in a user-specified color instead of using the highlight color (Bug #2787).
FIX: Added User.ColorPrefType.MEASUREMENT.

IMP: (6/9/10, FS) Extend CollectionFactory (ConcurrentHashSet, copySet methods)
     add debug possibilities to thread pool (load balancing)

BUG: (6/9/10, SMR) EDIF import places instance parameters too far apart (Bug #2786).
FIX: Fixed Cell.newVarOffset() to place parameters closer together.

IMP: (6/9/10, FS) Add possibility to reset ThreadIDs

IMP: (6/9/10, FS) Add test infrastructure for parallel placement tests

IMP: (6/8/10, FS) Experimental work stealing for parallel infrastructure

IMP: (6/7/10, GVG) Measurement tool and new style (Bug #2785)
Added preference to use Cadence style. Old style by default.

IMP: (6/7/10, SMR) Layer Visibility Configurations are now handled in a
     per-technology fashion (Bug #2758).

IMP: (6/7/10, FS) Add parameter to force directed placement 2

IMP: (6/7/10, FS) New concurrent data structures, circular array, unbounded
   double ended queue

IMP: (6/3/10, DN) Remove Technology.State class to simplify things.
   This class is not necessary because Technologies are immutable now.

************************* Version 9.00g: ******************************

BUG (6/3/10, FS) Bug #2770 fixed through the new bucket work distribution

IMP: (6/3/10, SMR) Added code to ignore hidden node names and reset them
     in the Properties dialog (Bug #2768).

IMP: (6/3/10, FS) Add a new work distribution to ERCWellCheck2
          - add a 2-dimensional view of threads
          - overlay the current cell with an 2-dimensional grid
          - each thread works on one cell of the grid (bucket)

IMP: (6/3/10, DN) The nameDescriptor of NodeInst can be non-displayable (Bug #2768).

BUG: (6/3/10, AM) Verilog simulation not working (Bug #2780)
FIX: Assign ".dump" extension to VerilogOut per Steve's request.

BUG: (6/2/10, AM) Adding panel to waveform window takes a long time (Bug #2776)
FIX: cache bounds in Analysis.java.

BUG: (6/2/10, AM) LT Spice stimuli not reading properly (Bug #2778)
FIX: Be more permissive in parsing the analysis type.

IMP: (6/2/10, AM) Merge LTSpiceOut with RawSpiceOut.

BUG: (6/2/10, AM) Verilog simulation not working (Bug #2780)
FIX: Fix DigitalSample.fromOldStyle().

BUG: (6/2/10, AM) IRSIM is still broken (Bug #2679)
FIX: Check for reinsertions in Analyzer.java

BUG: (6/2/10, AM) SmartSpice not reading (Bug #2779)
FIX: ".txt" is now handled by SmartSpiceOut

BUG: (6/2/10, GVG) NPE while importing Cadence errors with no current cell (Bug #2781)
FIX: Detecting the case when no current cell is selected.

BUG: (6/2/10, AM) Crash reading simulation data (Bug #2775)
FIX: Check for reinsertions in HSpiceOut.java.

BUG: (6/2/10, AM) The command "Plot Spice for This Cell" no longer
     works (Bug #2773)
FIX: Total overhaul of Simulate.java.

BUG: (6/1/10, AM) ALS needs Signal to be able to alter samples after
     they have been added (Bug #2679)
FIX: Add BTree.remove() and BTree.replace().

IMP: (6/1/10, AM) Implement BTree.remove().

IMP: (5/29/10, AM) Finish implementing hierarchical "undriven nets
     check".  Marina full-chip schematics pass except for
     arrays-of-cell-instances, which the netlister does not seem to
     handle properly.

IMP: (5/29/10, AM) Network.java: when determining connectivity, check
     all wires of a bus instead of only using the 0th wire.

IMP: (5/28/10, AM) Use EquivalenceClasses in undriven nodes check.

IMP: (5/28/10, AM) Add EquivalenceClasses.

IMP: (5/28/10, AM) Add ability to open simulation data from command line.

BUG: (5/28/10, GVG) NPE in cross library copy (Bug #2771)
FIX: Detecting when cell doesn't longer have a group.

IMP: (/5/28/10, GVG) Unknown tag in Client.read() (Bug #2759)
Added extra code to detect the source of the unknown tag

IMP: (5/27/10, SMR) New EDIF Preference to hide arc or node names (Bug #2768).

IMP: (5/27/10, DN) The nameDescriptor of ArcInst can be non-displayable (Bug #2768).

IMP: (5/25/10, DN) Technologies are immutable - new Technology objects are used if technology parameters are changed.
   Can be disabled by Tecyhnology.IMMUTABLE_TECHS = false;

IMP: (5/25/10, SMR) New "Display Control" Preference to keep modeless
     dialogs on top (Bug #2767).

IMP: (5/24/10, FS)
     - Use new parallel infrastructure in ERC Well Check Tool
     - Refactoring of ERC Well Check Tool

BUG: (5/24/10, SMR) Merging LEF and GDS fails (Bug #2765).
FIX: Do not copy node names when creating exports.

BUG: (5/24/10, SMR) LEF input gives errors on some ANTENNA keywords (Bug #2764).
FIX: Added these keywords to the ignore list.

BUG: (5/24/10, SMR) Multi-object Properties crashes when in resize mode (Bug #2763).
FIX: Fixed Highlight.HighlightSorting class to handle null returns from "getInfo()".

IMP: (5/24/10, SMR) New "Display Control" preference "Shift window to show errors"
     moves the window to focus on errors if they are not visible (Bug #2755).

BUG: (5/24/10, SMR) Greeked cells are not re-evaluated when layer visibility changes (Bug #2756).
FIX: Fixed VectorCache and VectorDrawing to recompute the cell color.

IMP: (5/24/10, FS) First refactoring (improved interface)
     features: parallel (for|reduce), and simple task scheduler for own algorithms

IMP: (5/21/10, FS) First commit of a parallel infrastructure,
     com.sun.electric.tool.util.concurrent

************************* Version 9.00f: ******************************

BUG: (5/21/10, GVG) False DRC errors on tsmcsun40gp poly resistors (Bug #2762)
FIX: Special case to detect network associated to poly in resistors.

IMP: (5/20/10, SMR) Initial version of Gerber reader.  Has Preferences panel for
    some controls (Bug #2749).

IMP: (5/20/10, GVG) Error window in TechEditorWizard in case of loading Parameters file that
doesn't comply with format.

BUG: (5/18/10, SMR) Small arcs of a circle may draw as full circles (Bug #2757).
FIX: Fixed PixelDrawing.drawCircleArc().

BUG: (5/18/10, GVG) Some layers have wrong default visibility settings for layer visibility groups (Bug #2753)
FIX: Make sure top layers are defined as overglass in the 40nm tech

BUG: (5/18/10, FS) Bug #2746
IMP: - Cache networks and transistors for faster progress
     - handle more then two transistors per network

BUG: (5/17/10, GVG) Still null messages in jobs (Bug #2747)
FIX: Pref values cached before ExternalScript is executed.

IMP: (5/17/10, DN) Minor changes in Added Design Summary code from GNU user (Bug #2734).
   - Skip icon of parent and Generic primitives
   - Better diagnostics when library has no fileURL
   - Clean comments

BUG: (5/12/10, FS) Bug #2746
FIX: Fixed for small chips

BUG: (5/7/10, SMR) Schematic DRC missing wire and bus arcs connected
     at a bus pin but not really connected (Bug #2748).
FIX: Now reported.

BUG: (5/7/10, SMR) Schematic DRC missing arcs touching if they are labeled (Bug #2748).
FIX: Also check for unconnected pins laying on an arc.

IMP: (5/5/10, AM) Add skeleton of RadixTrie (a Map<String,V> that
     maintains the statistics needed to detect the hierarchy
     separator).

IMP: (5/5/10, AM) Finally remove Signal.getAnalysis() for good.

BUG: (5/4/10, SMR) AutoStitch gives errors and fails to correctly route bus ports (Bug #2745).
FIX: AutoStitch.testPoly() handles busses separately when deciding whether or not ports
     are already connected.  It also has a bug in which it fails to report that it has made
     a connection.  Other fixes in InteractiveRouter.planRoute(), RouteElementArc.doAction().

BUG: (5/3/10, GVG) Autostitch creating 2 arcs when connecting bus ports in icons (Bug #2745)
FIX: Calling getNetwork(Nodable no, Name portName) in case of busses (temp fix)

IMP: (5/01/10, AM) Merge EpicOutProcess and EpicAnalysis into
     EpicOut.java (which follows the same naming convention as the
     rest of the simulation output readers).

IMP: (5/01/10, AM) Add Signal.extrapolateToRight to avoid more calls
     to Signal.getAnalysis().

IMP: (5/01/10, AM) Turn WaveformWindow.treePathFromAnalysis into
     treePathFromSignal.

IMP: (5/01/10, AM) Add Signal.getAnalysisType(), first step towards
     removing Signal.getAnalysis().

IMP: (4/30/10, JKG) Removed spacebar toggle of fat wiring mode, as it is now a preference.
Substrate and well contacts included in as contacts for finding width of connecting wire.
Ignore default-sized arcs when choosing arc size to connect to portinst,
as RouteElementArc.doAction creates default-sized arcs for 0 length connections.

************************* Version 9.00e: ******************************

BUG: (4/30/10, SMR) Interactive resizing of multiple nodes doesn't work right
     when they are different size (Bug #2732).
FIX: Fixed SizeListener.getNewNodeSize().

IMP: (4/29/10, SMR) Component menu now remembers the which variation of a node
     is selected (Bug #2741).

BUG: (4/28/10, SMR) Constraint system does not keep alignment between nodes
     and moves too much (Bug #2736).
FIX: In LayoutCell.java, scale sizes more uniformly (in transformByPort())
     and allow nodes to stay where they are if slidability can be done.

BUG: (4/28/10, SMR) Autostitch makes arcs that are not grid-aligned (Bug #2740).
FIX: Added alignment to AutoStitch.AutoStitchJob constructor and fixed bug
     in InteractiveRouter.getClosestValue().

IMP: (4/27/10, AM) Remove MultiSweepSignal.
IMP: (4/27/10, AM) Remove AnalogSignal.getIndexInAnalysis()

BUG: (4/27/10, SMR) Bean Shell cannot access currently highlighted objects (Bug #2739).
FIX: Added EvalJavaBsh.getHighlighted() to access the list from inside a Job.

IMP: (4/26/10, AM) Waveform viewer Panel no longer has a hardwired
     analysis type (will accept a Signal from any Analysis).

IMP: (4/26/10, JKG) Set netlist nonstandard cells to false for runSTA command.
Changed verilogA option to false for STA runs when writing verilog netlist.

BUG: (4/26/10, GVG) Exception when running STA (Bug #2738)
FIX: Caching Verilog Preference in RunPrimeTime constructor now.

BUG: (4/26/10, SMR) PostScript output does not handle background color (Bug #2735).
FIX: In color mode, fill background color.

BUG: (4/25/10, AM) Spice input crashes (Bug #2727)
FIX: Remove special-purpose code in HSpiceOut, use general-purpose code
     from BTreeSignal.

IMP: (4/25/10, AM) AnalogSignal extends ScalarSignal.

IMP: (4/25/10, AM) Allow null keys in getSummaryFromKeys() when one or
     both ends of a range are unbounded.

IMP: (4/19/10, SMR) Added Design Summary code contributed by GNU users.
     The command is "Cell|Cell Info|Summarize Cell Contents" (Bug #2734).

BUG: (4/22/10, SMR) The ruler should have tick marks (Bug #2718).
FIX: Redid MeasureListener to draw Cadence-like rulers.

BUG: (4/22/10, SMR) Text Properties dialog changes non-centered text on rotated nodes (Bug #2733).
FIX: Ignore code in PolyBase.unRotateType() which is not needed since Bug #2635.

BUG: (4/21/10, GVG) Adding pure layer nodes in palette and those warning messages (Bug #2726)
FIX: Added PrimitiveNode instances into tech.pureLayerNodes while parsing XML tech.

IMP: (4/21/10, JKG) Added menu commands to wire up and down one layer in layout

IMP: (4/21/10, SMR) Can now resize multiple nodes and multiple arcs (Bug #2732).

BUG: (4/21/10, DN) Netbeans build doesn't create manifest.
FIX: Add "trunk/srcj/manifest.mf" template.

IMP: (4/20/10, GVG) TechEditorWizard: better handling of asymmetric rules (Bug #2656)
Added WizardRuleFields class which should be the first step for this request.

IMP: (4/19/10, DN) More strict checking in ImmutableArcInst.newInstance and ImmutableArcInst.withAngle.

BUG: (4/19/10, SMR) Undefined arc angles still cause trouble (Bug #2729).
FIX: Added new ArcInst and ImmutableArcInst methods: getDefinedAngle() which
     returns 0 instead of -1.

IMP: (4/19/10, DN) Experimental "Cell|Cell info|Design Summary" command (only in -debug mode).

BUG: (4/19/10, DN) Placement of pure layer nodes inconsistent with highlighter (Bug #2730)
FIX: Set correct center in "Fix highlighting when place asymmetrical primitive" on 4/13/10

BUG: (4/19/10, DN) Slidable arc should slide along contact array (Bug #2728).
FIX: In CircuitChangeJob.ManyMove.doIt don't move a node on head/tail of slidable arc if it is still in port.

BUG: (4/16/10, GVG) Placement of pure layer nodes inconsistent with highlighter (Bug #2730)
FIX: Undone ""Fix highlighting when place asymmetrical primitive" on 4/13/10

************************* Version 9.00d: ******************************

BUG: (4/16/10, GVG) F-P-Well contact size broken in tsmcSun40GP (Bug #2725)
FIX: SizeOffset for p well contact in a substrate process corrected.

BUG: (4/16/10, DN) Slidable arc should slide along contact array (Bug #2728).
FIX: In CircuitCHangeJob.ManyMove.doIt don't move a node on head/tail if it is still in port.

IMP: (4/15/10, SMR) First pass of generalized routing framework (Bug #2724).

BUG: (4/15/10, GVG) DRC error when diff contact serves two transistors of diff sizes (Bug #2683)
FIX: Undoing "Better solution for "false drc error between pdiff contacts in
tsmcsun40GP (Bug #2311)" for now.

BUG: (4/14/10, GVG) NPE in TechPool.getThreadTechPool (all regressions) (Bug #2723)
FIX: Removed Technology.findTechnology in TechFactory.newInstance. Added extra
code to detect if a new soft tech has same name as a pre-defined one.

BUG: (4/14/10, SMR) Multiple technologies with the same name are not detected (Bug #2714).
FIX: Detect this both for built-in and added technologies.

BUG: (4/13/10, SMR) Verilog reader throws exceptions on bad Verilog (Bug #2722).
FIX: Catch errors more gracefully.

IMP: (4/12/10, JKG) Added Verilog option to write non-standard cells when writing standard cell netlist.

BUG: (4/7/10, DN) The ruler text is too small (Bug #2718).
FIX: In EditWindow.paintComponent select font for rule text with size 15*globalTextScale instead of 10*globalTextScale.

IMP: (4/8/10, GVG) Added more error messages to detect failures in gateLayGen regression (Bug #2717)

BUG: (4/8/10, GVG/SMR) New zero-length def of arcs and non-Manhattan shapes (Bug #2720)
FIX: ImmutableArcInst:isManhattan() and ImmutableArcInst:makeGridBoxInt handle angle=-1
(introduced by Bug #2713)

BUG: (4/7/10, SMR) The "Measure" cursor is ambiguous (which side is the pointer?)
     and the measurement mode should snap the mouse when moving around (Bug #2718).
     Measurement snapping-control is now in the "Grid" Preferences.
FIX: The cursor now looks like a tape measure; the mouse snaps.

IMP: (4/6/10, SMR) Zero-length arcs can stretch in either direction (Bug #2713).

BUG: (4/6/10, SMR) Invisible Pins under Annotation Text should be selectable (Bug #2712).
FIX: These pins are now "hard to select" and can be selected when in that mode.

BUG: (4/5/10, SMR) Option reconciliation truncates fields (Bug #2709).
FIX: Put full string into tooltip.

************************* Version 9.00c: ******************************

IMP: (4/2/10, GVG) Two new layers in 40nm

BUG: (4/2/10, DN) Changes in MoCMOS parameters don't immediately redisplay (Bug #2708).
FIX: In PreferencesFrame.OKUpdate.terminateOK call cloaseDialog(null).

BUG: (4/1/10, SMR) Exiting technology editor destroys its own colormap (Bug #2706).
FIX: Detect technology-editor color maps in PixelDrawing.

IMP: (3/31/10, SMR) Added VerilogA output with "Tools / Simulation (Verilog) /
     Write VerilogA Deck..." command (Bug #2705).

BUG: (3/31/10, SMR) Parasitic preferences has User and Project preferences swapped (Bug #2701).
FIX: Swapped the panels.

BUG: (3/31/10, DN) Key Q doesn't work properly in Cadence color scheme (Bug #2704).
FIX: Replace short cut for "Cycle Windows" in Cadence color scheme from 'Q' to 'W'.

BUG: (3/29/10, DN) Array indices are not being generated correctly (Bug #2703).
FIX: In Array.makeArray compare objects by STRING_NUMBER_ORDER.

IMP: (3/29/10, GVG) Amending tsmcSun40GP.xml and TechEditorWizard regression due to Bug #2702 changes.

BUG: (3/29/10, DN) Technology Wizard doesn't write gate_contact_spacing to DRC deck (Bug #2702).

FIX: In TechEditWizardData.addStandardElements write spacing rules.

BUG: (3/28/10, DN) Fill generation failed.
FIX: In CapCell use parameters for Well contact (not diffusion contact).

IMP: (3/25/10, DN) Select layers in generator.layout.TechType by function (Bug #2696).
    Almost all values in TechType subclasses are initialized from technology and DRC deck .

BUG: ConcurrentModificationException in gate generator (Bug #2700).
FIX: In NetSchem.updateSchematic fix a test that old Netlist is still valid.

BUG: Layer order not restored with preferences (Bug #2699).
FIX: In UserInterfaceAll.loadPreferences call LayerVisibility.loadPreferences.

IMP: (3/35/10, GVG) Compaction regression and changes in API (Bug #2633)

BUG: (3/25/10, GVG) NPE if layer is not found by name (Bug #2698)
FIX: Just detect the case and allow to catch any exception in writeXML()

BUG: (3/25/10, DN) Technology Wizard crashes in GDS panel after adding metal layer (Bug #2697).
FIX: In TechEditWizardData.setNumMetalLayers initialize "metal_layers" correctly.

IMP: (3/25/10, DN) Add command "Tool|Generation|Generate gate layouts (C_urrent tech)" (Bug #2696).

IMP: (3/25/10, DN) Remove TechTy.eTechTypeNum (Bug #2696).

IMP: (3/24/10, DN) gateLayRegression compares output and original JELIBs (Bug #2696).

BUG: (3/23/10, GVG) TechEditWizard not cleaning previous values uploaded from a txt file (Bug #2695)
FIX: Clearing the variables before the reading operation.

BUG: (3/22/10, DN) Copy crashes when from old schematic view (Bug #2694).
FIX: In Snapshot.reuseSchemId allow null oldSchemEq in groups with many schematic cells.

BUG: (3/22/10, AM) Implement SignalDifference(Signal,Signal) (Bug #2476)
FIX: Add DerivedSignal.  See DebugMenuAdam for example code.

IMP: (3/22/10, AM) Remove special-case handling of AnalogSignal in Panel.java

BUG: (3/22/10, SMR) Crash when referenced library is missing (Bug #2693).
FIX: In LibraryFiles.readExternalLibraryFromFilename() do not call
     getOpenFileType() if the file is not valid.

BUG: (3/22/10, SMR) Showing errors while editing down-in-place may shift
     the window (Bug #2690).
FIX: In UserInterfaceMain.reportLog() handle down-in-place transformation when
     checking for error visibility.

BUG: (3/22/10, SMR) Assertion error when primitive port does not connect (Bug #2692).
FIX: Removed assertion in User.getArcNamesSorted().

BUG: (3/21/10, DN) Project settings / external technology (Bug #2124, #2687).
FIX: Move initialization of SoftTechnologies to Environment.implementSettingsChanges.

************************* Version 9.00b: ******************************

IMP: (3/21/10, AM) Use monoid min/max code for waveform rendering.
     See demo at http://www.youtube.com/watch?v=0-5h60nOOzQ

IMP: (3/21/10, AM) Fixed many bugs in monoid summary code.  Appears to
     work now.

BUG: (3/18/10, GVG) NPE after re-exporting an ErrorLogger that contains invalid cells (Bug #2691)
FIX: Detecting case when cellId is null. Adding stack trace in debug mode.

IMP: (3/18/10, SMR) When pasting cell instances, should convert the view
     so that layout instances become icons when pasting into a schematic cell
     and icon instances become layout instances when pasting into a layout
     cell (Bug #2381).
FIX: Added new Node Preference to do this.  "Convert between schematic and
     layout when pasting" is on by default.

BUG: (3/18/10, DN) CIF/GDS output doesn't merge boxes (Bug #2689).
FIX: In io.output.Geometry.Visitor.exitCell add "gMerge.postProcess(true);".

IMP: (3/17/10, AM) Finish range query support.  Still a few bugs.

BUG: (3/17/10, DN) "-client" option doesn't work.
FIX: Add Main.InitClient Job.

BUG: (3/16/10, DN) Crash after creating new technology (Bug #2686).
FIX: Add WindowContents.loadTechnologies() and load it after TechPool change.

BUG: (3/15/10, SMR) Want to add pure-layer nodes to component menu (Bug #2685).
FIX: Added a list of pure-layer nodes in the Technology XML data structures.

IMP: (3/15/10, DN) First variant of multi-threaded JELIB/DELEB reader in
     "File|Import|Fast JELIB Reader|Database" (enabled only in -debug mode).

IMP: (3/14/10, DN) Refactor LibraryFiles.readExternalLibraryFromFilename to use from new JELIB reader.

IMP: (3/13/10, DN) Add method "Netlist.getNetwork(Nodable no, Name portName)" (Bug #2533).

BUG: (3/13/10, DN) "VIA{x,y,z}.W.1" not valid for artwork arc? (Bug #2682).
FIX: If Jelib file contains invalid arc name, put it into ART_message Variable.

BUG: (3/10/10, SMR) CIF input fails on some cell instances (Bug #2684).
FIX: Use lists instead of linked-lists so that objects are processed in proper order.

BUG: (3/9/10, DN) Exception in regression due to private in EditingPreferences (Bug #2681).
FIX: In PrefPackage.putPrefs insert "field.setAccessible(true)".

IMP: (3/9/10, DN) Encapsulate fields in EditingPreferences (Bug #2672).

IMP: (3/8/10, GVG) Add OD18ud15 Transistors to the 40nm tech (Bug #2680)

IMP: (3/8/10, AM) Finish implementation of MinMaxOperation.

IMP: (3/7/10, AM) Start using MinMaxOperation.

IMP: (3/7/10, AM) Add skeleton for MinMaxOperation.

IMP: (3/7/10, AM) Re-enable summary update on BTree.insert()

IMP: (3/7/10, AM) Re-enable LeafNodeCursor.getSummary().

IMP: (3/7/10, AM) BTree.java: let REPLACE specify the old value;
     enables one-pass replacements.

IMP: (3/7/10, AM) Add InvertibleOperation.

IMP: (3/6/10, AM) DigitalSignal: add support for varying drive strength.

************************* Version 9.00a: ******************************

IMP: (3/3/10, GVG) Ability to define exports per cell in Stitch fill gen (Bug #2677)
Option format: e[layerN1;layerN2;...;layerNn]

IMP: (3/3/10, AM) DigitalSignal extends BTreeSignal<DigitalSample>

IMP: (3/3/10, AM) DigitalSample implements Comparable.

IMP: (3/3/10, AM) Move getTree() from ScalarSignal to BTreeSignal.

IMP: (3/3/10, AM) Create new subclass ScalarSignal of BTreeSignal,
     make BTreeSignal package-private.

IMP: (3/3/10, AM) Add Unboxed instances to subclasses of Sample.

IMP: (3/3/10, AM) Add DigitalSample.

IMP: (3/3/10, AM) Add UnboxedByte.

IMP: (3/3/10, GVG) Ability to define exports per cell in Stitch fill gen (Bug #2677)
Part of the implementation.

BUG: (3/2/10, DN) "Fat mode" option can't be turn off in Arcs pref (Bug #2672).
FIX: Temporary solution: Remove "final" attribute from annotated fields of EditingPreferences.

BUG: (3/2/10, SMR) ALS cannot simulate transistors (Bug #2674).
FIX: Redid "GenerateVHDL.java" to handle layout transistors correctly.

IMP: (3/1/10, SMR) Placement preferences now allows algorithm-specific
     parameters (Bug #2673).

BUG: (2/26/10, GVG) DRC fails when transistor has more than 1 active layer (Bug #2669)
FIX: Condition removed for carbon-nanotube transistors.

BUG: (2/26/10, GVG) 3D View doesn't allow transistors with more than 2 active regions (Bug #2670)
FIX: Detecting CN transistors now whose active layers are not merged

IMP: (2/26/10, GVG) -debug and -regression don't work very well (Bug #2668)

BUG: (2/25/10, DN) Icon vs sch ports (Bug #2533).
FIX: In NetSchem connect exports by Name instead of by portImplementation.

BUG: (2/25/10, GVG) NPE in Preferences -> Technology -> Icon
FIX: Switch IconTab from Frame to PreferencesFrame constructor

IMP: (2/24/10, AM) Rename Approximation->View, add
     Signal.getRasterView() which returns a RangeSample

IMP: (2/24/10, AM) Add RangeSample.

IMP: (2/24/10, AM) Sample does not implement Comparable (but
     ScalarSample does).

IMP: (2/24/10, AM) Remove old Waveform.java methods.

IMP: (2/24/10, AM) Remove "using old/new code" marker on waveform window.

IMP: (2/24/10, AM) Merge Waveform.java into Signal.java.

BUG: (2/18/10, GVG) Electric litters files in my home directory without
     my permission (Bug #2613)
FIX: Not using File.createTempFile for now.

IMP: (2/17/10, AM) Remove SignalSimpleImpl.

IMP: (2/17/10, AM) Rename SimulationSample to Sample.

IMP: (2/17/10, AM) Remove WaveformImpl and ComplexWaveform, add ComplexSample.

BUG: (2/17/10, AM) Plotting Spice output from the cell (not a file) fails (Bug #2665).
FIX: Try all file types.

BUG: (2/17/10, SMR) Plotting Spice output from the cell (not a file) fails (Bug #2665).
FIX: When doing this, use the Spice Preference to determine the engine.

BUG: (2/17/10, SMR) SVG output not right (Bug #2664).
FIX: Now handles underline, centers on page, and has a test.

IMP: (2/16/10, AM) Merge NewSignal.java and Signal.java

IMP: (2/16/10, AM) Remove ArchSimOut.java

IMP: (2/16/10, AM) Separate "Signal" from "Stimuli".

IMP: (2/15/10, AM) Remove old Epic reader.

IMP: (2/15/10, AM) When reading in SPICE output files, detect the
     "flavor" automatically.  Now the user no longer has to change
     his/her preferences in order to read in simulation files.

BUG: (2/15/10, AM) Electric litters files in my home directory without
     my permission (Bug #2613)
FIX: Stop littering.

************************* END OF Version 8.11, GNU RELEASE *************
************************* Version 8.11e: ******************************

IMP: (2/15/10, AM) Fix repaint logic in EditWindow to comply with
     guidelines which distinguish "System-triggered" painting from
     "App-triggered" painting; see
     http://java.sun.com/products/jfc/tsc/articles/painting/#triggers
     for further details.

BUG: (2/14/10, SMR) Technology editor can't edit TFT technology (Bug #2663).
FIX: Allow metal1/metal2 instead of poly/active in transistor detection.

BUG: (2/14/10, GVG) Make command doesn't include helphtml/*.jelib and *.txt (Bug #2655)
FIX: Manual files not filtered by junk command

BUG: (2/14/10, GVG) Wrong location of silicide block and hi-res layers in analog resistors (Bug #2658)
FIX: Database amended yet. Considered as done.

BUG: (2/14/10, DN) Assertion error after technology editor makes new technology (Bug #2662).
FIX: Don't modify in LayerInfo.parseCell an reference to internal rectanle returned by ni.getBounds.

BUG: (2/13/10, DN) Crash when reconciling preferences (Bug #2661).
FIX: Update MoCMOS.getPatchedXML because previously <menuNode>Poly1-Poly2-Capacitor</menuNode>
    was replaced by <menuNodeInst protoName="Poly1-Poly2-Capacitior"...>.

BUG: (2/12/10, SMR) Crash in Vector drawing algorithm (Bug #2660).
FIX: Detect null cell in VectorCache.VectorCell.initTopOnlyShapes().

BUG: (2/12/10, DN) Importing GDSMap twice causes a crash (Bug #2659).
FIX: In GDSMap keep savedAssoc in Preferences instead of Prefs.

BUG: (2/12/10, GVG) More stuff for Bug #2658
FIX: mocmos.xml was re-generated. Database hasn't been amended yet.

BUG: (2/12/10, DN) IllegalStateException when importing GDS Map file (Bug #2657).
FIX: In GDSMap.java create OKUpdate Job to save map preferences on server side.

BUG: (2/12/10, DN) NotSerializableException for ImmutableArcInst (Bug #2652).
FIX: Remove "EditingPreferences ep" from IconParameters.

BUG: (2/11/10, GVG) Part of "Wrong location of silicide block and hi-res layers in analog resistors" (Bug #2658)
FIX: Changes in TechEditWizardData for now. mocmos.xml must be re-generated

IMP: (2/11/10, GVG) Better error if test library is not found in electric.jar (Bug #2653)

BUG: (2/11/10, SMR) Need fixes to Red and Purple libraries (Bug #2651).
FIX: Updated.

BUG: (2/11/10, SMR) Error highlighting fails when done in same cell (Bug #2646).
FIX: Fixed UserInterfaceMain.reportLog() to use proper window.
     Also fixed pulsating highlighting in EditWindow so that it uses proper
     paint() methods, and made it NOT the default.

BUG: (2/11/10, SMR) Placement regression fails (Bug #2650).
FIX: Make test request Min-Cut algorithm.

BUG: (2/10/10, DN) Routing regressions make fat wires.
FIX: Make fatWire and explicite field of InteractiveRouter.

IMP: (2/10/10, SMR) Added new placement code from Karlsruhe (Bug #2649).

BUG: (2/10/10, DN) Crash in ProjectTool initializer.
FIX: Make iconParameters alocal variable instead of static one.

IMP: (2/10/10, DN) Move plugins.menus.ScanChainXML into tool.simulation.test .

IMP: (2/10/10, DN) Refactor plugins.sctiming.SCRun into
    tool.simulation.sctiming.SCRunBase and plugins.sctiming.SCRun .

BUG: (2/9/10, SMR) Color PostScript ignores text color (Bug #2624).
FIX: PostScript.psText() now uses text color.

BUG: (2/9/10, SMR) Crash simulating layout resistors in IRSIM (Bug #2397).
FIX: In IRSIM.createBucket() handle missing values.

BUG: (2/8/10, SMR) Layer drawing does not update screen when exports visibility changes (Bug #2648).
FIX: Have LayerDrawing.visibilityChanged() return true instead of false.

IMP (2/4/10, GVG) electric litters files in my home directory without my permission (Bug #2613)
Two new user preferences added: (1) to enable logging (2) to generate multiple logs.
Back to original strategy for logfile paths. See details in Bug #2613.

BUG: (2/4/10, SMR) Exports on rotated nodes draws wrong (Bug #2635).
FIX: Undid change made for Bug #2622; made PolyBase.rotateType() do nothing;
     made Poly.transform() do no text rotating; and made
     CircuitChangeJobs.RotateSelected.doIt() rotates Export text.

BUG: (2/4/10, GVG) NPE in min size layer rule if it didn't exist before (Bug #2647)
FIX: Detect if the rule existed before trying to remove it from the map.

IMP: (2/3/10, GVG) Remove PIE plugin and any reference to it (Bug #2645).

BUG: (2/3/10, SMR) Renaming schematic exports should rename ALL icon exports (Bug #2644).
FIX: Fixed in Export.rename().

BUG: (2/3/10, SMR) Verilog netlisting emits strange module names (Bug #2631).
FIX: Added a Verilog Preference "Write Separate Module for each Icon" which is
     FALSE by default (the old behavior).  Also fixed strange cell names
     (with three underscores).  Also made Spice NOT write separate modules for
     each icon.

BUG: (2/3/10, SMR) Well check should not run on schematics (Bug #2642).
FIX: Disable on non-layout cells.

IMP: (2/2/10, SMR) Converted "Cell.acquireUserNetlist()" and
     "Cell.getUserNetlist()" to be "Cell.getNetlist()" (Bug #2641).

IMP: (2/2/10, SMR) Removed "build.xml" from packaging (Bug #2640).

IMP: (2/2/10, SMR) Fixed copyright in tool.simulation.test and database.geometry.btree (Bug #2639).

IMP: (2/2/10, SMR) Removed obsolete simulator: ArchSim (Bug #2638).

BUG: (2/1/10, SMR) Carbon nanotube technology causes assertion failure (Bug #2637).
FIX: Fixed assertion in AbstractShapeBuilder.genShapeOfNode().

BUG: (2/1/10, SMR) "Change" fails when ports are coincident (Bug #2536).
FIX: Fixed NodeInst.portAssociate() to handle coincident ports.

BUG: (1/29/10, GVG) Client's protocol version incompatible with Server's protocol version (Bug #2630)
FIX: Project tool can't call IconParameters.makeInstance() with true.

BUG: (1/28/10, GVG) Assertion in Verilog running in debug mode (Bug #2634)
FIX: No checking port names for supplies

IMP: (1/28/10, SMR) Added first pass of SVG export (Bug #2003).

IMP: (1/28/10, GVG) Accessing many user values in Make Export (Bug #2630)
Important refactorization due to icon preferences used in new exports.

BUG: (1/28/10, SMR) Technology editor fails to identify objects (Bug #2632).
FIX: Use correct database in Manipulate.getLayerCell().

************************* Version 8.11d: ******************************

BUG: (1/26/10, SMR) Autostitch missing some arcs (Bug #2628).
FIX: Rearrange order of elimination tests in AutoStitch.testPoly().

BUG: (1/26/10, SMR) Cell groups with multiple icons should netlist with
     multiple copies of the schematic (Bug #1957).
FIX: Changed Topology.java to handle this (added writeCopyForEachIcon()) and
     modified Spice and Verilog to use it.

BUG: (1/26/10, GVG) NPE in PS export (Bug #2623) (another fix)
FIX: Detect the null case and assign corresponding TextDescription default for exports.

IMP: (1/26/10, GVG) Keeping suffix ".log" for Electric's logfiles (Bug #2613)

BUG: (1/25/10, GVG) SeaOfGate router should not depend on NotUsed elements (Bug #2508)
FIX: NODSIZE indices not longer overlap with single layer indices. See more details in report.

BUG: (1/25/10, SMR) NCC should respect the "Display Preference" to keep
     cells in the same window (Bug #2572).
Fixed in HighlightTools.getHighlighter().

BUG: (1/25/10, SMR) Setting the Display Preference to keep cells in the same
     window is not respected when browsing through errors (Bug #2573).
FIX: Use the Display Preference for error browsing.

BUG: (1/25/10, SMR) Change dialog still gives popup error messages for every node
     that fails to change (Bug #2618).
FIX: Show just one popup at the end.

MAN: (1/25/10, GVG) NCC gets confused with two lay cells in the same group (Bug #2627)
Added comment in NCC manual.

BUG: (1/22/10, GVG) Runtime exception in LoadImage to create logos in Layout (Bug #2626)
FIX: Added extra code to check if file format is valid (png, jpeg so far)

IMP: (1/21/10, GVG) Message in MessagesWindow that a print job is running even though there is no
way to know if it is printing to file.

BUG: (1/21/10, GVG) NPE in PS export (Bug #2623)
FIX: Detect the null case and assign TextDescriptor.EMPTY

BUG: (1/21/10, SMR) Export text on rotated nodes reads wrong (Bug #2622).
FIX: In Export.getNamePoly(), adjust coordinates properly.

BUG: (1/21/10, SMR) Resizing a cell instance crashes (Bug #2621).
FIX: Prevent the crash and disallow the sizing.

IMP: (1/21/10, AM) Per Gilda's request, uniquify log file name and
     print it in the messages window on startup. Related to Bug #2613

IMP: (1/21/10, GVG) Ability to save text in MessagesLog to a file (Bug #2620)
     Only available in debug mode.

BUG: (1/20/10, SMR) Change dialog gives popup error messages for every node
     that fails to change (Bug #2618).
FIX: Show just one popup at the end.

BUG: (1/20/10, DN) Arc creation is very slow (Bug #2615).
FIX: Replace ArcInst.makeInstance by ArcInst.newInstance without checking that arc ends are in PortInst's polys.

BUG: (1/20/10, GVG) SeaOfGates not considering spacing rule in the "to" surround
FIX: Extra code added. It didn't affect the regression

BUG: (1/20/10, SMR) Auto-stitcher making too many arcs (Bug #2617).
FIX: Force it to use proper layer and prevent wide arcs from expanding coverage in cells.

************************* Version 8.11c: ******************************

BUG: (1/19/10, GVG) "Hi-Res-Poly2-Resistor not properly check in MoCMOS.getPatchedXml (Bug #2616)
FIX: Name corrected in function. This element was not properly marked as "notUsed".

BUG: (1/19/10, GVG) Not counting properly analog elements found in MoCMOS.getPatchedXml()
FIX: Removing null elements before counting.

IMP: (1/17/10, AM) Enable dotted/dashed lines in plots (for
     black+white publications).  Clean up handling of panel aspect
     ratios.  Disable "plot as PDF" because the gnuplot pdf driver is
     unreliable; use "plot as PS" instead and ps2pdf.

BUG: (1/17/10, AM) Electric litters files in my home directory without
     my permission (Bug #2613)
FIX: In ActivityLogger, use java.io.tmpdir instead of $HOME.

IMP: (1/16/10, AM) Waveform plotting: support for: multiple panes,
     multiple waves per pane, using user's colors for plotted waves,
     using user's names for plotted waves, x-axis label.

BUG: (1/16/10, DN) Assertion Exception in netlist/network tool (Bug #2611).
FIX: In NetSchem.updateSchematic clear map exportNameMapOffsets.

************************* Version 8.11b: ******************************

IMP: (1/15/10, GVG) Ability to specify exports in top layers (Bug #2610).
New syntax: "@exports = {layerName1, layerName2}

BUG: (1/14/10, GVG) ConcurrentModificationException in Netlist.checkForModification from Stitch job (Bug #2609)
FIX: Modifications are cached now before running the actual changes.

BUG: (1/14/10, GVG) FillCell not working with SeaOfGates option (Bug #2608)
FIX: Remove the condition only for PortProto == Export.

BUG: (1/14/10, GVG) NPE in getBasePort (Bug #2607)
FIX: Detected invalid exampleHigh in Highlighter.getSimiliarHighlight(). Added extra assertion to future cases.

BUG: (1/14/10, GVG) Runtime exception in fill if it was run with a diff tech before (Bug #2606)
FIX: Static final dependencies removed.

BUG: (1/14/10, GVG) Some preference causes NCC to fail (Bug #2604)
FIX: Fixed rounding issue in sizes match for the absolute value.

BUG: (1/14/10, SMR) Getting ports and arcs on network is very slow (Bug #2590).
FIX: Now using bulk methods Netlist.getArcInstsByNetwork() and Netlist.getPortInstsByNetwork() .

IMP: (1/14/10, DN) Self-test of a method "Netlist.getNetwork(Name exportName);" (For Bug #2533).

BUG: (1/13/10, GVG) NPE in CelLFile with one contact as cell (Bug #2605)
FIX: Detecting when # of gnds is not availabel (capCell==null). Similar to fix for vdds.

BUG: (1/13/10, GVG) NPE in VectorCache while renaming library whose cell was displayed (Bug #2589)
FIX: Nothing fixed since it is hard to reproduce. Added extra code to detect the case.

BUG: (1/13/10, GVG) Undo/Redo history is partially lost after undoing "SaveLibrary" (Bug #2539)
FIX: Implementd Dima' suggestion.

BUG: (1/13/10, GVG) overlapping metal arcs not detected (Bug #2567)
FIX: Undoing again the changes. See Bug #2567 for details.

BUG: (1/12/10, DN) Getting ports on network is very slow (Bug #2590).
FIX: Create a method Netlist.getArcInstsByNetwork() .

BUG: (1/12/10, SMR) Preferences window is too small on JDK 7 (Bug #2554).
FIX: In PreferencesFrame constructor, invoke pack() in a new thread.

IMP: (1/12/10, SMR) Updated built-in Purple/Red/Orange libraries (Bug #2603).

BUG: (1/12/10, GVG) overlapping metal arcs not detected (Bug #2567)
FIX: Adding bounding box for the interaction information to avoid so many collisions
with the same pair of geometries.

IMP: (1/12/10, GVG) More generic contacts geneted by TechEditorWizard (Bug #2597)

BUG: (1/11/10, GVG) Exception in SPICE with Poly1-Poly2 cap (lay) (Bug #2599)
FIX: Missing port added. Technology.check() will report the error now.

BUG: (1/11/10, SMR) Messages window not scrolled quickly enough (Bug #2575).
FIX: Schedule scrolling for later.

IMP: (1/11/10, SMR) Fixed calls to Cell.copyNodeProto() (Bug #2587).

BUG: (1/11/10, SMR) "Duplicate Cell" doesn't swap icons (Bug #2598).
FIX: Fixed CellChangeJobs.DuplicateCell.doIt() to use CellIds.

IMP: (1/08/10, GVG) Part of "More generic contacts geneted by TechEditorWizard" (Bug #)

************************* Version 8.11a: ******************************

IMP: (01/08/10, GVG) Add DRC annotation to skip cell (Bug #2596)
Added memu Tools -> DRC -> Add Skip Annotation to Cell.
Many files modified due to the move of LayoutLib.error function to Job.error.

BUG: (01/08/10, DN) Getting ports on network is very slow (Bug #2590).
FIX: Add method Netlist.getPortInstsByNetwork to get ports in bulky way.

BUG: (01/08/10, DN) Difference between immutable and mutable nodes in cell? (Bug #2594).
FIX: Comment experimental code for now.

IMP: (01/07/10, GVG) TechEditWizard writing metal-based technologies (Bug #2595).
This also changed the order of elements in tsmcSun40GP.xml and the regression.

IMP: (01/07/10, SMR) "Change" dialog now shows different types of schematic
     components (nMOS, pMOS, transistors, for example) and also shows
     hierarchical list of new object types (Bug #2550).

BUG: (01/07/10, SMR) Highlighting broken for down-in-place (Bug #2593).
FIX: Changes to Bug #2577 did not consider down-in-place.

BUG: (01/06/10, SMR) Explorer tree has problems viewing hierarchically (Bug #2591).
FIX: Fixed ExplorerTree.java and ExplorerTreeModel.java

BUG: (01/06/10, SMR) Dumping many lines to the messages window is slow (Bug #2582).
FIX: In MessagesWindow.appendString(), use a different way to scroll to the bottom.

BUG: (01/06/10, DN) Not serializable exception after library rename.
FIX: In CellChangeJobs make newCells a map from CellId to Cell.

BUG: (01/06/10, DN) NPE in getBasePort while deleting exports displayed in 2 windows (Bug #2588).
FIX: In StatusBar.updateSelectedText skip highlights which are not valid.

BUG: (01/06/10, SMR) Highlighting and objects are different when zoomed close (Bug #2577).
FIX: In Highlight.drawOutlineFromPoints(), use grid coordinates.

BUG: (01/06/10, GVG) exporting preferences to xml and re-importing causes some
     keybindings to disappear (Bug #2336)
FIX: "UTF-8" doesn't work on MacOSX (Snow Leopard). Back to original fix (default charset in MacOSX)

BUG: (01/06/10, DN) Assertion when running GNU version with a cmos90 library (Bug #2578)
FIX: In ImmutableNodeInst.addVar ignore TRACE on Cell instances and Cell-Centers.

BUG: (01/06/10, DN) Duplicate Cell assigned current tech instead of orig cell tech (Bug #2586)
FIX: In Cell.copyNodeProtoUsingMapping call NodeInst.copyStateBits instead NodeInst.copyStateBitsAndFlags.
   In CellChangeJobs and in CrossLibCopy copyExpansionStatus on client side.

BUG: (01/05/10, GVG) Exception in CellChangeJobs if it is executed from another job (Bug #2585)
FIX: Detect the case when this job is started by another one.

IMP: (01/05/10, SMR) "Change" dialog now reports the number of changes to make (Bug #2583).

BUG: (01/05/10, SMR) Duplicating cells may crash (Bug #2576).
FIX: Keep a separate copy of the cell group before exploring it.

BUG: (01/05/10, GVG) exporting preferences to xml and re-importing causes some
     keybindings to disappear (Bug #2336)
FIX: Trying "UTF-8" instead on MacOSX (Snow Leopard)

BUG: (01/05/10, DN) Wiring problem (Bug #2569).
FIX: In LayoutCell.doMoveArcInst() use proper ArcInst constructor for arc "ar3".

IMP: (01/04/10, GVG) Analog flag reported as "Vertical NPN Transistor pbase"
     preference (Bug #2581).  Manual might need to be reviewed.

IMP: (01/04/10, GVG) Calling the default PSubstrate process instead of PWell.
     This goes aligned with the changes done for Bug #2561. Figure in 7-1-2 needs to be updated.

IMP: (01/04/10, GVG) Fix "AlgorithmName is accessed from Place cells" (Bug #2580)

BUG: (01/04/10, GVG) JELIB reader reporting errors in non-existing lines (Bug #2579)
FIX: Removed the adding of cc.lineNumber in the error report.

************************* END OF Version 8.10, GNU RELEASE *************

IMP: (12/30/09, DN) Remove thread-unsafe code.
   "ToolMenu|Network|Redo Network Numbering" was also removed.

************************* Version 8.10r: ******************************

IMP: (12/27/09, AM) In debug mode, put an annotation on *all* panels
     (not just legacy-code panels).  Simulation-code bug reports which
     lack a debug-mode screenshot will be summarily INVALIDated.

BUG: (12/26/09, DN) Version 8.08 library reads differently in later versions (Bug #2357).
FIX: In Environment.withSettingChanges remove old change test.

BUG: (12/26/09, DN) Extract Cell Instance in v8.10 very slow (Bug #2566).
FIX: In CellChangeJobs.PackageCell and CellChangeJobs.ExtractCellInstances Jobs expand cell
     instances in terminateOK phase.
     In CellChangeJobs.replaceExtractedArcs use another ArcInst factory method which doesn't check Export Polys.

IMP: (12/25/09, AM) Final documentation and cleanup of BTree code.
     Please try to include this in the GNU release.

IMP: (12/23/09, AM) Make "show undriven networks" hierarchical (does
     not seem to handle arrays of NodeInsts, though).

BUG: (12/22/09, GVG) exporting preferences to xml and re-importing causes some
keybindings to disappear (Bug #2336)
FIX: MacOSX doesn't support Charset="utf-8". Creating OutputStreamWriter with default
on MacOSX (Snow Leopard)

************************* Version 8.10q: ******************************

IMP: (12/22/09, GVG) Review warning: "should connect to polysilicon-1 because that
layer is in the node" (Bug #2521). Added extra code to consider the case of a poly2 contact
with extra poly1.

IMP: (12/22/09, GVG) The 'Change' dialog cannot handle selection of both arcs and
primitives (Bug #2565). Added extra message to deal with this case since the dialog is modeless.

IMP: (12/22/09, DN) Schematic DRC shows error when there is
    an export "vdd" which is not connected to global "vdd" (Bug #2538).

IMP: (12/22/09, GVG) Get ERC to consider new resistors in layout (Bug #2557)
Not checking if resistors are reported twice due to the 2 ports.

BUG: (12/21/09, DN) Version 8.08 library reads differently in later versions (Bug #2357).
FIX: In MoCMOS.newState fix new states with incorrect ruleSet or numMetals.

IMP: (12/21/09, GVG) Get ERC to consider new resistors in layout (Bug #2557)
It works now after Bug #2561 and extra checking to avoid reporting resistor
errors twice (they have two ports).

IMP: (12/21/09, GVG) Make mocmos/tsmc180/cmos90 p-substrate technologies (Bug #2561)
Adding ERC tests for cmos90 and tsmc180 examples.

BUG: (12/21/09, SMR) "Cleanup Pins" warns about zero-size pins (Bug #2549).
FIX: In CircuitChanges.cleanupCell() ignore zero-size pins and also
     ignore artwork primitives with zero area.

BUG: (12/21/09, SMR) Placement fails (Bug #2563).
FIX: In PlacementFrame.doPlacement(), made conditional port location code.

BUG: (12/21/09, SMR) Many simulation outputs do not read in (Bug #2564).
FIX: Fixed "readSimulationOutput()" method in Spice2, LTSpice, PSpice,
     SmartSpice, Verilog, Epic, Raw format, and ArchSim.

IMP: (12/21/09, GVG) Changes for Get ERC to consider new resistors in layout (Bug #2557)

IMP: (12/20,09, DN) NPE in network coming from autostitch (Bug #2562).
FIX: In AutoStitich.java return false if specified "ni" doesn't have network (is icon of parent).

IMP: (12/20,09, DN) Set java.tab-size=4 in Netbeans project.

IMP: (12/20,09, DN) Exclude MacOSXInterface, JMF, Java3D from default Netbeans project.

IMP: (12/19/09, DN) Remove hard-coded "spiceparts:Ammeter{ic}" from Network code (Bug #2558).
    Add "spiceparts:Ammeter{sch}" with dummy resistor to force NCC short-cut.

BUG: (12/17/09, GVG) Wrong function assigned to 40nm well resistors (Bug #2560)
FIX: Function types changed. Amended code for resolution (Bug #2540)

IMP: (12/16/09, GVG) Cache waveformview prefs from working threads (Bug #2556).

BUG: (12/16/09, GVG) FillGen with templates and mocmos (Bug #2555)
FIX: Extra code to deal with inconsistency in TSMC180 port names in transistors.

BUG: (12/15/09, DN) Version 8.08 library reads differently in later versions.
FIX: In MoCMOS.getSizeCorrector patch transistor size for library versions from 8.08h to 8.09c .

BUG: (12/15/09, GVG) NPE if you cancel Export waveform to CSV (Bug #2553)
FIX: Detect the cancel case (null file). Added an extra printing.

IMP: (12/15/09, GVG) Generalizing usage of capacitors in LE and ViewChanges.
Due to Bug #2529.

BUG: (12/15/09, AM) export waveform data as CSV (Bug #2482)
FIX: Fixed it.

IMP: (12/15/09, GVG) Correcting shortName in POLY2CAPAC (Bug #2529)

IMP: (12/15/09, GVG) Rename of groups adds name instead of replacing it (Bug #2547)
Now the condition for the dialog should be the correct one.

BUG: (12/15/09, AM) 12 second delay after loading tr0 file (Bug #2551)
FIX: AnalogSignal.getBounds() was doing a linear scan.  Don't do that.

************************* Version 8.10p: ******************************

IMP: (12/15/09, GVG) More changes for new capacitors and resistors in
Schematics (Bug #2529). Hi-Res poly2 resistor function is now RESHIRESPOLY2

BUG: (12/15/09, GVG) NPE with Find Unused Libraries and spiceparts (Bug #2548)
FIX: Detecting cases which don't have valid URL to work with (spiceparts for example)

IMP: (12/14/09, GVG) Rename of groups adds name instead of replacing it (Bug #2547)
Added extra dialog to warn users about prefix action instead of replacement.

IMP: (12/14/09, GVG) XML reader should report better Function errors in
XML tech file (Bug #2543). Better detection of the case and sending an
error message instead of the exception.

BUG: (12/14/09, GVG) Inconsistency with DRC resolution (Bug #2540)
FIX: Make sure the tech resolution is a lambda value rather than a
scaled value.

BUG: (12/14/09, GVG) MoCMOS new capacitor and resistors (Bug #2509)
FIX: Issues with extension of ports and m1 surround. Hi-Res resistor
named Hi-Res-Poly2-Resistor for consistency.

BUG: (12/14/09, SMR) Control-shift-right dragging doesn't let you cut an
     arc (Bug #2545).
FIX: In CircuitChanges.deleteSelected() accept a highlighted area.

BUG: (12/14/09, SMR) Auto-stitch misses ports when all in a line (Bug #2535).
FIX: In GenMath.getQuadrants() allow zero-size boxes to be in a quadrant.

IMP: (12/14/09, GVG) First set of changes for New capacitors and resistors in
Schematics (Bug #2529).

IMP: (12/14/09, GVG) No longer direct access to first extension in a FileType.
Using function instead.

BUG: (12/14/09, GVG) Out of bounds exception while plotting waveform into PDF
     (Bug #2543)
FIX: Extra code to detect if given extension is a known one.

BUG: (12/14/09, GVG) NPE trying to print from Waveform viewer (Bug #2542)
FIX: Detects now non-EditWindow context and send error message.

IMP: (12/13/09, AM) Crude but usable support for plotting simulation
     data via GnuPlot (both on-screen and as PDF for publication).

IMP: (12/12/09, AM) BTree.summarize(min,max) and support therefore;
     still needs tested.  Can answer queries like "what is the
     minimum voltage in the time range [t0,t1]" with O(log|t1-t0|)
     operations, so a query on a simulation set with 200 million
     samples requires about a dozen operations rather than 200
     million operations.

IMP: (12/12/09, DN) A reference from Cell to Topology and NetCell is
     SoftReference.

IMP: (12/12/09, DN) Remove mutable computation of Technology.getShapeOfPort0().

BUG: (12/12/09, DN) Can no longer get polygons from dummy NodeInsts (Bug #
     In PortOriginal.traverse and in NodeInst.getCellTreeUnsafe().

IMP: (12/11/09, GVG) Updated capacitor info in LE.

BUG: (12/11/09, SMR) EDIF input makes too many arcs (Bug #2536).
FIX: Stopped EDIF from making duplicate arcs and
     Stopped AutoStitch from daisy-chaining busses.

BUG: (12/11/09, GVG) MoCMOS new capacitor and resistors (Bug #2509)
FIX: New names, new p non silicide poly resistor, min/spacing rules for hi-res
     layer.

IMP: (12/11/09, GVG) XML Tech reader should verify if layer in DRC rule exists
     (Bug #2534)

IMP: (12/11/09, GVG) Enable MoCMOS Subm rules with analog flag (Bug #2531)

IMP: (12/10/09, GVG) Group mocmos rules options (Bug #2532).
     Subm, scmos and deep options added to a group.

BUG: (12/10/09, GVG) MoCMOS new capacitor and resistors (Bug #2509)
FIX: Wrong scaling in some layers.

IMP: (12/10/09) First modifications for new capacitors and resistors in
     Schematics (Bug #2529)

BUG: (12/10/09, GVG) MoCMOS new capacitor and resistors (Bug #2509)
FIX: Some Functions were wrong. Added RESNACTIVE/RESPACTIVE

BUG: (12/10/09, SMR) Text problems (highlighting doesn't match, dotted line
     wrong, anchor wrong on rotated nodes) (Bug #2528).
FIX: Fixed ElectricObject.computeTextPoly(),
     Highlight.HighlightText.showInternalHighlight(), and PolyBase.rotateType().

************************* Version 8.10o: ******************************

BUG: (12/9/09, DN) Assertion in
     Netlist.concurrentModificationException(Nodable,Global) (NCC regression)
     (Bug #2523)
FIX: In SchemNamesToLay.constructor order Layout Cells from top to down.

BUG: (12/9/09, DN) Assertion in NetSchem.getNetMapOffset(Nodable,Global) (NCC
     regression) (Bug #2523)
FIX: In NetSchem.getNetMapOffset(Nodable,Global) refine assertion.

BUG: (12/9/09, GVG) Verilog not detecting top cell properly (Bug #2527)
FIX: Look for last module read if no cell with the name of the file is found.

IMP: (12/9/09, GVG) MoCMOS new capacitor and resistors (Bug #2509)
     Added unsiliced poly resistor. Fixed resizing of poly capacitor.

BUG: (12/9/09, SMR) EDIF input doesn't convert all <> brackets, misses some
     renames (Bug #2526).
FIX: Fix all brackets, consider all renames.

BUG: (12/9/09, SMR) "Change" command crashes on "change nodes with arcs" (Bug
     #2525).
FIX: More robust calculation of contacts, eliminate unused arc choices.

IMP: (12/9/09, GVG) Change Dialog should not list PrimitivesNodes not in used
     (Bug #2524)

BUG: (12/9/09, SMR) Export PNG needs preferences (Bug #2474).
FIX: Added the defaultFont to EditWindow0 and passed that class to the relevant
     modules so that both defaultFont and TextGlobalScale became available.

BUG: (12/8/09, GVG) Edit Key Bindings dialog hangs if no shortcut is selected in
     the list (Bug #2353)
FIX: null as parent component in JOptionPane.showMessageDialog used.

BUG: (12/8/09, GVG) Missing refresh when cell is removed (Bug #2498)
FIX: Always do full Repaint.

IMP: (12/8/09, GVG) Part of export PNG and values not cached (Bug #2474).

BUG: (12/8/09, SMR) EDIF import places exports on instances incorrectly (Bug
     #2512).
FIX: Use proper port instead of first one.

IMP: (12/8/09, GVG) MoCMOS new capacitor and resistors (Bug #2509)
     Added active/poly/hi-res/well resistors. Only available in analog mode.

BUG: (12/8/09, SMR) Technology Preferences don't update right when "Analog" is
     chosen (Bug #2520).
FIX: In TechnologyTab.term() must update dialog fields.

BUG: (12/8/09, DN) Exception arrayout of bounds and crash (Bug #2519).
FIX: Override IconNodeInst.setD and IconNodeInst.setDInUndo and clear nodables
     there.

BUG: (12/8/09, DN) Frozen on NetSchem error (Bug #2518).
FIX: In NetSchem constructor make implementation from mainSchematics instead of
     Icon Cell.

IMP: (12/8/09, SMR) Improved vector display memory usage by using immutable
     database (Bug #2517).

IMP: (12/8/09, GVG) Multiple exceptions if PrimitiveNode is defined twice in XML
     tech file (Bug #2516)

IMP: (12/8/09, GVG) Tech XML reader doesn't check if layer doesn't exist (Bug
     #2515). Electric will print error message during the reading and ignore that
     unknown layer.

BUG: (12/8/09, DN) Netlist.getNetIndex(Nodable,PortProto,int) fails when
     IconNodeInst is passed as Nodable (Bug #2513).
FIX: In Netlist.getNetMapOffsetIndex(Noable,PortProto,int) remap portIndex by
     ep.portImplementation .

BUG: (12/8/09, GVG) NPE if extension is not found (Bug #2514)
FIX: Detect the case when the extension is not from FileType

IMP: (12/8/09, DN) In threadsafe mode Netlists are weak-referenced.

IMP: (12/8/09, DN) Replace Netlist.expectedModCount by Netlist.expectedSnapshot
     and expected.CellTree .

IMP: (12/8/09, DN) Field Cell.weakTopology is always non-null to simplify
     Cell.getTopology().

BUG: (12/7/09, DN) Library cannot be read (Bug #2510, #2511).
FIX: In NetSchem.getNetMapOffset don't redirect portIndex by portImplementation.

IMP: (12/6/09, DN) Move network.NetSchem.Proxy to
     topology.IconNodeInst.IconNodable.

IMP: (12/6/09, DN) Optimization of immutable algorithm of computing connected
     Exports in schematic cells. Self-test is always on.

BUG: (12/5/09, DN) Regressions fails in getShapeOfPort.
FIX: Use cellTree.techPool instead of cellBackup.techPool for getShapeOfPort.

IMP: (12/4/09, GVG) MoCMOS new capacitor and resistors (Bug #2509)
     Added capacitor and hi_res layer.

BUG: (12/4/09, DN) Can no longer get polygons from dummy NodeInsts (Bug #2507).
FIX: In NodeInst.getShapeOfPort() use getCellBackupUnsafe() instead of
     cell.backupUnsafe(). In PortOriginal.traverse don't get database if cell is
     null.

BUG: (12/3/09, DN) New ELIB files don't read back in. (Bug #2506).
FIX: In input.ELIB.convertPortProto return null when index is "-1".
     Add field output.ELIB.ElibConn2239ection.arcIndex and use it for output.

BUG: (12/3/09, SMR) Should detect errors outside of jobs (Bug #2505).
FIX: Fixed "Align to Grid" and others.

************************* Version 8.10n: ******************************

BUG: (12/3/09, GVG) Undo gets stuck after saving files (Bug #2503)
FIX: Added extra condition to statement which brings up the dialog. Removing
     write from done/undone lists.

BUG: (12/2/09, DN) ArrayIndexOutOfBoundsException in LayerDrawing.drawDiscRow
     during redraw (Bug #2504).
FIX: Clip properly in LayerDrawing.discRow .

IMP: (12/2/09, SMR) New Node Preference "Increment rightmost array index"
     allows export duplication to auto-increment from the left (if unchecked)
     (Bug #2501).

BUG: (12/2/09, SMR) Missing plugins cause hang (Bug #2501).
FIX: Cleaned-up warnings.

IMP: (12/1/09, DN) Self-test in "-debug" mode for immutable algorithm of
     computing connected Exports in schematic cells.

IMP: (12/1/09, DN) Self-test for immutable algorithm of computing connected
     Exports in layout cells.

BUG: (12/1/09, DN) Network could obtain incorrect name if the Cell contains
     nonelectric arcs.
FIX: In NetSchem.calcDrawnWidth move ai = it.next() before any "continue"
     statements.

IMP: (12/1/09, DN) Technology computes shape of ports in immutable way.

BUG: (11/30/09, GVG) No cleanUnusedNodesInLibrary for MoCMOS special nodes such
     as poly2 contact (Bug #2500)
FIX: CMOS90.cleanUnusedNodesInLibrary functionality moved to
     Technology.cleanUnusedNodesInLibrary

BUG: (11/30/09, SMR) MOSIS CMOS PLA generator fails (Bug #2499).
FIX: In PLA.java, must start a Job.

BUG: (11/30/09, SMR) Going Up-Hierarchy when editing down-in-place should not
     alter scale/pan (Bug #2497).
FIX: In EditWindow.upHierarchy() always keep focus when editing down-in-place.

IMP: (11/30/09, DN) Bus names of arcs and nodes are allowed only in icon and
     schematic cells. The prototype of arc with bus name must be
     Schematics.bus_arc . The prototype of node with bus name must be an Icon
     cell.

IMP: (11/30/09, DN) Remove diagnostics of case-insensitive match of Variables.

IMP: (11/30/09, DN) Move diagnostics of Networks with case-insensitive match into
     Schematics DRC. Remove field database.text.Name.canonicString.

IMP: (11/29/09, DN) CellTree contains EquivPorts which represents internal
     connections in Layout CellTree.

BUG: (11/27/09, DN) Incremental DRC used incorrect conditions when to invoke.
FIX: Move CellRevision.getNode()/getArc() to
     CellBackup.Memoization.getNodeById()/getArcById().

IMP: (11/27/09, DN) Move arcIndexByArcId from NetCell to CellBackup.Memoization.

BUG: (11/25/09, GVG) Error Logger: first time you use next error, you go to error
     number 2 (Bug #2496)
FIX: Correct initialization of current log number

BUG: (11/25/09, SMR) Digital waveforms show panel and signal name badly (Bug
     #2495).
FIX: In DragButton.java, combine the names instead of overlapping them.

IMP: (11/24/09, DN) Expand/unexpand command doesn't allocate Topologies of
     subcells.

BUG: (11/24/09, SMR) Waveform window draws extra garbage (Bug #2493).
FIX: In HorizRuler.renderRuler() clear the area first.

BUG: (11/24/09, SMR) Export names not shown when editing down-in-place (Bug
     #2438).
FIX: Patched all three display algorithms.

IMP: (11/24/09, DN) Release arrays NetCell.headConn and NetCell.tailConn when
     they are no more used.

IMP: (11/24/09, DN) Redisplay in LayerDrawing doesn't allocate Topologies of
     subcells.

BUG: (11/23/09, DN) ArrayIndexOutOfBoundsException when re-exporting highlighted
     ports (Bug #2491).
FIX: In Cell.updatePortInsts don't update PortInsts of parent Cell if its
     Topology is not allocated.

BUG: (11/23/09, DN) Routing regressions crashed attempting to save preferences.
FIX: In RoutingTest comment out ep.putPrefs .

IMP: (11/22/09, DN) NodeInst.getShapeOfPort doesn't allocate Topologies of
     subcells.

BUG: (11/20/09, DN) can't change export name (Bug #2490)
FIX: In Cell.unfreshCellTree redoGeometric only if Topology is alive.

BUG: (11/20/09, DN) UnsupportedOperationException in Quit with
     EmptyPreferencesFactory (Bug #2489)
FIX: In EmptyPreferencesFactory.flushSpi don't throw an exception.

BUG: (11/20/09, DN) UnsupportedOperationException on MacOSX with
     EmptyPreferencesFactory (Bug #2488)
FIX: Don't setRemoteType in SunAsyncMenu class initialization. Instead replace
     TYPE_LOCAL by TYPE_SSH in SunAsyncMenu.getExec and SunAsyncMenu.getCdToDir .

BUG: (11/19/09, DN) Bad diagnostics when ".bsh" script calls unavailable Java
     method. (Bug #2484).
FIX: In EvalJavaBsh.doSource apply doGetTarget not only to bsh.TargetError but to
     any bsh.EvalError .

BUG: (11/19/09, DN) Exception in fill gen/gate generation with
     EmptyPreferencesFactory (Bug #2485).
FIX: Use Cell.isTopologyModified() instead of Cell.isContentsModified() when
     changing nodes.

BUG: (11/19/09, GVG) NullPointerException importing GDS (Bug #2486).
FIX: GenMath.getAreaOfPoints() didn't consider some points are null from
     GDS.buildComplexNode for example.

BUG: (11/19/09, SMR) Auto-stitcher does too much (Bug #2363).
FIX: Made stitcher shrink pin ports to the size of connected extended arcs.

IMP: (11/18/09, DN) NodeInst are owned by Topology object.
     So GarbageCollector can discard them in unused Topologies.

BUG: (11/18/09, GVG/JKG) NullPointerException on wiring switching wiring targets
     (Bug #2480)
FIX: Rounding dbmouse in ClickZoomWireListener:switchWiringTarget. Extra DBMath
     in InteractiveRouter.getCornerLocation()

BUG: (11/18/09, GVG) Crash when typing "/" (Bug #2483)
FIX: Load next message if nothing has been shown yet.

BUG: (11/18/09, SMR) Crash when reading waveforms (Bug #2481).
FIX: Do not request current technology in TextUtils.atof().

************************* Version 8.10m: ******************************

IMP: (11/18/09, SMR) Arrow-key movement now goes by grid-aligned amount.

BUG: (11/17/09, DN) database exceptions, cannot save... (Bug #2479)
FIX: In CellTree.with() test for empty subTrees[i] .

IMP: (11/17/09, GVG) Avoid NPE in Pad generation in case of errors in input (Bug
     #2478)

BUG: (11/17/09, GVG) Electric postscript output not working (Bug #2477)
FIX: Replaced "Rectangle2D printBound"; for "ERectangle printBound" in the
     postscript prefs.

IMP: (11/17/09, GVG) 4 new layers in 40nm (Bug #2475)

IMP: (11/16/09, DN) CellTree is cached in Cell.tree .
     Remove cell bounds computation code from mutable database.

BUG: (11/16/09, GVG) User Prefs/Proj Prefs/Text exports: double file extensions
     (Bug #2473)
FIX: Considering case when two FileTypes have the same extensions

BUG: (11/16/09, SMR) Auto-stitch broken: adjacent ports from two instances do not
     stitch (Bug #2472)
FIX: AutoStitch.ZEROSIZEPINS = false

IMP: (11/16/09, DN) Don't check in Snapshot.with those invariants which were
     checked in CellTree.with .

IMP: (11/15/09, DN) Ensure that Cell.cellBounds are the same as
     CellTree.getBounds().

IMP: (11/15/09, DN) Don't need to supply cell bounds to Snapshot.

IMP: (11/15/09, DN) Move "packaging" upper due to netbeans project.

IMP: (11/15/09, AM) Make legacy code off-by-default.

BUG:(11/13/09, DN) NullPointerException in repaint when trying to highlight
     deleted port (Bug #2471).
FIX: In Highlight.HighlightEOBJ.showInternalHighlight return when eobj is not
     linked.

IMP: (11/13/09, GVG) Working on a new DSPF reader

IMP: (11/13/09, SMR) Arc Preferences now has control over "fat wiring mode" (Bug
     #2470).

BUG: (11/12/09, DN) AssertionError in getShapeOfPort (Bug #2468)
FIX: In Schematics.genShapeOfPort gen shape in grid units when lambda != 1.
     Not getting double polys in NodeInsts with outline.

IMP: (11/12/09, GVG) EditWindow0.globalScale cached during class creation.
     Caching placement prefs in Verilog input prefs.

IMP: (11/12/09, GVG) "\" character causing errors in VerilogReader (Bug #2465)
     Not removing "\" from cell instance name.

IMP: (11/12/09, DN) Technology.getShapeOfPort() computes shape of ports both in
     mutable and immutable way for self-check.

BUG: (11/11/09, GVG) "\" character causing errors in VerilogReader (Bug #2465)
FIX: Assertion removed. The "\" removed from the name.

IMP: (11/11/09, GVG) Run placement tool after Verilog reader (Bug #2467)
     New preference added.

BUG: (11/10/09, GVG) Verilog not including subcells found in other libraries (Bug
     #2466)
FIX: Using Library.findCellInLibraries() instead of lib.findNodeProto()

IMP: (11/10/09, DN) Export doesn't contain a strong reference to original
     PortInst.

IMP: (11/09/09, GVG) TechEditorWizard should produce some 3D values (Bug #2235)
     Implemented with Bug #2460

BUG: (11/09/09, GVG) Switching fro JELIB to DELIB generates wrong file extensions
     (Bug #2328)
FIX: Warns now about the correct filename. Points 1 and 3 not implemented.

BUG: (11/9/09, DN) Null pointer exception while pasting layout cells (Bug #2462).
FIX: In CellTree.with always continue cellUsages loop when cui == null.

BUG: (11/9/09, GVG) Incorrect verilog netlist for individual ports with bus tags
     (Bug #2461)
FIX: Fixed wrong export selection when the signal is descending.

IMP: (11/9/09, DN) Snapshot contains CellTree objects which can compute Cell
     bounds. For some time Cell bounds will be computed both by Snapshot and by
     EDatabase to self-check.

BUG: (11/6/09, GVG) Writing Verilog deck from Verilog view (Bug #1323)
FIX: Library_Cell format is just one option.

IMP: (11/6/09, GVG) Ability to specify min/spacing rules for other layers (Bug
     #2460)

IMP: (11/6/09, GVG) Improving syntax in TechEditorWizard file to include rules
     in @extra_layers

BUG: (11/5/09, GVG) VerilogReader can't parser /* comments (Bug #2459)
FIX: Added ability to read until end of the */ comment.

BUG: (11/5/09, GVG) Out of bounds exception in Verilog writing with invalid
     syntax (Bug #2458)
FIX: Added extra code to detect syntax errors in input/output lines

IMP: (11/4/09, GVG) Ability to generate light internal version (Bug #2457)

************************* Version 8.10l: ******************************

BUG: (11/4/09, SMR) HPGL output crashes (Bug #2455).
FIX: Created EditWindow0.EditWindowSmall to pass to Jobs, fixed visitor.

BUG: (11/4/09, SMR) PostScript output crashes (Bug #2455).
FIX: Created EditWindow0.EditWindowSmall to pass to Jobs.

IMP: (11/03/09, DN) Cell.computeBounds() doesn't use ArcInsts.

IMP: (11/03/09, DN) Compaction.compactNow starts uses job.startOMyResult to be
     scheduled in regressions before QuitJob.

IMP (11/02/09, GVG) Add Extra Layers in Palette (Bug #2454)

BUG: (11/02/09, GVG) NPE if extra layer information is incomplete (Bug #2453)
FIX: Detecting the cases. Code refactored.

IMP: (11/01/09, AM) PowerChannelResistorVoltageReadable: finish
     implementation.

IMP: (11/01/09, AM) com.sun.electric.tool.simulation.test needs its
     own JNI binaries because the class names changed.  I added an "e"
     (for Electric) to the end of these names and put them in
     /proj/async/cad/test/ and changed the loadLibrary() calls to
     point to them.

IMP: (10/30/09, GVG) TechEditWizard improvements: scrolls in some tabs,
     image and labels overlap in well/implant tab (Bug #2452)

BUG: (10/30/09, GVG) Wrong setup of metal layers in Metal tab (Bug @2451)
FIX: Wrong loop limit detected in TechEditWizardData.setNumMetalLayers.

BUG: (10/30/09, GVG) Inconsistencies in 3D values for Active-cut and n-active
     (Bug #2450)
FIX: 3D values for Active-cut and n-active in cmos90 fixed.

IMP: (10/29/09, AM) Signalyzer: implementation complete, tested, and
     working (on Marina, chip #19).

IMP: (10/29/09, AM) NetscanGeneric.hw_net_scan_ir(): pass along the
     length of the now-selected scan chain.

IMP: (10/29/09, AM) Make ExecProcessReader a Daemon thread.

IMP: (10/29/09, AM) Make ChainNode and
     SubchainNode.{getParentChain(),getBitIndex()} public

IMP: (10/29/09, AM) Support HSpice output in BTree code.

BUG: (10/28/09, GVG) Bizarre rotation with facet-center selected (Bug #2449)
FIX: Facet center ignored if selected. Arcs whose both NI nodes are in the list
     are also included.

BUG: (10/28/09, DN) Export not visible while editing in place (Bug #2438).
FIX: In VectorDrawing.render and LayerDrawing.drawCell pass proper
     expansion status to drawPortList.

BUG: (10/27/09, GVG) Inconsistent cell expansion after undo (Bug #1138)
FIX: Detecting if user previously expanded/unexpanded the cell node instance.

BUG: (10/26/09, GVG) NPE in SaveAs command (Bug #2447)
FIX: Detect the case when no current library is available.

BUG: (10/26/09, GVG) NPE in Array dialog (Bug #2446)
FIX: Detecting cases where no valid cell/window is available

BUG: (10/26/09, SMR) Moving Cell variables beyond the 4088 offset limit
     causes them to overflow and jump to a random location (Bug #1641).
FIX: In MutableTextDescriptor.setOff() now clip the scale factor.

BUG: (10/25/09, AM) New simulation data code needs to reinstate the
     distinction between interpolated points and sampled points (Bug
     #2346).
FIX: NewSignal.getPixelatedApproximation().

IMP: (10/25/09, AM) Change PCB examples in schematic.jelib to be
     layout views.

IMP: (10/25/09, AM) Fix some typos in the manual.

IMP: (10/24/09, AM) Do not write files to disk unless simulation data
     exceeds 50MB.

IMP: (10/24/09, AM) BTree: take advantage of CachingPageStorage API.

IMP: (10/24/09, AM) FileBasedPageStorage: defer creating the file
     until the first page is requested.

IMP: (10/24/09, AM) Rewrite CachingPageStorage, make it thread-safe.

IMP: (10/23/09, AM) Add partial implementation of Signalyzer driver.

IMP: (10/23/09, AM) Add compileTestCode target which will compile
     com.sun.electric.tool.simulation.test.  I have confirmed that
     this will fail (as desired) if the test code depends on any other
     part of electric.  We should call this build target from the
     regression tests every night.

IMP: (10/23/09, AM) Move com.sun.async.test to
     com.sun.electric.tool.simulation.test (as discussed with SMR,
     JKG)

BUG: (10/23/09, GVG) Fill generator exception when cell already exists (Bug
     #2444)
FIX: Printing warning instead of throwing assertion.

IMP: (10/23/09, JG) Added more invisible layer configs for metals 10, 11, 12 in
     40nm

IMP: (10/23/09, GVG) Ability to provide layer functions in extra layer definition
     (Bug #2445)

BUG: (10/23/09, SMR) Nodes in the component menu are drawn too small
     when there are larger nodes in the same class (Bug #2233).
FIX: Nodes in the component menu are now drawn to fill the menu square.

BUG: (10/23/09, SMR) Crash when changing cell parameters (Bug #2442)
FIX: Handle missing parameters and treat them as empty strings.

BUG: (10/23/09, SMR) When "Duplicate/Array/Paste copies exports" is set,
     deleting export text tries to delete it twice (Bug #2443).
FIX: In Clipboard.copyListToCell() copy the geometric list before modifying it.

BUG: (10/22/09, GVG) Crash when changing cell parameters (Bug #2442)
FIX: Temporary patch to avoid the exception. Not the solution yet.

************************* Version 8.10k: ******************************

BUG: (10/21/09, SMR) Verilog needs to separate instance names and network names
     (Bug #2430)
FIX: In Verilog.writeCellTopology() detect and modify instance names.

BUG: (10/20/09, GVG) System clipboard data unavailable after second copy/paste on
     MacOSX (Bug #2440)
FIX: Catching the exception on MacOSX. It is a known issue on that platform.

BUG: (10/20/09, GVG) NPE on Window -> Move to other display (Bug #2436)
FIX: Not finalizing old objects until new ones are created.

IMP: (10/19/09, GVG) Ability to add pins/arcs to extra layers defined in txt file
     used by TechEditorWizard (Bug #2435)

IMP: (10/19/09, GVG) Scale GDS on export option (Bug #2434)

BUG: (10/18/09, AM) BTree waveform code randomly transposes signals.
FIX: Heed the distinction between a signal's "index" and its "number".

BUG: (10/18/09, DN) NPE while moving objects in threadsafe mode (Bug #2431).
     Cell.getBounds() algorithm had a bug which appeared in threadsafe mode with
     its lazy RTree calculation. Previously RTree calculated always and these
     calculation hid this bug.
FIX: In Cell.getBounds() recalculate bounds of subcells in BOUNDS_CORRECT_GEOM
     and BOUNDS_RECOMPUTE cases.

BUG: (10/16/09, GVG) TechEditorWizard  doesn't write metal pin when numMetals=1
     (Bug #2433)
FIX: Pins not longer defined in same loop as the metal contacts. Extra code to
     detect arcs without pins associated (in an invalid tech for example).

BUG: (10/16/09, GVG) NPE if no pin associated to the arc is found (Bug #2432)
FIX: Case detected (probably due to invalid tech) and routing path is discarded

IMP: (10/16/09, GVG) Better caching of IllegalArgumentException in GDS IO (Bug
     #2423)

BUG: (10/16/09, DN) NPE while moving objects (Bug #2431).
FIX: Measures to prevent Electric from hang:
     1) Assertion Errors don't stop GUI thread;
     2) MessagesStream prints elsewhere when Job.getUserIntereface() == null;
     3) UserInterfaceMain.showSnapshot recovers database if undo fails;
     4) Cell.recover() assign cellBounds to computed bounds instead of assert;

BUG: (10/16/09, DN) NPE in CVS with threadsafe mode on (Bug #2429).
FIX: In Edit.MarkForEditJob.doIt call
     fieldVariableChanged("uneditMatchedStrings") earlier.

IMP: (10/13/09, GVG) Threadsafe (FULL_SCREEN_SAFE) mode back to default.
     Use -nothreadsafe to switch to previous mode.

IMP: (10/12/09, GVG) Export names not sorted multi-object properties dialog (Bug
     #2419).  Adding sorting of highlights before they added into the selection
     list.

BUG: (10/12/09, GVG) build.xml broken: not producing the right thing for GNU
     releases (Bug #2427)
FIX: In generalPurposeJar, rolling back to unjarSun and zipfilesets commented out

BUG: (10/12/09, GVG) NPE in Spice if no schematic associated to an icon is found
     (Bug #2428)
FIX: Detecting the case and assigning icon name as unique name.

BUG: (10/10/09, AM) Waveform viewer sometimes truncates data
     horizontally when using BTrees (Bug #2413)
FIX: Do not snap the least and greatest visible times (t0 and t1) to
     events before partitioning the space between them into equal
     sized chunks.

IMP: (10/10/09, AM) NewSignal: request approximations by supplying a
     desired number of events rather than an integer time denominator
     -- the latter did not offer any way of asking for events which
     are more than one time unit apart.

IMP: (10/10/09, AM) Implement BTree.{getOrdFromKey,getOrdFromKeyFloor}.

BUG: (10/10/09, AM) changes to grid do not take effect until next repaint (Bug
     #2409)
FIX: Invoke EditWindow.repaintAllContents() from GridAndAlignmentTab.

BUG: (10/10/09, AM) Re-deprecate Infrastructure.waitSeconds() (Bug #2386)
FIX: Use Thread.sleep() instead.

BUG: (10/10/09, AM) Make of ColorPrefType.HIGHLIGH* values in pulsing highlight
     (Bug #2401)
FIX: Convert HIGHLIGHT color to HSV, then use hue for pulsation.

BUG: (10/10/09, AM) Reading Logical Effort libraries produces many errors (Bug
     #2410)
FIX: Open each of the three libraries, change something, save it, and exit.

IMP: (10/10/09, AM) update the LESettings{ic,sch} in purpleGeneric180.jelib.

BUG: (10/9/09, DN) NPE while getting the default tech (Bug #2424).
FIX: In User.endBatch don't invoke render job on initial empty Environment.

************************* Version 8.10j: ******************************

IMP: (10/8/09, GVG) Undo of Write library doesn't remove the file (Bug #2329)

BUG: (10/8/09, DN) NPE while getting the default tech (Bug #2424).
FIX: Check that Environment.settingValues are of correct type.

IMP: (10/8/09, GVG) Better error explanation while reading XML tech (Bug #2425)

IMP: (10/8/09, GVG) Making extra_layers definition in TechEditorWizard available
     by default

BUG: (10/8/09, GVG) GDS and too large coordinates (Bug #2423)
FIX: Caching IllegalArgumentException in EPoint

BUG: (10/8/09, GVG) Exceptions in TechEditorWizard with incomplete tech txt files
     (Bug #2422)
FIX: Consider incomplete metal definition.

BUG: (10/8/09, DN) Threadsafe mode slow? (Bug #2420).
FIX: Disable database self-test in UserInterfaceMain.showSnapshot.

BUG: (10/8/09, DN) Threadsafe mode slow? (Bug #2420).
FIX: Disable database self-test in UserInterfaceMain.showSnapshot.

IMP: (10/7/09, GVG) Show cell results in new window not working for errors? (Bug
     #2421)

IMP: (10/7/09, AM) Ensure that the JVM exits with nonzero exit code if
    an exception is thrown in Batch mode (so Electric can be called
    from Makefiles).

IMP: (10/7/09, GVG) Back to DEFAULT_MODE = Mode.FULL_SCREEN_UNSAFE until
     "threadsafe mode slow?" (bug #2420) is further investigated.

IMP: (10/7/09, DN) cvspm.Edit.UneditResponder stores matched Strings in a list
     for later processing in Edit.MarkForEditJob.terminateOK (Bug #2417).

BUG: (10/7/09, DN) Threadsafe mode doesn't remember cells expanded (Bug #2416).
FIX: Move Cell.loadExpandStatus from Library readers to
     FileMenu.ReadLibrary.terminateOK.

BUG: (10/7/09, DN) DefGridXBoldFrequency is accessed from null (Bug #2415).
FIX: Create class AbstractDrawing.DrawingPreferences to pass preferences to
     RenderJob.

BUG: (10/7/09, DN) Inconsistent state of linkedlibs in DB after getting errors in
     SaveAs (Bug #2406).
FIX: In FileMenu.RenameAndSaveLibraryTask.renameAndSave() throw JobException on
     failure in thread-safe mode.

BUG: (10/7/09, DN) Marina scripts fail with "java.lang.AssertionError" (Bug
     #2414).
FIX: Change Output.OutputCellInfo from CLIENT_EXAMINE to SERVER_EXAMINE .
     In Make.UserInterfacDummy.terminateJob check for Job.isThreadSeafe().

IMP: (10/5/09, GVG) Toggle Grid and resolution warnings (Bug# 2404)

BUG: (10/1/09, GVG) Marina scripts fail with "Conflicting thread modes:
     BATCH and THREAD_SAFE" (Bug #2411)
FIX: New Mode.THREAD_SAFE is defined (bug #2293) before -batch condition.

IMP: (9/30/09, AM) Rename com.sun.electric.tool.btree to
     com.sun.electric.database.geometry.btree as instructed by SMR.

BUG: (9/29/09, SMR) Bold grid dot spacing cannot be changed (Bug #2405).
FIX: Made bold spacing use integers, not doubles.

BUG: (9/29/09, SMR) Implant coverage generator leaves notches (Bug #2408).
FIX: Better testing for areas within DRC limits.

BUG: (9/29/09, SMR) GDS import is imprecise (Bug #2402).
FIX: Rounded the "meter unit" read from the GDS file.

IMP: (9/29/09, GVG) Made "-threadsafe" (Mode.THREAD_SAFE) by default to test new
     mode and fixes for bug #2293

IMP: (9/29/09, DN) A simple scheduler for CLIENT_EXAMINE jobs in thread-safe
     mode.

IMP: (9/28/09, GVG) Extra code to detect case described in Bug #2151

BUG: (9/28/09, GVG) NPE in Export PS (Bug #2407)
FIX: Detect the 3D case and aborts the action. PS is only available from an
     EditWindow instance

IMP: (9/28/09, AM) Successfully loaded a 1.1GB simulation file using a
     400MB JVM heap (-Xmx=400m).  Loading time was 3.8 minutes, and
     once loaded panning/scrolling showed no perceptible delay.

IMP: (9/28/09, AM) Stream simulation data directly from the disk into
     the BTree rather than storing it in an intermediate byte[].  We
     can now officially load simulation files that are "bigger than
     memory".

IMP: (9/28/09, AM) Finish implementing BTree.getValFromOrd(), which
     lets us switch from a BTree<Integer,Pair<Double,Double>> to a
     BTree<Double,Double>.  Not much impact on time to load a file,
     but cuts memory use by ~33%.  Making the rasterization code use
     getValFromOrd() instead of doing a binary search made a huge
     difference in UI responsiveness, though.

BUG: (9/25/09, GVG) Can't save file in MacOSX after browsing in the save dialog
     box (Bug #2326)
FIX: Using URL instead of String to open the FileWriter

************************* Version 8.10i: ******************************

BUG: (9/24/09, SMR) Explorer tree "Search" dialog doesn't allow multiple
     cells to be selected and viewed (Bug #2322).
FIX: Now handle all selected cells.

IMP: (9/24/09, SMR) New Display Preference: "Show cell results in new window"
     causes commands that show a cell to do it in a new window.  The commands
     are: "Edit XXX View", "Make XXX View", do Placement, ROM generation, PLA
     generation, etc. (Bug #2388).

BUG: (09/24/09, GVG) Non-deterministic results in AutoFillTemplate test (Bug
     #2380)
FIX: Sorting ports before FillRouter.

BUG: (9/24/09, SMR) GDS Preferences doesn't show enough scale precision (Bug
     #2402).
FIX: In GDSTab.java, use more precision.

BUG: (09/24/09, GVG) Remove RDL layer from tsmcSun40GP tech (Bug #2403)
FIX: RDL definition in tsmcSun40GP.txt removed and xml tech file generated again.

IMP: (09/23/09, AM) Allow bold dots on non-integer lambda multiples.

IMP: (09/23/09, AM) Prefs.java: support "upgrading" a pref from
     Integer to Double.

BUG: (09/23/09, AM) Export names change size rapidly when mousing over
     highlighted objects (Bug #2382).
FIX: In pulsating Timer, use highlighter.showHighlights(,,true).

IMP: (09/22/09, JKG) if only export text is selected during copy,
     it adds in the node the export is on so it can be copied (if copyExports is
     on)

IMP: (09/22/09, JKG) Node extractor: improved active type selection, improved
     multi-cut contact extraction to prevent lots of single contacts.

IMP: (09/22/09, AM) build.xml: produce jdk1.5-compatible bytecodes.

BUG: (09/21/09, GVG) Non-deterministic results in AutoFillTemplate test (Bug
     #2380)
FIX: Sorting arcs based on length while selecting the best port to connect to.

IMP: (09/21/09, DN) Regression driver doesn't allocate mutable database.

IMP: (09/19/09, DN) If DRC.THREAD_SAFE_DRC=true, then DRC Jobs are SERVER_EXAMINE
     and can run in thread-safe mode.

IMP: (09/17/09, DN) Quick.doCheck() and Schematic.doCheck don't call termLogging.
     Instead caller terms Logging or do anything else.

BUG: (09/17/09, DN) Assertion in JobTree.updateJobs().
FIX: In UserInterfaceMain.java use SwingUtilities.invokeLater for updating Jobs.

************************* Version 8.10h: *******************************

BUG: (09/17/09, GVG) tmscSun40GP tech f-p-well node needs to be able to connect
     to p-well arc (Bug #2399)
FIX: arc added.

BUG: (9/17/09, SMR) Explorer tree Library Search function doesn't clear
     fields from last time (Bug #2322).
FIX: Fixed.

IMP: (9/16/09, DN) Lazy evaluation of RTree in thread-safe mode.

BUG: (9/16/09, SMR) Saving to a write-protected directory freezes the UI (Bug
     #2293).
FIX: In FileMenu.RenameAndSaveLibraryTask.renameAndSave() do not throw a
     JobException on error.

BUG: (9/16/09, SMR) Messages window doesn't handle standard text editing (Bug
     #2398).
FIX: Improved Edit commands so that cut/copy/paste/erase/select all work
     properly.

BUG: (9/16/09, SMR) Zero-size arcs are not area-selectable (Bug #2394).
FIX: In PolyBase.polyDistance() use DBMath.rectsIntersect() instead of
     Rectangle.intersects() because the later doesn't handle zero-size rects.

IMP: (9/16/09, DN) Command-line switch "-threadsafe" turns on thread-safe mode.

BUG: (9/16/09, GVG) IRSIM on layouts and exceptions (Bug #2397)
FIX: Prevent to run IRSIM on non-schematic cells.

BUG: (9/15/09, AM) IllegalStateException when attempting to load
     libraries in batch mode (Bug #2390).
FIX: Kludge in MessagesStream.print().

IMP: (9/15/09, AM) Implement BTree.getOrdinal() query and supporting
     data structures.

BUG: (9/15/09, AM) Fix erroneous UnboxedInt.compare().

BUG: (9/15/09, SMR) Delete key doesn't work (Bug #2395), and ctrl-numpad 0
     doesn't work (Bug #2396).
FIX: More special cases in KeyBindingManager.processKeyEvent().

BUG: (9/15/09, GVG) Missing "subtractAll" method in GeometryHandler (Bug #2384)
FIX: Fixed inconsistent refactoring of HashMap parameter to TreeMap in the
     subtractAll function.

BUG: (9/15/09, SMR) Highlighting crashes when over portless cell (Bug #2391).
FIX: Fixed Highlighter.checkOutObject().

IMP: (9/15/09, GVG) Improve error message in case XML ErrorLogger import fails
     (Bug #2393)

IMP: (9/15/09, GVG) Well resistors in 40nm (Bug #2392)

IMP: (9/15/09, SMR) Added two new error-reporting commands to
     "Edit / Selection" which do NOT popup a new window:
     "Show Next Error, same Window" and "Show Previous Error, same Window"
     These are bound to "[" and "]" (Bug #2388).

BUG: (9/15/09, SMR) No way to select two coincident exports (Bug #2385).
FIX: Holding "Control" now cycles through the ports that are equidistant
     from the cursor.

IMP: (9/14/09, JKG) Add "exportsToIgnore" NCC annotation (Bug #2387)

BUG: (9/14/09, AM) Merge com.sun.async.test.* into Electric code base
     (Bug #2347).  As discussed with SMR (in person), JKG (in person),
     GVG (on phone), and DN (on phone).
FIX: After appropriate massaging, check former contents of
     /proj/async/cad/cvs/test/ into electric/srcj/com/sun/async/test/.
     Please see the package.html for details.  I have also
     write-protected the old CVS repository so people don't accidentally
     check in anything new (any changes should go in here now).

IMP: (9/14/09, SMR) "Manipulate Exports" now lets you change the name and
     characteristic of an export (Bug #2383).

BUG: (9/14/09, AM) SwingUtilities.isEventThread() assertion failure.
FIX: Use SwingUitilities.invokeLater() in SunAsyncMenu gdsJob.startJob.

BUG: (9/14/09, SMR) Explorer tree Library Search function doesn't close
     properly and needs an "Edit All Cells" button (Bug #2322).
FIX: Fixed closure and added button.

BUG: (9/11/09, AM) We need to agree on what "batch" means and how to
     launch Electric in headless mode (Bug #2375).
FIX: JonG says: "I think batch mode implies 'no GUI', and nothing
     more.".  Updated documentation and Main.java.

BUG: (9/11/09, AM) Garbled export names (Bug #2382).
FIX: Distinguish between HighlightLine instances which correspond to
     errors and those which do not.

************************* Version 8.10g: *******************************

IMP (9/11/09, GVG): Ability to duplicate cells in another cell (for Bug #2023
     investigation)

BUG: (9/10/09, DN) Cannot run calibre DRC (Bug #2379).
FIX: Implement UserInterfaceExec.termLogging and Exec.ExecProcess.userInterface
     while discussing with Jon and Adam other solution.

BUG: (9/10/09, AM) EditWindow.java: stop pulsating timer when window
     is closed (Bug #2371)

IMP: (9/10/09, GVG) Change Dialog not picking the preferred contact (Bug #2378)

IMP: (9/10/09, AM) build.xml: more efficient way of building
     electric.jar without unjarring-and-rejarring stuff so much.

IMP: (9/9/09, AM) Added a fast path to the BTree code when insertions
     are in key-increasing order.  Net speedup when loading simulation
     data: 74%.  Combined with two previous modifications: 96%
     improvement (time required is 4% of time previously required).

IMP: (9/9/09, AM) Change PageStorage to a zero-copy API, at the
     expense of doing more byte[] allocation.  This made it feasible
     to increase the default page size from 1024 bytes to just under
     4096 bytes (because the System.arraycopy()'s are no longer
     killing us).  Net result: 73% improvement in time to build BTree.
     Combined with previous modification: 84% improvement (time
     required is 26% of time previously required).

IMP: (9/9/09, AM) Store simulation data as BTree<Pair<Double,Double>>
     instead of two BTree<Double>'s.  Result: 43% improvement in time
     to build BTree.

IMP: (9/9/09, AM) Remove com.sun.electric.tool.io.input.BTree (use
     c.s.e.t.btree.BTree instead)

************************* Version 8.10f: *******************************

BUG: (9/9/09, DN) Orientation JUnit test fails in JVM-1.6 64-bit.
FIX: In Orientation constructor use StringMath instead of Math.

BUG: (9/8/09, GVG) NPE while resetting all preferences in Preferences dialog (Bug
     #2376)
FIX: Detecting null cases in dialogs not used before the reset.

IMP: (9/8/09, DN) Move client queue from ClientJobManager to
     AbstractUserInterface.

IMP: (9/7/09, DN) Job.currentUI is handled similar to StreamClient .

BUG: (9/7/09, DN) Starting Jobs from Jobs fails.
FIX: In Job.startJob compute "startedByServer" correctly.

IMP: (9/7/09, DN) Preparations for thread-safe database.

IMP: (9/7/09, DN) Electric throws IllegalStateException when attempting to
     "plot spice listing" (Bug #2374).
FIX: Install UserInterfaceExec in Simulate.ReadSimulationOutput.run,
     EpicOutProcess.run, ScalarEpicOutProcess.run.

IMP: (9/7/09, AM) Remove JDBM, use com.sun.electric.tool.btree instead.

IMP: (9/7/09, AM) Check in first draft of com.sun.electric.tool.btree.

IMP: (9/6/09, DN) Rename MultiTaskJobLight to MultiTaskJob, remove old
     MultiTaskJob.

BUG: (9/3/09, JKG) bug 2351, logical effort had hard coded assumed values for
     gate widths and lengths of the X=1 inverter. Those changed for 40nm.
     They are now specifiable as logical effort settings

IMP: (9/3/09, GVG) Build.xml modified to unjar Jython and to include it into
     electric.jar (ant jar).  That is to run Scripting regression in batch mode
     (part of Bug #2358)

BUG: (9/3/09, DN) Command line "-batch -s script.bsh" executes script without any
     EditingPreferences (Bug #2373)
FIX: In Main.InitDatabase.doIt assign factory-default EditingPreferences.

BUG: (9/2/09, DN) DRCUpdate is not executed in MultiDRC regressins.
FIX: In "DRC.DRCUpdate()" use "startJobOnMyResult()" instead of "startJob()".

IMP: (9/2/09, DN) Better regression diagnostics.

IMP: (9/2/09, DN) Explicit UserInterface object for each thread.

IMP: (9/2/09, GVG) More changes to get Jython working in the regressions (Bug
     #2358)

IMP: (9/1/09, AM) Change name of ScalarSignal to NewSignal (it is no
     longer limited to scalar samples).

IMP: (9/1/09, AM) Parameterize ScalarSignal on arbitrary instances of
     SimulationSample.

IMP: (9/1/09, AM) Change "Recenter On Selection" to "(move) Cell
     Center to Center of Selection".

IMP: (9/1/09, AM) Renamed com.sun.electric.tool.user.Highlight2->Highlight.

IMP: (9/1/09, SMR) In explorer tree, the context command "Search" under
     "LIBRARIES" now has a more powerful dialog that does partial searches, shows
     results in the dialog, and lets the cells be edited (Bug #2322).

BUG: (9/1/09, SMR) Cannot use delete key in Text windows (Bug #2372).
FIX: Added recognition of TextWindow in KeyBindingManager.processKeyEvent().

IMP: (9/1/09, DN) ImmutableNodeInst.computeBounds doesn't require real NodeInst.

BUG: (8/31/09, SMR) Undo/Redo status is not updated during text editing (Bug
     #2361).
FIX: In TextWindow.updateUndoRedo(), call showUndoRedoStatus() and
     In Undo.updateUndoRedo(), do not call showUndoRedoStatus() if in a text
     cell.

IMP: (8/31/09, SMR) User's Manual search highlights search keys.

IMP: (8/30/09, AM) Right-align signal names in the waveform viewer,
     and truncate from the left when necessary.  When a signal name is
     very long due to being deep in the hierarchy, the *rightmost*
     part of the signal name is most useful to the user.

IMP: (8/30/09, AM) Add a menu item to Window->WaveformWindow for each
     icon button in the waveform window.  Aside from acting as
     documentation, this makes it possible for users to add a
     keystroke for those buttons.

IMP: (8/30/09, AM) Add Edit->Move->Recenter Cell on Selection.

BUG: (8/28/09, JKG) Stitch fill generator not keeping arc extension (Bug #2364)
FIX: InterativeRouter modified.

BUG: (8/28/09, AM) Pulsing error highlighting doesn't work on
     resolution/size DRC errors (Bug #2350).
FIX: In ErrorLogger, ensure that all error markers are logged with "thick" lines.

BUG: (8/28/09, DN) Array exception in stitch generator if cell is instantiated
     (Bug #2360)
FIX: In StitchFillJob.generateFill reload netlist after database modifications.

BUG: (8/27/09, JKG) Stitch fill generator connecting subcells with wrong arc (Bug
     #2362)
FIX: In InterativeRouter, Special contact code earlier so it would not be skipped
     in this case.

BUG: (8/27/09, DN) Pixel drawing algorithm not displaying LE result (Bug #2359)
FIX: In PixelDrawing.drawNode replace "varContext.pop();" by
     "varContext = varContext.pop();".

IMP: (8/26/09, SMR) Added "Tools / Languages / Run Jython Script..." (Bug
     #2358).

BUG: (8/25/09, SMR) Bipolar technology crashes (Bug #2332).
FIX: Changed the function of the PNJunction node to a CONNECT.

BUG: (8/25/09, GVG) Assertion in techs with PrimitiveNode with more than 1 port
     (Bug #2356)
FIX: Code generalized.

BUG: (8/24/09, SMR) Switching cells between icon and tech-edit does not update
     the style of the Artwork technology in the component menu (Bug #2355).
FIX: In WindowFrame.setCellWindow() call loadComponentMenuForTechnology().

BUG: (8/24/09, SMR) Converting schematic technology to library fails (Bug #2354).
FIX: Fix vector conversion and disable editing of noneditable technologies.

BUG: (8/22/09, AM) Annotation text not selectable in a certain situation (Bug
     #2352)
FIX: com.sun.electric.tool.user.Highlighter.findTextNow() must pass
     all text to EditWindow.setTextInCell(), THEN filter out the text
     that is not visible (rather than in the other order).

BUG: (8/19/09, DN) fill generator does not replace old versions of existing fill
     cells (Bug #2342).
FIX: In Cell.kill() remove all instances of killed Cell.
     In StitchFillJob.cleanReplacement copy all instances in a temporary list
     before starting modification.

************************* Version 8.10e: ******************************

IMP: (8/18/09, SMR) Added Placement tool.

BUG: (8/18/09, SMR) Moving diagonal arcs may break them (Bug #2341).
FIX: Special diagonal arc handling only used if Manhattan arcs connected
     to them are NOT selected.

BUG: (8/17/09, AM) Pulsating error highlighting causes 100% CPU usage
     (Bug #2348)
FIX: Use a javax.swing.Timer instead of repaint requests.

BUG: (8/17/09, GVG) Fill generator is not putting enough contacts in when
     connecting to cell instance (Bug #2340)
FIX: Adding nodes in SearchInHierarchy.

BUG: (8/17/09, SMR) If two arcs are in a line, meeting at an end (not sharing
     a pin, but each having their own pin, and the pins are coincident)
     then it is not possible to select the two arcs and use right-click
     to wire them.  Instead, all points are wired to (0,0) (Bug #2339).
FIX: In "InteractiveRouter.getIntersection()" the parallel but intersecting
     case is now handled.

IMP: (8/16/09, AM) Finished first round of performance tuning for
     BTree-based storage of simulation data.

BUG: (8/16/09, AM) Adjust CalibreDrcErrors so that a "CN" line applies
     to all the rest of the errors for that rule, rather than just the
     next error.  Jon Gainsley: please verify this! (Bug #2338).

IMP: (8/16/09, AM) Add pulsating error highlighting.  This is
     useful because using motion to direct the user's attention (rather
     than color) works with any color scheme.

IMP: (8/15/09, AM) Add "duplicate in place" option.  When this is
     enabled, the "duplicate" command will place the duplicated object
     exactly where the original was.  This is far more useful than the
     default behavior when you have layout geometry that needs to stay
     on a grid.

IMP: (8/12/09, AM) use BTree in ScalarEpicAnalysis.  It works.  But it
     is slow.

IMP: (8/11/09, AM) add JDBM-based implementation of BTree (temporary,
     just to get something working quickly).

